posterior<-function(list2,samp=TRUE){
  bl<-list2$bl 
  cruns<-list2$cruns
  SEPARATION<-list2$SEPARATION
  y<-list2$y
  design0<-list2$design0
  design<-design0[,-1]
  cBA<-list2$cBA
  
  data.to.block.ind<-c(1:(bl*2*cruns))
 
  if(bl>1){
    BA1<-c(cBA,list(nblocks=bl,y=y[data.to.block.ind],runs=cruns,
                    design0=design0[data.to.block.ind,],RESAMPLE=RESAMPLE))
    BA<-Bayesian.Analysis.update(BA1)
    update.mean<-BA$post.mean[bl+1,]
    # update.median<-BA$post.median[bl+1,]
    update.sd<-BA$post.sd[bl+1,]
    update.mean.p<-BA$p.post.mean[bl+1,]
    # update.sd.p<-BA$p.post.sd[bl+1,]
    # update.est<-"Discrete"
    update.post.prob<-BA$post.prob[bl+1,]
    
  }
  if(bl==1){
    ls<-list(nblocks=bl,y=y[data.to.block.ind],runs=cruns,
             design0=design0[data.to.block.ind,])
    BA<-Bayesian.Analysis.first(ls)
    update.mean<-BA$post.mean
    # update.median<-BA$post.median
    update.sd<-BA$post.sd
    update.mean.p<-BA$p.post.mean
    # update.sd.p<-BA$p.post.sd
    # update.est<-"Discrete"
    update.post.prob<-BA$post.prob
    
  }
  if(samp){
    cdf.b<-cumsum(BA$w[,ncol(BA$w)])
    ru<-runif(2*cruns,0,1)
    ind<-c()
    for(m in 1:(2*cruns))ind[m]<-min(which(cdf.b>ru[m]))
    
    if(BA$RESAMPLE)post.sample<-BA$b.prior.res[ind,]
    if(!BA$RESAMPLE)post.sample<-BA$b.prior[ind,]
  }
  #####################################################
  # }
  #####################################################
  if(!samp)post.sample<-"not requested"
  
  
  return(list(update.mean=update.mean,update.sd=update.sd,
              post.sample=post.sample,BA=BA,update.mean.p=update.mean.p,
              update.post.prob=update.post.prob))
  # update.median=update.median,update.est=update.est,
  # update.sd.p=update.sd.p
}



# A full Bayesian analysis of an executed experiment

Bayesian.Analysis.first<- function(ls){
  y<-ls$y
  runs<-ls$runs
  nblocks<-ls$nblocks
  design0<-ls$design0
  design<-design0[,-1]
  BREAK1<-FALSE
  LIK.0<-FALSE
  RESAMPLE<-FALSE
  RES<-FALSE
  
  w<-matrix(ncol=nblocks+1,nrow=n)
  b.prior<-mvrnorm(n, mu=mu, Sigma=cov_mtrx)
  post.mean<-matrix(ncol=K+1,nrow=nblocks+1)
  # post.median<-matrix(ncol=K+1,nrow=nblocks+1)
  post.sd<-matrix(ncol=K+1,nrow=nblocks+1)
  p.post.mean<-matrix(ncol=16,nrow=nblocks+1)
  # p.post.sd<-matrix(ncol=2^K,nrow=nblocks+1)
  post.prob<-matrix(ncol=K+1,nrow=nblocks+1)
  b.prior.res<-c()
  
  w[,1]<-rep(1/n,n)
  
  # phase 1  ____________________________________________________________
  
  for (j in 1:nblocks){
    for(i in 1:(K+1)){post.prob[j,i]<-sum(w[b.prior[,i]>0,j])} 
    post.mean[j,]<-apply(b.prior,2,wtd.mean,weights=w[,j],normwt=FALSE, na.rm=FALSE)      
    # sorted.b<-apply(b.prior,2,sort)
    # post.median[j,]<-sorted.b[n/2,]  
    p.post.mean[j,]<-apply(induced.ps(b.prior),2,wtd.mean,weights=w[,j],normwt=FALSE, na.rm=FALSE) 
    cov<-cov.wt(x=as.matrix(b.prior),wt=w[,j])$cov  
    post.sd[j,]<-sqrt(diag(cov))
    # cov.p<-cov.wt(x=as.matrix(induced.ps(b.prior)),wt=w[,j])$cov
    # p.post.sd[j,]<-sqrt(diag(cov.p))
    # setting the weights for next time:
    
    likli<-rep(NA,n)
    for (i in 1:n){
      likli[i]<-prod(pnorm(design0[((j-1)*2*runs+1):(j*2*runs),]%*%b.prior[i,])^y[((j-1)*2*runs+1):(j*2*runs)]*
                       (1-pnorm(design0[((j-1)*2*runs+1):(j*2*runs),]%*%b.prior[i,]))^(1-y[((j-1)*2*runs+1):(j*2*runs)]))}          
    w[,j+1]<-w[,j]*likli/sum(w[,j]*likli)
    
    if(sum((w[,j+1])^2)>=cutoff){tstop<-j+1;RESAMPLE<-TRUE;RES<-TRUE;rstop<-"concentration index is larger than cut-off";break}
    if(max(w[,j+1])>max.w){tstop<-j+1;RESAMPLE<-TRUE;RES<-TRUE;rstop<-"maximal weight exceeds threshold";break}
    if(sum(w[,j+1]==1)==1){tstop<-j+1;RESAMPLE<-TRUE;RES<-TRUE;rstop<-"all the weight is at one point";break}   
    
    tstop<-j+1
    rstop<-"reached maximum number of blocks"
  } # end of phase 1 
  
  STOP<-c()  
  STOP[1]<-tstop  
  if(tstop==nblocks+1 & !RES) {
    j<-tstop
    for(i in 1:(K+1)){post.prob[j,i]<-sum(w[b.prior[,i]>0,j])} 
    post.mean[j,]<-apply(b.prior,2,wtd.mean,weights=w[,j],normwt=FALSE, na.rm=FALSE)      
    # sorted.b<-apply(b.prior,2,sort)
    # post.median[j,]<-sorted.b[n/2,]  
    p.post.mean[j,]<-apply(induced.ps(b.prior),2,wtd.mean,weights=w[,j],normwt=FALSE, na.rm=FALSE) 
    cov<-cov.wt(x=as.matrix(b.prior),wt=w[,j])$cov  
    post.sd[j,]<-sqrt(diag(cov))
    # cov.p<-cov.wt(x=as.matrix(induced.ps(b.prior)),wt=w[,j])$cov
    # p.post.sd[j,]<-sqrt(diag(cov.p))
    BREAK1<-TRUE
  }
  if(tstop==nblocks+1 & RES){
    tstart=STOP[1]
    list<-list(
      tstart=tstart,
      mu.resample=post.mean[(tstart-1),],
      cov.resample=as.matrix(Diagonal(x=(post.sd[tstart-1,])^2)),
      Flag=FALSE,
      WARNING=FALSE,
      w.res=w[,tstart],
      a=rep(1,K+1),
      m=rep(0,K+1),
      count=0,
      y=y,
      LIK.0=LIK.0,
      runs=runs,
      design0=design0)
    
    resample1<-resample(list)
    
    b.prior.res<-resample1$b.prior.res    
    w[,tstart]<-resample1$w.res
    LIK.0<-resample1$LIK.0
    j<-tstart
    for(i in 1:(K+1)){post.prob[j,i]<-sum(w[b.prior.res[,i]>0,j])} 
    post.mean[j,]<-apply(b.prior.res,2,wtd.mean,weights=w[,j],normwt=FALSE, na.rm=FALSE)      
    # sorted.b<-apply(b.prior.res,2,sort)
    # post.median[j,]<-sorted.b[n/2,]  
    p.post.mean[j,]<-apply(induced.ps(b.prior.res),2,wtd.mean,weights=w[,j],normwt=FALSE, na.rm=FALSE) 
    cov<-cov.wt(x=as.matrix(b.prior.res),wt=w[,j])$cov  
    post.sd[j,]<-sqrt(diag(cov))
    # cov.p<-cov.wt(x=as.matrix(induced.ps(b.prior.res)),wt=w[,j])$cov
    # p.post.sd[j,]<-sqrt(diag(cov.p))
    BREAK1<-TRUE
  }
  
  # phase 2  ____________________________________________________________
  
  if(!BREAK1){  
    
    for(u in 1:100){
      tstart=STOP[u]
      list<-list(
        tstart=tstart,
        mu.resample=post.mean[(tstart-1),],
        cov.resample=as.matrix(Diagonal(x=(post.sd[tstart-1,])^2)),
        Flag=FALSE,
        WARNING=FALSE,
        w.res=w[,tstart],
        a=rep(1,K+1),
        m=rep(0,K+1),
        count=0,
        y=y,
        LIK.0=LIK.0,
        runs=runs,
        design0=design0)
      resample1<-resample(list)
      
      b.prior.res<-resample1$b.prior.res    
      w[,tstart]<-resample1$w.res
      RES<-FALSE
      
      for (j in tstart:nblocks){
        for(i in 1:(K+1)){post.prob[j,i]<-sum(w[b.prior.res[,i]>0,j])} 
        post.mean[j,]<-apply(b.prior.res,2,wtd.mean,weights=w[,j],normwt=FALSE, na.rm=FALSE)      
        # sorted.b<-apply(b.prior.res,2,sort)
        # post.median[j,]<-sorted.b[n/2,]  
        p.post.mean[j,]<-apply(induced.ps(b.prior.res),2,wtd.mean,weights=w[,j],normwt=FALSE, na.rm=FALSE) 
        cov<-cov.wt(x=as.matrix(b.prior.res),wt=w[,j])$cov  
        post.sd[j,]<-sqrt(diag(cov))
        # cov.p<-cov.wt(x=as.matrix(induced.ps(b.prior.res)),wt=w[,j])$cov
        # p.post.sd[j,]<-sqrt(diag(cov.p))
        
        # setting the weights for next time:
        
        likli<-c()
        for (i in 1:n){
          likli[i]<-prod(pnorm(design0[((j-1)*2*runs+1):(j*2*runs),]%*%b.prior.res[i,])^y[((j-1)*2*runs+1):(j*2*runs)]*
                           (1-pnorm(design0[((j-1)*2*runs+1):(j*2*runs),]%*%b.prior.res[i,]))^(1-y[((j-1)*2*runs+1):(j*2*runs)]))}          
        w[,j+1]<-w[,j]*likli/sum(w[,j]*likli)
        #       }
        
        if(sum((w[,j+1])^2)>=cutoff){tstop<-j+1;RES<-TRUE;rstop<-"concentration index is larger than cut-off";break}
        if(max(w[,j+1])>max.w){tstop<-j+1;RES<-TRUE;rstop<-"maximal weight exceeds threshold";break}
        if(sum(w[,j+1]==1)==1){tstop<-j+1;RES<-TRUE;rstop<-"all the weight is at one point";break}   
        
        tstop<-j+1
        rstop<-"reached maximum number of blocks"
      } #end of loop phase 2
      (STOP[u+1]<-tstop)
      
      if(tstop==nblocks+1 & !RES) {
        j<-tstop
        for(i in 1:(K+1)){post.prob[j,i]<-sum(w[b.prior.res[,i]>0,j])} 
        post.mean[j,]<-apply(b.prior.res,2,wtd.mean,weights=w[,j],normwt=FALSE, na.rm=FALSE)      
        # sorted.b<-apply(b.prior.res,2,sort)
        # post.median[j,]<-sorted.b[n/2,]  
        p.post.mean[j,]<-apply(induced.ps(b.prior.res),2,wtd.mean,weights=w[,j],normwt=FALSE, na.rm=FALSE) 
        cov<-cov.wt(x=as.matrix(b.prior.res),wt=w[,j])$cov  
        post.sd[j,]<-sqrt(diag(cov))
        # cov.p<-cov.wt(x=as.matrix(induced.ps(b.prior.res)),wt=w[,j])$cov
        # p.post.sd[j,]<-sqrt(diag(cov.p))
        break
      }
      if(tstop==nblocks+1 & RES){
        tstart<-STOP[u+1]
        list<-list(
          tstart=tstart,
          mu.resample=post.mean[(tstart-1),],
          cov.resample=as.matrix(Diagonal(x=(post.sd[tstart-1,])^2)),
          Flag=FALSE,
          WARNING=FALSE,
          w.res=w[,tstart],
          a=rep(1,K+1),
          m=rep(0,K+1),
          count=0,
          y=y,
          LIK.0=LIK.0,
          runs=runs,
          design0=design0)
        
        resample1<-resample(list)
        
        b.prior.res<-resample1$b.prior.res    
        w[,tstart]<-resample1$w.res
        j<-tstart
        for(i in 1:(K+1)){post.prob[j,i]<-sum(w[b.prior.res[,i]>0,j])} 
        post.mean[j,]<-apply(b.prior.res,2,wtd.mean,weights=w[,j],normwt=FALSE, na.rm=FALSE)      
        # sorted.b<-apply(b.prior.res,2,sort)
        # post.median[j,]<-sorted.b[n/2,]  
        p.post.mean[j,]<-apply(induced.ps(b.prior.res),2,wtd.mean,weights=w[,j],normwt=FALSE, na.rm=FALSE) 
        cov<-cov.wt(x=as.matrix(b.prior.res),wt=w[,j])$cov  
        post.sd[j,]<-sqrt(diag(cov))
        # cov.p<-cov.wt(x=as.matrix(induced.ps(b.prior.res)),wt=w[,j])$cov
        # p.post.sd[j,]<-sqrt(diag(cov.p))
        break
      }
    }
  }
  return(list(w=w,post.mean=post.mean,post.sd=post.sd,
              b.prior=b.prior,b.prior.res=b.prior.res,p.post.mean=p.post.mean,
              RESAMPLE=RESAMPLE,LIK.0=LIK.0,post.prob=post.prob))
  
  # post.median=post.median,p.post.sd=p.post.sd
  
}

# Bayesian analysis one block update

Bayesian.Analysis.update<- function(BA1){
  y<-BA1$y
  runs<-BA1$runs
  nblocks<-BA1$nblocks
  design0<-BA1$design0
  design<-design0[,-1]
  LIK.0<-BA1$LIK.0
  RESAMPLE<-BA1$RESAMPLE
  RES<-FALSE
  w<-cbind(BA1$w,rep(NA,n))
  b.prior<-BA1$b.prior
  b.prior.res<-BA1$b.prior.res
  post.mean<-rbind(BA1$post.mean,rep(NA,K+1))
  # post.median<-rbind(BA1$post.median,rep(NA,K+1))
  post.sd<-rbind(BA1$post.sd,rep(NA,K+1))
  p.post.mean<-rbind(BA1$p.post.mean,rep(NA,16))
  # p.post.sd<-rbind(BA1$p.post.sd,rep(NA,2^K))
  post.prob<-rbind(BA1$post.prob,rep(NA,K+1))
  
  if(RESAMPLE){
    RES<-FALSE
    j<-nblocks  
    likli<-c()
    for (i in 1:n){
      likli[i]<-prod(pnorm(design0[((j-1)*2*runs+1):(j*2*runs),]%*%b.prior.res[i,])^y[((j-1)*2*runs+1):(j*2*runs)]*
                       (1-pnorm(design0[((j-1)*2*runs+1):(j*2*runs),]%*%b.prior.res[i,]))^(1-y[((j-1)*2*runs+1):(j*2*runs)]))}          
    
    w[,j+1]<-w[,j]*likli/sum(w[,j]*likli)
    
    
    if(sum((w[,j+1])^2)>=cutoff){tstop<-j+1;RES<-TRUE;rstop<-"concentration index is larger than cut-off"}
    if(max(w[,j+1])>max.w){tstop<-j+1;RES<-TRUE;rstop<-"maximal weight exceeds threshold"}
    if(sum(w[,j+1]==1)==1){tstop<-j+1;RES<-TRUE;rstop<-"all the weight is at one point"}   
    
    if(!RES){
      j<-nblocks+1
      for(i in 1:(K+1)){post.prob[j,i]<-sum(w[b.prior.res[,i]>0,j])} 
      post.mean[j,]<-apply(b.prior.res,2,wtd.mean,weights=w[,j],normwt=FALSE, na.rm=FALSE)      
      # sorted.b<-apply(b.prior.res,2,sort)
      # post.median[j,]<-sorted.b[n/2,]  
      p.post.mean[j,]<-apply(induced.ps(b.prior.res),2,wtd.mean,weights=w[,j],normwt=FALSE, na.rm=FALSE) 
      cov<-cov.wt(x=as.matrix(b.prior.res),wt=w[,j])$cov  
      post.sd[j,]<-sqrt(diag(cov))
      # cov.p<-cov.wt(x=as.matrix(induced.ps(b.prior.res)),wt=w[,j])$cov
      # p.post.sd[j,]<-sqrt(diag(cov.p))
    }
    if(RES){
      tstart<-nblocks+1
      list<-list(
        tstart=tstart,
        mu.resample=post.mean[(tstart-1),],
        cov.resample=as.matrix(Diagonal(x=(post.sd[tstart-1,])^2)),
        Flag=FALSE,
        WARNING=FALSE,
        w.res=w[,tstart],
        a=rep(1,K+1),
        m=rep(0,K+1),
        count=0,
        y=y,
        LIK.0=LIK.0,
        runs=runs,
        design0=design0)
      
      resample1<-resample(list)
      
      b.prior.res<-resample1$b.prior.res    
      w[,tstart]<-resample1$w.res
      LIK.0<-resample1$LIK.0
      j<-tstart
      for(i in 1:(K+1)){post.prob[j,i]<-sum(w[b.prior.res[,i]>0,j])} 
      post.mean[j,]<-apply(b.prior.res,2,wtd.mean,weights=w[,j],normwt=FALSE, na.rm=FALSE)      
      # sorted.b<-apply(b.prior.res,2,sort)
      # post.median[j,]<-sorted.b[n/2,]  
      p.post.mean[j,]<-apply(induced.ps(b.prior.res),2,wtd.mean,weights=w[,j],normwt=FALSE, na.rm=FALSE) 
      cov<-cov.wt(x=as.matrix(b.prior.res),wt=w[,j])$cov  
      post.sd[j,]<-sqrt(diag(cov))
      # cov.p<-cov.wt(x=as.matrix(induced.ps(b.prior.res)),wt=w[,j])$cov
      # p.post.sd[j,]<-sqrt(diag(cov.p))
    }
  }
  
  if(!RESAMPLE){
    RES<-FALSE
    j<-nblocks  
    likli<-c()
    for (i in 1:n){
      likli[i]<-prod(pnorm(design0[((j-1)*2*runs+1):(j*2*runs),]%*%b.prior[i,])^y[((j-1)*2*runs+1):(j*2*runs)]*
                       (1-pnorm(design0[((j-1)*2*runs+1):(j*2*runs),]%*%b.prior[i,]))^(1-y[((j-1)*2*runs+1):(j*2*runs)]))}          
    w[,j+1]<-w[,j]*likli/sum(w[,j]*likli)
    
    
    if(sum((w[,j+1])^2)>=cutoff){tstop<-j+1;RES<-TRUE;rstop<-"concentration index is larger than cut-off"}
    if(max(w[,j+1])>max.w){tstop<-j+1;RES<-TRUE;rstop<-"maximal weight exceeds threshold"}
    if(sum(w[,j+1]==1)==1){tstop<-j+1;RES<-TRUE;rstop<-"all the weight is at one point"}   
    
    if(!RES) {
      j<-nblocks+1
      for(i in 1:(K+1)){post.prob[j,i]<-sum(w[b.prior[,i]>0,j])} 
      post.mean[j,]<-apply(b.prior,2,wtd.mean,weights=w[,j],normwt=FALSE, na.rm=FALSE)      
      # sorted.b<-apply(b.prior,2,sort)
      # post.median[j,]<-sorted.b[n/2,]  
      p.post.mean[j,]<-apply(induced.ps(b.prior),2,wtd.mean,weights=w[,j],normwt=FALSE, na.rm=FALSE) 
      cov<-cov.wt(x=as.matrix(b.prior),wt=w[,j])$cov  
      post.sd[j,]<-sqrt(diag(cov))
      # cov.p<-cov.wt(x=as.matrix(induced.ps(b.prior)),wt=w[,j])$cov
      # p.post.sd[j,]<-sqrt(diag(cov.p))
      
    }
    if(RES){
      RESAMPLE<-TRUE
      tstart<-nblocks+1
      list<-list(
        tstart=tstart,
        mu.resample=post.mean[(tstart-1),],
        cov.resample=as.matrix(Diagonal(x=(post.sd[tstart-1,])^2)),
        Flag=FALSE,
        WARNING=FALSE,
        w.res=w[,tstart],
        a=rep(1,K+1),
        m=rep(0,K+1),
        count=0,
        y=y,
        LIK.0=LIK.0,
        runs=runs,
        design0=design0)
      
      resample1<-resample(list)
      
      b.prior.res<-resample1$b.prior.res    
      w[,tstart]<-resample1$w.res
      LIK.0<-resample1$LIK.0
      j<-tstart
      for(i in 1:(K+1)){post.prob[j,i]<-sum(w[b.prior.res[,i]>0,j])} 
      post.mean[j,]<-apply(b.prior.res,2,wtd.mean,weights=w[,j],normwt=FALSE, na.rm=FALSE)      
      # sorted.b<-apply(b.prior.res,2,sort)
      # post.median[j,]<-sorted.b[n/2,]  
      p.post.mean[j,]<-apply(induced.ps(b.prior.res),2,wtd.mean,weights=w[,j],normwt=FALSE, na.rm=FALSE) 
      cov<-cov.wt(x=as.matrix(b.prior.res),wt=w[,j])$cov  
      post.sd[j,]<-sqrt(diag(cov))
      # cov.p<-cov.wt(x=as.matrix(induced.ps(b.prior.res)),wt=w[,j])$cov
      # p.post.sd[j,]<-sqrt(diag(cov.p))
    }
  }
  
  
  return(list(w=w,post.mean=post.mean,post.sd=post.sd,
              b.prior=b.prior,b.prior.res=b.prior.res,p.post.mean=p.post.mean,
              RESAMPLE=RESAMPLE,LIK.0=LIK.0,post.prob=post.prob))
  # post.median=post.median,p.post.sd=p.post.sd
  
}


induced.ps<-function(b.sample){
  K <- 4
  full.design0<-matrix(ncol=K+1,nrow=2^K) 
  full.design0[,1]<-rep(1,2^K)
  for(i in 1:K){
    xx<-c(rep(1,2^(K-i)),rep(-1,2^(K-i)))
    full.design0[,i+1]<-rep(xx,2^(i-1))
  }
  ps.mat<-pnorm(t(full.design0%*%t(b.sample[,c(1,8:11)])))
  return(ps.mat)
}