FFD<-function(l,start.block){
  pv.mat<-l$pv.mat
  correction.strong<-l$correction.strong
  Thompson.strong<-l$Thompson.strong
  start.Thompson<-l$start.Thompson
  design<-l$design
  k<-K
  f<-F
  y<-l$y
  ind.strong<-l$ind.strong  
  k1<-0
  f1<-0
  post.mean.temp<-l$post.mean.temp
  post.median.temp<-l$post.median.temp
  post.sd.temp<-l$post.sd.temp
  p.post.mean.temp<-l$p.post.mean.temp
  p.post.sd.temp<-l$p.post.sd.temp
  est.form.temp<-l$est.form.temp
  pv.temp <- l$pv.temp
  SEPARATION<-l$SEPARATION
  cBA<-l$cBA
  post.sample<-l$post.sample
  spike.weight<-l$spike.weight 
  post.prob.temp<-l$post.prob.temp
  
  cruns<-2^(k-f)
  cnblocks<-max(2^(f-1),1)
  crep<-ceiling((max.blocks-start.Thompson)/cnblocks)
  cblocks<-array(NA,dim=c(2*cnblocks,2*cruns,k))
  
  if(f>0){
    dup<-1       
    x.def<-relations.def(k,f)
    base.design<-x.def[1:cruns,1:(k-f)] # full 2^(k-f) design matrix
    full.design0<-matrix(ncol=k+1,nrow=2^K) 
    full.design0[,1]<-rep(1,2^k)
    for(i in 1:k){
      xx<-c(rep(1,2^(k-i)),rep(-1,2^(k-i)))
      full.design0[,i+1]<-rep(xx,2^(i-1))
    }
    
    full.design<-full.design0[,-1]   # without intercept
    
    gen.signs<-matrix(nrow=2^f,ncol=f)
    for(i in 1:f){
      xx<-c(rep(1,2^(f-i)),rep(-1,2^(f-i)))
      gen.signs[,i]<-rep(xx,2^(i-1))
    }
    
   for(h in 1:(2*cnblocks)){
      cblocks[h,,]<-generator(gen.signs[h,],k,f,cruns,base.design,x=x.def)
    }
    
    if (!is.foldover(cblocks[1,1:cruns,])){
      #ind<-find.dual.block(blocks,full.design) # it takes a few minutes to run 
      if(k==10 & f==6){ind<-IND.10.6}
      if(k==9 & f==5){ind<-IND.9.5}
      if(k==5 & f==1){ind<-cbind(c(1,1),c(2,2))}
      cblocks<-cblocks[ind[,1],,]
    }
    
    if (is.foldover(cblocks[1,1:cruns,])){
      half.blocks<-array(NA,dim=c(2*cnblocks,cruns,k))
      for(h in 1:(2*cnblocks)){
        half.blocks[h,,]<-generator.without.foldover(gen.signs[h,],k,f,cruns,base.design,x=x.def)
      }
      ind<-sample(2*cnblocks)
      for (h in 1:cnblocks){
        cblocks[h,,]<-rbind(half.blocks[ind[h],,],half.blocks[ind[2*cnblocks-h+1],,])
      }
    }
  }
  if(f<=0){
    full.design0<-matrix(ncol=k+1,nrow=2^k) 
    full.design0[,1]<-rep(1,2^k)
    for(i in 1:k){
      xx<-c(rep(1,2^(k-i)),rep(-1,2^(k-i)))
      full.design0[,i+1]<-rep(xx,2^(i-1))
    }
    full.design<-full.design0[,-1]
    dup<-2*cruns/2^k
    temp.block<-c()
    for(d in 1:dup){
      temp.block<-rbind(temp.block,full.design)
    }
    cblocks[1,,]<-cblocks[2,,]<-temp.block
  }
  
  # Add the design with rep replications:
  temp.list<-c(l,list(f=f,k=k,blocks=cblocks,nblocks=cnblocks,rep=crep,runs=cruns))
  design1<-form.design(temp.list)$design
  design<-rbind(l$design,design1)
  design0<-cbind(rep(1,nrow(design)),design) # with intercept
  
  p<-pnorm(design0%*%b)
  if(start.block==1)add.p<-p[1:nrow(design)]
  if(start.block!=1)add.p<-p[(nrow(l$design)+1):nrow(design)]
  add.y<-rbinom(length(add.p),1,add.p)
  if(start.block==1)y[1:nrow(design)]<-add.y
  if(start.block!=1)y[(nrow(l$design)+1):nrow(design)]<-add.y
  

  # After every block, decide if there are strong factors
  # and update posterior mean and s.d

  pv.mat<-rbind(l$pv.mat,rep(NA,K)) # blocks,factors
  correction.strong<-rbind(l$correction.strong,rep(FALSE,K))# blocks,factors

  # after 1st block:
  if(start.block==1){
    start.loop<-2
    bl<-1
    all.data.to.block<-c(1:(bl*2*cruns))
    cdesign<-design[all.data.to.block,]
    colnames(cdesign)<-paste0("x", 1:K)
    relevant.vars<-paste0("x", 1:K)
    cy<-y[all.data.to.block]
    cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
    data1<-as.data.frame(cbind(cy,cdesign))
    colnames(data1)<-c("y",paste0("x", 1:K))
    # glm(cfmula,data=data1,family = binomial(link = "probit"))
    fit<-reg.fit.possible(data=data1,fmula=cfmula)
    SEPARATION<-fit$error | fit$warnings | sum(cy)==0 #for the posterior mean and s.d at the end of this block
    
    sep<-rep(NA,K)
    for(j in 1:K){
      relevant.vars<-paste0("x", j)
      cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
      data1<-as.data.frame(cbind(cy,cdesign))
      colnames(data1)<-c("y",paste0("x", 1:K))
      # glm(cfmula,data=data1,family = binomial(link = "probit"))
      fit<-reg.fit.possible(data=data1,fmula=cfmula)
      sep[j]<-fit$error | fit$warnings
    }
    
    list2<-list(spike.weight=spike.weight,bl=bl,cruns=cruns,SEPARATION=SEPARATION,y=y,design0=design0)   
    if(!SPIKESLAB)update<-posterior(list2,samp=FALSE) # BA first
    if(SPIKESLAB)update<-posterior.spike.slab(list2,samp=FALSE) # BA first
    
    post.mean.temp[1:2,]<-update$update.mean
    post.median.temp[1:2,]<-update$update.median
    post.sd.temp[1:2,]<-update$update.sd
    p.post.mean.temp[1:2,]<-update$update.mean.p
    p.post.sd.temp[1:2,]<-update$update.sd.p
    est.form.temp[1:2]<-update$update.est
    post.prob.temp[1:2,]<-update$update.post.prob
    cBA<-update$BA
    if(SPIKESLAB) spike.weight<-update$spike.weight
    
    if(sum(y[1:(bl*2*cruns)])==0){
      pv.mat[1,]<-rep(1,k)
      pv.temp[bl,]<-rep(1,k)
      }
    if(sum(y[1:(bl*2*cruns)])>0){
      for(j in 1:k){
        if(sep[j]){
          ft<-fisher.test(cdesign[,j],cy)
          pv.mat[1,j]<-ft$p.value}
        if(!sep[j]){
          ft<-fisher.test(cdesign[,j],cy)
          g<-glm(cy~cdesign[,j],family=binomial(link="probit"))  
          pv.mat[1,j]<-min(ft$p.value,coef(summary(g))[2,4])
          }
    }
    correction.strong[1,which(pv.mat[1,]<correction.threshold)]=TRUE
    Thompson.strong[1,which(pv.mat[1,]<Thompson.threshold)]=TRUE
    pv.temp[bl,]<-pv.mat[1,]
    }
  }
  if(start.block>1) start.loop<-start.block
  
  # next blocks:
  BREAK<-FALSE
  for (bl in start.loop:max.blocks){
    all.data.to.block<-c(1:(bl*2*cruns))
    cdesign<-design[all.data.to.block,]
    colnames(cdesign)<-paste0("x", 1:K)
    relevant.vars<-paste0("x", 1:K)
    cy<-y[all.data.to.block]
    sum(cy)
    cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
    data1<-as.data.frame(cbind(cy,cdesign))
    colnames(data1)<-c("y",paste0("x", 1:K))
    # glm(cfmula,data=data1,family = binomial(link = "probit"))
    fit<-reg.fit.possible(data=data1,fmula=cfmula)
    SEPARATION<-fit$error | fit$warnings | sum(cy)==0 # for the posterior mean and s.d at the end of this block
    
    sep<-rep(NA,K)
    for(j in 1:K){
      relevant.vars<-paste0("x", j)
      cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
      data1<-as.data.frame(cbind(cy,cdesign))
      colnames(data1)<-c("y",paste0("x", 1:K))
      # glm(cfmula,data=data1,family = binomial(link = "probit"))
      fit<-reg.fit.possible(data=data1,fmula=cfmula)
      sep[j]<-fit$error | fit$warnings
    }
    
    if(sum(cy)==0){
      pv.mat[2,]<-rep(1,k)
      pv.temp[bl,]<-rep(1,k)
    }
    if(sum(cy)>0){
      
        if (!(any(correction.strong[1,]))&!BREAK){
        for(j in 1:k){
          if(sep[j]){
            ft<-fisher.test(cdesign[,j],cy)
            pv.mat[2,j]<-ft$p.value}
          if(!sep[j]){
            ft<-fisher.test(design[all.data.to.block,j],y[all.data.to.block])
            g<-glm(cy~cdesign[,j],family=binomial(link="probit"))  
            pv.mat[2,j]<-min(ft$p.value,coef(summary(g))[2,4])}
        }
      }
      if (any(correction.strong[1,])&!BREAK){   
        index.strong<-which(correction.strong[1,])
        for (s in c(1:K)[-index.strong]){
          relevant.vars<-paste0("x", c(s,index.strong))
          cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
          data1<-as.data.frame(cbind(cy,cdesign))
          colnames(data1)<-c("y",paste0("x", 1:K))
          # glm(cfmula,data=data1,family = binomial(link = "probit"))
          fit<-reg.fit.possible(data=data1,fmula=cfmula)
          
          if(fit$error | fit$warnings){ # if a model *cannot* be fitted
            if(length(index.strong)>1){
              comb<-unique(cdesign[which(cy==1),index.strong])
              if(is.vector(comb))comb.ind<-find.all.rows(comb,cdesign[,index.strong])$ind
              if(is.matrix(comb)){
                comb.ind<-c()
                for(u in seq(nrow(comb))){
                  comb.ind<-sort(c(comb.ind,find.all.rows(comb[u,],cdesign[,index.strong])$ind))
                }
              }
              ft<-fisher.test(cy[comb.ind],cdesign[comb.ind,s])
              pv.mat[2,s]<-ft$p.value
            }
            if(length(index.strong)==1){
              comb<-unique(design[(which(cy==1)),index.strong])
              if(length(comb)==2){
                ft<-fisher.test(cy,cdesign[,s])
                pv.mat[2,s]<-ft$p.value
              }
              if(length(comb)==1){
                comb.ind<-which(cdesign[,index.strong]==comb)
                ft<-fisher.test(cy[comb.ind],cdesign[comb.ind,s])
                pv.mat[2,s]<-ft$p.value
              }
            }
          }
          if(!(fit$error | fit$warnings)){ # if a model *can* be fitted
            g<-glm(cfmula,data=data1,family=binomial(link="probit"),separation = "test")
            pv.mat[2,s]<-coef(summary(g))[2,4]
          }
        } # end of p.v for non-strong factors
        
        if (length(index.strong)==1){
          s<-index.strong
          if(sep[s]){
            ft<-fisher.test(cdesign[,s],cy)
            pv.mat[2,s]<-ft$p.value}
          if(!sep[s]){
            ft<-fisher.test(cdesign[,s],cy)
            g<-glm(cy~cdesign[,s],family=binomial(link="probit"))  
            pv.mat[2,s]<-min(ft$p.value,coef(summary(g))[2,4])}            
        }
        if (length(index.strong)>1){
          relevant.vars<-paste0("x", index.strong)
          cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
          data1<-as.data.frame(cbind(cy,cdesign))
          colnames(data1)<-c("y",paste0("x", 1:K))
          # glm(cfmula,data=data1,family = binomial(link = "probit"))
          fit<-reg.fit.possible(data=data1,fmula=cfmula)
          fit.possible<-!(fit$error | fit$warnings)
          if (fit.possible){
            g<-glm(cy~cdesign[,index.strong],family=binomial(link="probit"))
            pv.mat[2,index.strong]<-coef(summary(g))[-1,4]
          }
          if (!fit.possible){
            for (s in index.strong){
              index.strong.without.s<-setdiff(index.strong,c(s))
              comb<-unique(design[(which(cy==1)),index.strong.without.s])
              if(is.vector(comb))comb.ind<-find.all.rows(comb,cdesign[,index.strong.without.s])$ind
              if(is.matrix(comb)){
                comb.ind<-c()
                for(u in seq(nrow(comb))){
                  comb.ind<-sort(c(comb.ind,find.all.rows(comb[u,],cdesign[,index.strong.without.s])$ind))
                }
              }
              if(length(unique(cdesign[comb.ind,s]))==1)pv1<-NA
              if(length(unique(cdesign[comb.ind,s]))==2)pv1<-fisher.test(cy[comb.ind],cdesign[comb.ind,s])$p.value
              pv2<-fisher.test(cy,cdesign[,s])$p.value
              cfmula <- as.formula(paste("y ~ ",paste0("x", s)))
              fit<-reg.fit.possible(data=data1,fmula=cfmula)
              fit.possible<-!(fit$error|fit$warnings)
              pv3<-ifelse(fit.possible,coef(summary(fit$g))[2,4],NA)
              pv.mat[2,s]<-min(na.omit(c(pv1,pv2,pv3)))
              #pv.comp[s,bl,]<-c(pv1,pv2,pv3)
            }
          }
        }
      }
    }
    correction.strong[2,which(pv.mat[2,]<correction.threshold)]<-TRUE
    correction.strong[2,which(pv.mat[2,]>correction.threshold)]<-FALSE
    Thompson.strong[bl,which(pv.mat[2,]<Thompson.threshold)]<-TRUE
    pv.temp[bl,]<-pv.mat[2,]
    pv.mat[1,]<-pv.mat[2,]
    correction.strong[1,]<-correction.strong[2,]
    
    # Check if any factor is strong and update mean and sd
    
    if (all(!Thompson.strong[bl,])){
      list2<-list(spike.weight=spike.weight,bl=bl,cruns=cruns,SEPARATION=SEPARATION,y=y,
                  design0=design0,cBA=cBA)   
      if(!SPIKESLAB)update<-posterior(list2,samp=FALSE) # BA first
      if(SPIKESLAB)update<-posterior.spike.slab(list2,samp=FALSE) # BA first
      post.mean.temp[bl+1,]<-update$update.mean
      post.median.temp[bl+1,]<-update$update.median
      post.sd.temp[bl+1,]<-update$update.sd
      p.post.mean.temp[bl+1,]<-update$update.mean.p
      p.post.sd.temp[bl+1,]<-update$update.sd.p
      est.form.temp[bl+1]<-update$update.est
      post.prob.temp[bl+1,]<-update$update.post.prob
      cBA<-update$BA
      if(SPIKESLAB) spike.weight<-update$spike.weight
    }
    if (any(Thompson.strong[bl,])){
      list2<-list(spike.weight=spike.weight,bl=bl,cruns=cruns,SEPARATION=SEPARATION,y=y,
                  design0=design0,cBA=cBA)   
      if(!SPIKESLAB)update<-posterior(list2,samp=TRUE) # BA first
      if(SPIKESLAB)update<-posterior.spike.slab(list2,samp=TRUE) # BA first
      post.mean.temp[bl+1,]<-update$update.mean
      post.median.temp[bl+1,]<-update$update.median
      post.sd.temp[bl+1,]<-update$update.sd
      p.post.mean.temp[bl+1,]<-update$update.mean.p
      p.post.sd.temp[bl+1,]<-update$update.sd.p
      est.form.temp[bl+1]<-update$update.est
      post.prob.temp[bl+1,]<-update$update.post.prob
      cBA<-update$BA
      post.sample<-update$post.sample
      if(SPIKESLAB)spike.weight<-update$spike.weight
      
      start.Thompson<-bl
      RSTOP<-c()
      ind.strong<-c()
      for(j in 1:k){
        if(Thompson.strong[bl,j]){
          ind.strong<-c(ind.strong,j)
          RSTOP<-cbind(RSTOP,c(bl,j,"in"))}
      }
      BREAK<-TRUE
      break}
  }
  if(bl==max.blocks){
    RSTOP<-c(bl,NA,"end")
    start.Thompson<-bl
    BREAK<-TRUE}
  if(BREAK) {
    y<-y[1:(start.Thompson*2*cruns)]
    pv.mat<-pv.mat[2,]
    correction.strong<-correction.strong[2,]
    design<-design[1:(start.Thompson*2*cruns),] 
    design0<-cbind(rep(1,nrow(design)),design)
    p<-pnorm(design0%*%b)
  }
  
  return(list(pv.mat=pv.mat,correction.strong=correction.strong,Thompson.strong=Thompson.strong,
              design=design,RSTOP=RSTOP,p=p,y=y,k1=k1,f1=f1,
              start.Thompson=start.Thompson,ind.strong=ind.strong,
              post.mean.temp=post.mean.temp,post.median.temp=post.median.temp,post.sd.temp=post.sd.temp,
              est.form.temp=est.form.temp,cBA=cBA,spike.weight=spike.weight,
              SEPARATION=SEPARATION,post.sample=post.sample,
              post.prob.temp=post.prob.temp,
              p.post.mean.temp=p.post.mean.temp,
              p.post.sd.temp=p.post.sd.temp,pv.temp=pv.temp))
}

FFD.T<-function(l,start.Thompson){
  pv.mat<-l$pv.mat
  correction.strong<-l$correction.strong
  Thompson.strong<-l$Thompson.strong
  start.Thompson<-l$start.Thompson
  design<-l$design
  k1<-l$k1
  f1<-l$f1
  k<-l$k
  f<-l$f
  y<-l$y
  ind.strong<-l$ind.strong
  cBA<-l$cBA
  post.sample<-l$post.sample
  post.mean.temp<-l$post.mean.temp
  post.median.temp<-l$post.median.temp
  post.sd.temp<-l$post.sd.temp
  p.post.mean.temp<-l$p.post.mean.temp
  p.post.sd.temp<-l$p.post.sd.temp
  est.form.temp<-l$est.form.temp
  pv.temp<-l$pv.temp
  SEPARATION<-l$SEPARATION
  spike.weight<-l$spike.weight
  post.prob.temp<-l$post.prob.temp
  
  
  cruns<-2^(k1-f1)
  cnblocks<-max(2^(f1-1),1)
  crep<-ceiling((max.blocks-start.Thompson)/cnblocks)
  cblocks<-array(NA,dim=c(2*cnblocks,2*cruns,k1))
  
  if(f1>0){
    dup<-1
    x.def<-relations.def(k1,f1)
    base.design<-x.def[1:cruns,1:(k1-f1)] 
    # full 2^(k1-f1) design matrix
    full.design0<-matrix(ncol=k1+1,nrow=2^k1) 
    full.design0[,1]<-rep(1,2^k1)
    for(i in 1:k1){
      xx<-c(rep(1,2^(k1-i)),rep(-1,2^(k1-i)))
      full.design0[,i+1]<-rep(xx,2^(i-1))
    }
    
    full.design<-full.design0[,-1]   # without intercept
    
    gen.signs<-matrix(nrow=2^f1,ncol=f1)
    for(i in 1:f1){
      xx<-c(rep(1,2^(f1-i)),rep(-1,2^(f1-i)))
      gen.signs[,i]<-rep(xx,2^(i-1))
    } 
    
    for(h in 1:(2*cnblocks)){
      cblocks[h,,]<-generator(gen.signs[h,],k1,f1,cruns,base.design,x=x.def)
    }
    if (!is.foldover(cblocks[1,1:cruns,])){
      #ind<-find.dual.block(blocks,full.design)} # it takes a few minutes to run 
      if(k==10 & f==6){ind<-IND.10.6}
      if(k==9 & f==5){ind<-IND.9.5}
      if(k==5 & f==1){ind<-cbind(c(1,1),c(2,2))}
    cblocks<-cblocks[ind[,1],,]
    }
    if (is.foldover(cblocks[1,1:cruns,])){
      half.blocks<-array(NA,dim=c(2*cnblocks,cruns,k1))
      for(h in 1:(2*cnblocks)){
        half.blocks[h,,]<-generator.without.foldover(gen.signs[h,],k1,f1,cruns,base.design,x=x.def)
      }
      ind<-sample(2*cnblocks)
      for (h in 1:cnblocks){
        cblocks[h,,]<-rbind(half.blocks[ind[h],,],half.blocks[ind[2*cnblocks-h+1],,])
      }
    }
    temp.list<-list(k=l$k1,f=l$f1,blocks=cblocks,nblocks=cnblocks,rep=crep,runs=cruns)
    design1<-form.design(temp.list)$design # partial design
    design<-rbind(l$design,matrix(ncol=K,nrow=crep*dup*2^k1))
    design[((2*cruns*start.Thompson)+1):(dim(design)[1]),-ind.strong]<-design1
    design0<-cbind(rep(1,(nrow(design))),design) # with intercept
  }
  if(f1<=0 & k1>0){
    full.design0<-matrix(ncol=k1+1,nrow=2^k1) 
    full.design0[,1]<-rep(1,2^k1)
    for(i in 1:k1){
      xx<-c(rep(1,2^(k1-i)),rep(-1,2^(k1-i)))
      full.design0[,i+1]<-rep(xx,2^(i-1))
    }
    full.design<-full.design0[,-1]
    dup<-2*cruns/2^k1
    temp.block<-c()
    for(d in 1:dup){
      temp.block<-rbind(temp.block,full.design)
    }
    cblocks[1,,]<-cblocks[2,,]<-temp.block
    # next 5 rows were added at Feb 2019 
    temp.list<-list(k=l$k1,f=l$f1,blocks=cblocks,nblocks=cnblocks,rep=crep,runs=cruns)
    design1<-form.design(temp.list)$design # partial design
    design<-rbind(l$design,matrix(ncol=K,nrow=crep*dup*2^k1))
    design[((2*cruns*start.Thompson)+1):(dim(design)[1]),-ind.strong]<-design1
    design0<-cbind(rep(1,(nrow(design))),design) # with intercept
  }
  
  if(f1<=0 & k1<=0){
    dup<-2*cruns/2^k1
    design<-rbind(l$design,matrix(ncol=K,nrow=crep*dup*2^k1))
    design0<-cbind(rep(1,(nrow(design))),design) # with intercept
  }
  
  pv.mat<-rbind(pv.mat,rep(NA,K))
  correction.strong<-rbind(correction.strong,rep(FALSE,K))
  y<-c(y[1:(start.Thompson*2*cruns)],rep(NA,crep*cnblocks*2*cruns))
  
  BREAK<-FALSE
  for (bl in (start.Thompson+1):max.blocks){
    #print(bl)
    block.runs.index<-c(((bl-1)*2*cruns+1):(bl*2*cruns))
    
    design0[block.runs.index,ind.strong+1]<-sign(post.sample[,ind.strong+1])
    # if(any(design0[block.runs.index,ind.strong+1]==0)){
    #   for (u in ind.strong){
    #   zero.ind<-which(design0[block.runs.index,u+1]==0)
    #   design0[block.runs.index,u+1][zero.ind]<-rep(sign(post.mean.temp[bl-1,u+1]),length(zero.ind))
    #   }
    # }
    if(any(design0[block.runs.index,]==0)){
      for (u in ind.strong){
        zero.ind<-which(design0[block.runs.index,u+1]==0)
        (x1<-rbinom(1,1,0.5))
        (x2<--1*x1+1*(1-x1))
        design0[block.runs.index,u+1][zero.ind]<-c(rep(x2,0.5*length(zero.ind)),rep(-x2,length(zero.ind)-floor(0.5*length(zero.ind))))
      }
    }
    design<-design0[,-1]
    p.temp<-pnorm(design0[block.runs.index,]%*%b)
    y[block.runs.index]<-rbinom(2*cruns,1,p.temp)
      
    all.data.to.block<-c(1:(bl*2*cruns))
    cdesign<-design[all.data.to.block,]
    colnames(cdesign)<-paste0("x", 1:K)
    relevant.vars<-paste0("x", 1:K)
    cy<-y[all.data.to.block]
    cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
    data1<-as.data.frame(cbind(cy,cdesign))
    colnames(data1)<-c("y",paste0("x", 1:K))
    # glm(cfmula,data=data1,family = binomial(link = "probit"))
    fit<-reg.fit.possible(data=data1,fmula=cfmula)
    SEPARATION<-fit$error | fit$warnings | sum(cy)==0# for the posterior mean and s.d at the end of this block
    
    sep<-rep(NA,K)
    for(j in 1:K){
      relevant.vars<-paste0("x", j)
      cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
      data1<-as.data.frame(cbind(cy,cdesign))
      colnames(data1)<-c("y",paste0("x", 1:K))
      # glm(cfmula,data=data1,family = binomial(link = "probit"))
      fit<-reg.fit.possible(data=data1,fmula=cfmula)
      sep[j]<-fit$error | fit$warnings
    }
    
    # extract p-values after observing new data:
  if (!(any(correction.strong[1,]))&!BREAK){
    for(j in 1:K){
      if(sep[j]){
        ft<-fisher.test(cdesign[,j],cy)
        pv.mat[2,j]<-ft$p.value}
      if(!sep[j]){
        ft<-fisher.test(cdesign[,j],cy)
        g<-glm(cy~cdesign[,j],family=binomial(link="probit"))  
        pv.mat[2,j]<-min(ft$p.value,coef(summary(g))[2,4])}
    }
  }
  if (any(correction.strong[1,])&!BREAK){   
    index.strong<-which(correction.strong[1,])
     
    for (s in c(1:K)[-index.strong]){
      relevant.vars<-paste0("x", c(s,index.strong))
      cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
      data1<-as.data.frame(cbind(cy,cdesign))
      colnames(data1)<-c("y",paste0("x", 1:K))
      # glm(cfmula,data=data1,family = binomial(link = "probit"))
      fit<-reg.fit.possible(data=data1,fmula=cfmula)
      
      if(fit$error | fit$warnings){ # if a model *cannot* be fitted
        if(length(index.strong)>1){
          comb<-unique(design[(which(cy==1)),index.strong])
          if(is.vector(comb))comb.ind<-find.all.rows(comb,cdesign[,index.strong])$ind
          if(is.matrix(comb)){
            comb.ind<-c()
            for(u in seq(nrow(comb))){
              comb.ind<-sort(c(comb.ind,find.all.rows(comb[u,],cdesign[,index.strong])$ind))
            }
          }
          ft<-fisher.test(cy[comb.ind],cdesign[comb.ind,s])
          pv.mat[2,s]<-ft$p.value
        }
        if(length(index.strong)==1){
          comb<-unique(design[(which(cy==1)),index.strong])
          if(length(comb)==2){
            ft<-fisher.test(cy,cdesign[,s])
            pv.mat[2,s]<-ft$p.value
          }
          if(length(comb)==1){
            comb.ind<-which(cdesign[,index.strong]==comb)
            ft<-fisher.test(cy[comb.ind],cdesign[comb.ind,s])
            pv.mat[2,s]<-ft$p.value
          }
        }
      }
      if(!(fit$error | fit$warnings)){ # if a model *can* be fitted
        g<-glm(cfmula,data=data1,family=binomial(link="probit"),separation = "test")
        pv.mat[2,s]<-coef(summary(g))[2,4]
      }
    } # end of p.v for non-strong factors
    
    if (length(index.strong)==1){
      s<-index.strong
      if(sep[s]){
        ft<-fisher.test(cdesign[,s],cy)
        pv.mat[2,s]<-ft$p.value}
      if(!sep[s]){
        ft<-fisher.test(cdesign[,s],cy)
        g<-glm(cy~cdesign[,s],family=binomial(link="probit"))  
        pv.mat[2,s]<-min(ft$p.value,coef(summary(g))[2,4])}            
    }
    if (length(index.strong)>1){
      relevant.vars<-paste0("x", index.strong)
      cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
      data1<-as.data.frame(cbind(cy,cdesign))
      colnames(data1)<-c("y",paste0("x", 1:K))
      # glm(cfmula,data=data1,family = binomial(link = "probit"))
      fit<-reg.fit.possible(data=data1,fmula=cfmula)
      fit.possible<-!(fit$error | fit$warnings)
      if (fit.possible){
        g<-glm(cy~cdesign[,index.strong],family=binomial(link="probit"))
        pv.mat[2,index.strong]<-coef(summary(g))[-1,4]
      }
      if (!fit.possible){
        for (s in index.strong){
          # if(check.sep(list(j=s,bl=bl,design=cdesign,y=cy,runs=cruns))){
          #   pv.mat[2,s]<-fisher.test(cy,cdesign[,s])$p.value
          # }
          # if(!check.sep(list(j=s,bl=bl,design=cdesign,y=cy,runs=cruns))){
          index.strong.without.s<-setdiff(index.strong,c(s))
          comb<-unique(design[(which(cy==1)),index.strong.without.s])
          if(is.vector(comb))comb.ind<-find.all.rows(comb,cdesign[,index.strong.without.s])$ind
          if(is.matrix(comb)){
            comb.ind<-c()
            for(u in seq(nrow(comb))){
              comb.ind<-sort(c(comb.ind,find.all.rows(comb[u,],cdesign[,index.strong.without.s])$ind))
            }
          }
          if(length(unique(cdesign[comb.ind,s]))==1)pv1<-NA
          if(length(unique(cdesign[comb.ind,s]))==2)pv1<-fisher.test(cy[comb.ind],cdesign[comb.ind,s])$p.value
          pv2<-fisher.test(cy,cdesign[,s])$p.value
          cfmula <- as.formula(paste("y ~ ",paste0("x", s)))
          fit<-reg.fit.possible(data=data1,fmula=cfmula)
          fit.possible<-!(fit$error|fit$warnings)
          pv3<-ifelse(fit.possible,coef(summary(fit$g))[2,4],NA)
          pv.mat[2,s]<-min(na.omit(c(pv1,pv2,pv3)))
          #pv.comp[s,bl,]<-c(pv1,pv2,pv3)
        }
      }
    }
  } 
  
  correction.strong[2,which(pv.mat[2,]<correction.threshold)]<-TRUE
  correction.strong[2,which(pv.mat[2,]>correction.threshold)]<-FALSE
  Thompson.strong[bl,which(pv.mat[2,]<Thompson.threshold)]<-TRUE
  pv.temp[bl,]<-pv.mat[2,]
    pv.mat[1,]<-pv.mat[2,]
    correction.strong[1,]<-correction.strong[2,]
    
    RSTOP<-c()
    (ind.strong1<-which(Thompson.strong[bl,]))
    if(length(ind.strong1)==0){
      ind.strong<-c()
      for(j in 1:K){
        if((j %in% l$ind.strong) & pv.mat[2,j]<=max.wobble){ind.strong<-sort(c(ind.strong,j))}
        if((j %in% l$ind.strong) & pv.mat[2,j]>max.wobble){ind.strong<-setdiff(ind.strong,c(j))}
      }
    }
    if(length(ind.strong1)>0){ind.strong<-ind.strong1}
    
    if(!setequal(l$ind.strong,ind.strong)){
      diff.ind<-union(setdiff(l$ind.strong,ind.strong),setdiff(ind.strong,l$ind.strong))
      for(j in diff.ind){
        if((j %in% l$ind.strong) & !(j %in% ind.strong) & pv.mat[2,j]<=max.wobble){ind.strong<-sort(c(ind.strong,j))}
        if((j %in% l$ind.strong) & !(j %in% ind.strong) & pv.mat[2,j]>max.wobble){RSTOP<-cbind(RSTOP,c(bl,j,"out"));BREAK<-TRUE}
        if((j %in% ind.strong) & !(j %in% l$ind.strong)){RSTOP<-cbind(RSTOP,c(bl,j,"in"));BREAK<-TRUE}
      }
    }
    
    list2<-list(spike.weight=spike.weight,bl=bl,cruns=cruns,SEPARATION=SEPARATION,y=y,design0=design0,cBA=cBA)   
    if(!SPIKESLAB)update<-posterior(list2,samp=TRUE) # BA first
    if(SPIKESLAB)update<-posterior.spike.slab(list2,samp=TRUE) # BA first
    post.mean.temp[bl+1,]<-update$update.mean
    post.median.temp[bl+1,]<-update$update.median
    post.sd.temp[bl+1,]<-update$update.sd
    p.post.mean.temp[bl+1,]<-update$update.mean.p
    p.post.sd.temp[bl+1,]<-update$update.sd.p
    est.form.temp[bl+1]<-update$update.est
    post.prob.temp[bl+1,]<-update$update.post.prob
    cBA<-update$BA
    post.sample<-update$post.sample
    if(SPIKESLAB)spike.weight<-update$spike.weight
    
    if(bl==max.blocks){
      RSTOP<-c(bl,NA,"end")
      start.Thompson<-bl
      BREAK<-TRUE}
    
    if(BREAK) {
      start.Thompson<-bl
      y<-y[1:(start.Thompson*2*cruns)]
      pv.mat<-pv.mat[2,]
      correction.strong<-correction.strong[2,]
      design<-design[1:(start.Thompson*2*cruns),] 
      design0<-cbind(rep(1,dim(design)[1]),design)
      p<-pnorm(design0%*%b)
      break
    }
    
  }
  
  return(list(pv.mat=pv.mat,correction.strong=correction.strong,Thompson.strong=Thompson.strong,
              design=design,p=p,RSTOP=RSTOP,k1=k1,f1=f1,y=y,cBA=cBA,
              start.Thompson=start.Thompson,ind.strong=ind.strong,
              post.mean.temp=post.mean.temp,post.median.temp=post.median.temp,post.sd.temp=post.sd.temp,
              est.form.temp=est.form.temp,SEPARATION=SEPARATION,
              post.sample=post.sample,spike.weight=spike.weight,
              post.prob.temp=post.prob.temp,
              p.post.mean.temp=p.post.mean.temp,
              p.post.sd.temp=p.post.sd.temp,pv.temp=pv.temp))
  
}

Only.Thompson<-function(l){ # list of only K and F
  k<-l$K
  f<-l$F
  runs<-2^(k-f)
  cruns<-2^(k-f)
  post.mean.temp<-matrix(ncol=K+1,nrow=max.blocks+1)
  post.median.temp<-matrix(ncol=K+1,nrow=max.blocks+1)
  post.sd.temp<-matrix(ncol=K+1,nrow=max.blocks+1)
  p.post.mean.temp<-matrix(ncol=2^K,nrow=max.blocks+1)
  p.post.sd.temp<-matrix(ncol=2^K,nrow=max.blocks+1)
  est.form.temp<-rep(NA,max.blocks+1)
  pv.temp<-matrix(ncol=K,nrow=max.blocks)
  post.prob.temp<-matrix(ncol=K+1,nrow=max.blocks+1)
  spike.weight<-matrix(ncol=K,nrow=max.blocks+1)
  if(SPIKESLAB)p.spike<-spike.prior.probability
  
  design0<-matrix(ncol=k+1,nrow=2*runs*max.blocks)
  design0[,1]<-rep(1,nrow(design0))
  design<-design0[,-1]
  y<-rep(NA,2*runs*max.blocks)
  
  # draw a first sample from the prior:
  bl<-1
  block.runs.index<-c(((bl-1)*2*cruns+1):(bl*2*cruns))
  if(SPIKESLAB){
    # in the spike and slab case, we can't decide which levels to play 
    # at the first block because of the zeros. So we will split the
    # zero levels to half (+) half (-).
    post.sample<-spike.slab.sample(spike.prior.probability,mu,cov_mtrx,2*runs)
    design0[block.runs.index,-1]<-sign(post.sample[,-1])
    if(any(design0[block.runs.index,]==0)){
      for (u in 1:K){
        zero.ind<-which(design0[block.runs.index,u+1]==0)
        (x1<-rbinom(1,1,0.5))
        (x2<--1*x1+1*(1-x1))
        design0[block.runs.index,u+1][zero.ind]<-c(rep(x2,0.5*length(zero.ind)),rep(-x2,length(zero.ind)-floor(0.5*length(zero.ind))))
        }
      }
    }
  if(!SPIKESLAB){
    bl<-1
    w0<-rep(1/n,n)
    b.prior<-mvrnorm(n, mu=mu, Sigma=cov_mtrx)
    cdf.b<-cumsum(w0)
    ru<-runif(2*runs,0,1)
    ind<-c()
    for(m in 1:(2*runs))ind[m]<-min(which(cdf.b>ru[m]))
    post.sample<-b.prior[ind,]
    design0[block.runs.index,-1]<-sign(post.sample[,-1])
  }
 
  design<-design0[,-1]
  p.temp<-pnorm(design0[block.runs.index,]%*%b)
  y[block.runs.index]<-rbinom(2*cruns,1,p.temp)
  
  all.data.to.block<-c(1:(bl*2*cruns))
  cdesign<-design[all.data.to.block,]
  colnames(cdesign)<-paste0("x", 1:K)
  relevant.vars<-paste0("x", 1:K)
  cy<-y[all.data.to.block]
  cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
  data1<-as.data.frame(cbind(cy,cdesign))
  colnames(data1)<-c("y",paste0("x", 1:K))
  # glm(cfmula,data=data1,family = binomial(link = "probit"))
  fit<-reg.fit.possible(data=data1,fmula=cfmula)
  SEPARATION<-fit$error | fit$warnings | sum(cy)==0 #for the posterior mean and s.d at the end of this block
  
  # Caculation of p-values
  sep<-rep(NA,K)
  for(j in 1:K){
    relevant.vars<-paste0("x", j)
    cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
    data1<-as.data.frame(cbind(cy,cdesign))
    colnames(data1)<-c("y",paste0("x", 1:K))
    # glm(cfmula,data=data1,family = binomial(link = "probit"))
    fit<-reg.fit.possible(data=data1,fmula=cfmula)
    sep[j]<-fit$error | fit$warnings | sum(cy)==0
  }
  
  if(sum(cy)==0){
    pv.temp[bl,]<-rep(1,k)
  }
  if(sum(cy)>0){
    for(j in 1:k){
      if(sep[j]){
        ft<-fisher.test(cdesign[,j],cy)
        pv.temp[bl,j]<-ft$p.value
        }
      if(!sep[j]){
        ft<-fisher.test(cdesign[,j],cy)
        g<-glm(cy~cdesign[,j],family=binomial(link="probit"))  
        pv.temp[bl,j]<-min(ft$p.value,coef(summary(g))[2,4])
      }
    }
  }
  
  list2<-list(spike.weight=spike.weight,bl=bl,cruns=cruns,SEPARATION=SEPARATION,y=y,design0=design0)   
  if(!SPIKESLAB)update<-posterior(list2,samp=TRUE) # BA first
  if(SPIKESLAB)update<-posterior.spike.slab(list2,samp=TRUE) # BA first
  post.mean.temp[1:2,]<-update$update.mean
  post.median.temp[1:2,]<-update$update.median
  post.sd.temp[1:2,]<-update$update.sd
  p.post.mean.temp[1:2,]<-update$update.mean.p
  p.post.sd.temp[1:2,]<-update$update.sd.p
  est.form.temp[1:2]<-update$update.est
  post.prob.temp[1:2,]<-update$update.post.prob
  cBA<-update$BA  
  post.sample<-update$post.sample
  if(SPIKESLAB)spike.weight<-update$spike.weight
  
 for (bl in 2:max.blocks){
    
    block.runs.index<-c(((bl-1)*2*cruns+1):(bl*2*cruns))
    
    design0[block.runs.index,-1]<-sign(post.sample[,-1])
    # if(any(design0[block.runs.index,]==0)){
    #   for (u in 1:K){
    #     zero.ind<-which(design0[block.runs.index,u+1]==0)
    #     design0[block.runs.index,u+1][zero.ind]<-rep(sign(post.mean.temp[bl,u+1]),length(zero.ind))
    #   }
    # }
    # This creates too unbalanced design
    
    if(any(design0[block.runs.index,]==0)){
      for (u in 1:K){
        zero.ind<-which(design0[block.runs.index,u+1]==0)
        (x1<-rbinom(1,1,0.5))
        (x2<--1*x1+1*(1-x1))
        design0[block.runs.index,u+1][zero.ind]<-c(rep(x2,0.5*length(zero.ind)),rep(-x2,length(zero.ind)-floor(0.5*length(zero.ind))))
      }
    }
    design<-design0[,-1]
    p.temp<-pnorm(design0[block.runs.index,]%*%b)
    y[block.runs.index]<-rbinom(2*cruns,1,p.temp)
    
    all.data.to.block<-c(1:(bl*2*cruns))
    cdesign<-design[all.data.to.block,]
    colnames(cdesign)<-paste0("x", 1:K)
    relevant.vars<-paste0("x", 1:K)
    cy<-y[all.data.to.block]
    cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
    data1<-as.data.frame(cbind(cy,cdesign))
    colnames(data1)<-c("y",paste0("x", 1:K))
    # glm(cfmula,data=data1,family = binomial(link = "probit"))
    fit<-reg.fit.possible(data=data1,fmula=cfmula)
    SEPARATION<-fit$error | fit$warnings | sum(cy)==0 #for the posterior mean and s.d at the end of this block
    
    # Caculation of p-values
    sep<-rep(NA,K)
    for(j in 1:K){
      relevant.vars<-paste0("x", j)
      cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
      data1<-as.data.frame(cbind(cy,cdesign))
      colnames(data1)<-c("y",paste0("x", 1:K))
      # glm(cfmula,data=data1,family = binomial(link = "probit"))
      fit<-reg.fit.possible(data=data1,fmula=cfmula)
      sep[j]<-fit$error | fit$warnings | sum(cy)==0
    }
    if(sum(cy)==0){
      pv.temp[bl,]<-rep(1,k)
    }
    if(sum(cy)>0){
      for(j in 1:k){
        if(sep[j]){
          ft<-fisher.test(cdesign[,j],cy)
          pv.temp[bl,j]<-ft$p.value
        }
        if(!sep[j]){
          ft<-fisher.test(cdesign[,j],cy)
          g<-glm(cy~cdesign[,j],family=binomial(link="probit"))  
          pv.temp[bl,j]<-min(ft$p.value,coef(summary(g))[2,4])
        }
      }
    }
    
    list2<-list(spike.weight=spike.weight,bl=bl,cruns=cruns,SEPARATION=SEPARATION,y=y,design0=design0,cBA=cBA)   
    if(!SPIKESLAB)update<-posterior(list2,samp=TRUE) # BA first
    if(SPIKESLAB)update<-posterior.spike.slab(list2,samp=TRUE) # BA first
    post.mean.temp[bl+1,]<-update$update.mean
    post.median.temp[bl+1,]<-update$update.median
    post.sd.temp[bl+1,]<-update$update.sd
    p.post.mean.temp[bl+1,]<-update$update.mean.p
    p.post.sd.temp[bl+1,]<-update$update.sd.p
    est.form.temp[bl+1]<-update$update.est
    post.prob.temp[bl+1,]<-update$update.post.prob
    cBA<-update$BA
    post.sample<-update$post.sample
    if(SPIKESLAB)spike.weight<-update$spike.weight
    
  }
  
  return(list(design0=design0,y=y,post.mean.temp=post.mean.temp,
              post.sd.temp=post.sd.temp,est.form.temp=est.form.temp,
              cBA=cBA,runs=runs,post.median.temp=post.median.temp,
              post.sample=post.sample,spike.weight=spike.weight,
              post.prob.temp=post.prob.temp,pv.temp=pv.temp,
              p.post.mean.temp=p.post.mean.temp,p.post.sd.temp=p.post.sd.temp))
}

# Design and analysis without TS.
# type = FFDHD => FFD with choice of blocks by HD
# type = FFD => FFD with random choice of blocks
# type = RAN => random choice of runs

BuildDesign<-function(l){ 
  type <- l$type
  pv.mat<-l$pv.mat
  correction.strong<-l$correction.strong
  design<-l$design
  k<-l$k
  f<-l$f
  y<-l$y
  post.mean.temp<-l$post.mean.temp
  post.sd.temp<-l$post.sd.temp
  p.post.mean.temp<-l$p.post.mean.temp
  pv.temp <- l$pv.temp
  post.prob.temp<-l$post.prob.temp
  
  
  cruns<-2^(k-f)
  cnblocks<-max(2^(f-1),1)
  rep<-max.blocks*2*runs/(2^(k+1))
  # rep<-max.blocks*2*runs/(2^k)
  crep<-rep
  cblocks<-array(NA,dim=c(2*cnblocks,2*cruns,k))
  
  if(f>0){
    dup<-1       
    x.def<-relations.def(k,f)
    base.design<-x.def[1:cruns,1:(k-f)] # full 2^(k-f) design matrix
    full.design0<-matrix(ncol=k+1,nrow=2^K) 
    full.design0[,1]<-rep(1,2^k)
    for(i in 1:k){
      xx<-c(rep(1,2^(k-i)),rep(-1,2^(k-i)))
      full.design0[,i+1]<-rep(xx,2^(i-1))
    }
    
    full.design<-full.design0[,-1]   # without intercept
    
    gen.signs<-matrix(nrow=2^f,ncol=f)
    for(i in 1:f){
      xx<-c(rep(1,2^(f-i)),rep(-1,2^(f-i)))
      gen.signs[,i]<-rep(xx,2^(i-1))
    }
    
    for(h in 1:(2*cnblocks)){
      cblocks[h,,]<-generator(gen.signs[h,],k,f,cruns,base.design,x=x.def)
    }
    
    if (!is.foldover(cblocks[1,1:cruns,])){
      #ind<-find.dual.block(blocks,full.design) # it takes a few minutes to run 
      if(k==10 & f==6){ind<-IND.10.6}
      if(k==9 & f==5){ind<-IND.9.5}
      if(k==5 & f==1){ind<-cbind(c(1,1),c(2,2))}
      cblocks<-cblocks[ind[,1],,]
    }
    
    if (is.foldover(cblocks[1,1:cruns,])){
      half.blocks<-array(NA,dim=c(2*cnblocks,cruns,k))
      for(h in 1:(2*cnblocks)){
        half.blocks[h,,]<-generator.without.foldover(gen.signs[h,],k,f,cruns,base.design,x=x.def)
      }
      ind<-sample(2*cnblocks)
      for (h in 1:cnblocks){
        cblocks[h,,]<-rbind(half.blocks[ind[h],,],half.blocks[ind[2*cnblocks-h+1],,])
      }
    }
  }
  if(f<=0){
    full.design0<-matrix(ncol=k+1,nrow=2^k) 
    full.design0[,1]<-rep(1,2^k)
    for(i in 1:k){
      xx<-c(rep(1,2^(k-i)),rep(-1,2^(k-i)))
      full.design0[,i+1]<-rep(xx,2^(i-1))
    }
    full.design<-full.design0[,-1]
    dup<-2*cruns/2^k
    temp.block<-c()
    for(d in 1:dup){
      temp.block<-rbind(temp.block,full.design)
    }
    cblocks[1,,]<-cblocks[2,,]<-temp.block
  }
  
  full.design0<-matrix(ncol=k+1,nrow=2^k) 
  full.design0[,1]<-rep(1,2^k)
  for(i in 1:k){
    xx<-c(rep(1,2^(k-i)),rep(-1,2^(k-i)))
    full.design0[,i+1]<-rep(xx,2^(i-1))
  }
    
  # Add the design (by "type") with rep replications:
  temp.list<-c(l,list(f=f,k=k,blocks=cblocks,nblocks=cnblocks,rep=crep,runs=cruns,type=type))
  design1<-form.design(temp.list)$design
  design<-rbind(l$design,design1)
  design0<-cbind(rep(1,nrow(design)),design) # with intercept
  
  p<-pnorm(design0%*%b)
  y<-rbinom(nrow(design),1,p)
  
  
  # After every block, decide if there are strong factors
  # and update posterior mean and s.d
  
  pv.mat<-rbind(l$pv.mat,rep(NA,K)) # blocks,factors
  correction.strong<-rbind(l$correction.strong,rep(FALSE,K))# blocks,factors
  
  # after 1st block:
    bl<-1
    all.data.to.block<-c(1:(bl*2*cruns))
    cdesign<-design[all.data.to.block,]
    # colnames(cdesign)<-paste0("x", 1:K)
    # relevant.vars<-paste0("x", 1:K)
    cy<-y[all.data.to.block]
    # cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
    # data1<-as.data.frame(cbind(cy,cdesign))
    # colnames(data1)<-c("y",paste0("x", 1:K))
    # # glm(cfmula,data=data1,family = binomial(link = "probit"))
    # fit<-reg.fit.possible2(data=data1,fmula=cfmula)
    # SEPARATION<-fit$error | fit$warnings | sum(cy)==0 #for the posterior mean and s.d at the end of this block
    # 
    # sep<-rep(NA,K)
    # for(j in 1:K){
    #   relevant.vars<-paste0("x", j)
    #   cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
    #   data1<-as.data.frame(cbind(cy,cdesign))
    #   colnames(data1)<-c("y",paste0("x", 1:K))
    #   # glm(cfmula,data=data1,family = binomial(link = "probit"))
    #   library(safeBinaryRegression)
    #   fit<-reg.fit.possible(data=data1,fmula=cfmula)
    #   sep[j]<-fit$error | fit$warnings
    # }
    # detach(package:safeBinaryRegression)
    list2<-list(bl=bl,cruns=cruns,SEPARATION=NULL,y=y,design0=design0)   
    if(!SPIKESLAB)update<-posterior(list2,samp=F) # BA first
    if(SPIKESLAB)update<-posterior.spike.slab(list2,samp=F) # BA first
    
    post.mean.temp[1:2,]<-update$update.mean
    # post.median.temp[1:2,]<-update$update.median
    post.sd.temp[1:2,]<-update$update.sd
    p.post.mean.temp[1:2,]<-update$update.mean.p
    # p.post.sd.temp[1:2,]<-update$update.sd.p
    # est.form.temp[1:2]<-update$update.est
    post.prob.temp[1:2,]<-update$update.post.prob
    cBA<-update$BA
    # if(SPIKESLAB) spike.weight<-update$spike.weight
    
    rm(update)
    
    if(sum(y[1:(bl*2*cruns)])==0){
      pv.mat[1,]<-rep(1,k)
      pv.temp[bl,]<-rep(1,k)
    }
    if(sum(y[1:(bl*2*cruns)])>0){
      for(j in 1:k){
        # if(sep[j]){
          ft<-fisher.test(cdesign[,j],cy)
          pv.mat[1,j]<-ft$p.value
          }
        # if(!sep[j]){
        #   ft<-fisher.test(cdesign[,j],cy)
        #   g<-glm(cy~cdesign[,j],family=binomial(link="probit"))  
        #   pv.mat[1,j]<-min(ft$p.value,coef(summary(g))[2,4])
        # }
      # }
      correction.strong[1,which(pv.mat[1,]<correction.threshold)]=TRUE
      # Thompson.strong[1,which(pv.mat[1,]<Thompson.threshold)]=TRUE
      pv.temp[bl,]<-pv.mat[1,]
    }
  # }
  # if(start.block>1) start.loop<-start.block
  
  # next blocks:
  BREAK<-FALSE
  for (bl in 2:max.blocks){
    all.data.to.block<-c(1:(bl*2*cruns))
    cdesign<-design[all.data.to.block,]
    # colnames(cdesign)<-paste0("x", 1:K)
    # relevant.vars<-paste0("x", 1:K)
    cy<-y[all.data.to.block]
    ##########################################
    # sum(cy)
    # cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
    # data1<-as.data.frame(cbind(cy,cdesign))
    # colnames(data1)<-c("y",paste0("x", 1:K))
    # # glm(cfmula,data=data1,family = binomial(link = "probit"))
    # fit<-reg.fit.possible2(data=data1,fmula=cfmula)
    # SEPARATION<-fit$error | fit$warnings | sum(cy)==0 # for the posterior mean and s.d at the end of this block
    
    # sep<-rep(NA,K)
    # for(j in 1:K){
    #   relevant.vars<-paste0("x", j)
    #   cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
    #   data1<-as.data.frame(cbind(cy,cdesign))
    #   colnames(data1)<-c("y",paste0("x", 1:K))
    #   # glm(cfmula,data=data1,family = binomial(link = "probit"))
    #   library(safeBinaryRegression)
    #   fit<-reg.fit.possible(data=data1,fmula=cfmula)
    #   sep[j]<-fit$error | fit$warnings
    # }
    ####################################################
    if(sum(cy)==0){
      pv.mat[2,]<-rep(1,k)
      pv.temp[bl,]<-rep(1,k)
    }
    if(sum(cy)>0){
      
      if (!(any(correction.strong[1,]))&!BREAK){
        for(j in 1:k){
          # if(sep[j]){
          ft<-fisher.test(cdesign[,j],cy)
          pv.mat[2,j]<-ft$p.value
          #}
          # if(!sep[j]){
          #   ft<-fisher.test(design[all.data.to.block,j],y[all.data.to.block])
          #   g<-glm(cy~cdesign[,j],family=binomial(link="probit"))  
          #   pv.mat[2,j]<-min(ft$p.value,coef(summary(g))[2,4])}
        }
      }
      # }
      if (any(correction.strong[1,])&!BREAK){   
        index.strong<-which(correction.strong[1,])
        for (s in c(1:K)[-index.strong]){
          # relevant.vars<-paste0("x", c(s,index.strong))
          # cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
          # data1<-as.data.frame(cbind(cy,cdesign))
          # colnames(data1)<-c("y",paste0("x", 1:K))
          # # glm(cfmula,data=data1,family = binomial(link = "probit"))
          # detach(package:safeBinaryRegression)
          # fit<-reg.fit.possible2(data=data1,fmula=cfmula)
          # 
          # if(fit$error | fit$warnings){ # if a model *cannot* be fitted
          if(length(index.strong)>1){
            comb<-unique(cdesign[which(cy==1),index.strong])
            if(is.vector(comb))comb.ind<-find.all.rows(comb,cdesign[,index.strong])$ind
            if(is.matrix(comb)){
              comb.ind<-c()
              for(u in seq(nrow(comb))){
                comb.ind<-sort(c(comb.ind,find.all.rows(comb[u,],cdesign[,index.strong])$ind))
              }
            }
            ft<-fisher.test(cy[comb.ind],cdesign[comb.ind,s])
            pv.mat[2,s]<-ft$p.value
          }
          if(length(index.strong)==1){
            comb<-unique(design[(which(cy==1)),index.strong])
            if(length(comb)==2){
              ft<-fisher.test(cy,cdesign[,s])
              pv.mat[2,s]<-ft$p.value
            }
            if(length(comb)==1){
              comb.ind<-which(cdesign[,index.strong]==comb)
              ft<-fisher.test(cy[comb.ind],cdesign[comb.ind,s])
              pv.mat[2,s]<-ft$p.value
            }
          }
          # }
          # if(!(fit$error | fit$warnings)){ # if a model *can* be fitted
          #   g<-glm(cfmula,data=data1,family=binomial(link="probit"),separation = "test")
          #   pv.mat[2,s]<-coef(summary(g))[2,4]
          # }
        } # end of p.v for non-strong factors
        
        if (length(index.strong)==1){
          s<-index.strong
          # if(sep[s]){
          ft<-fisher.test(cdesign[,s],cy)
          pv.mat[2,s]<-ft$p.value
          # if(!sep[s]){
          #   ft<-fisher.test(cdesign[,s],cy)
          #   g<-glm(cy~cdesign[,s],family=binomial(link="probit"))  
          #   pv.mat[2,s]<-min(ft$p.value,coef(summary(g))[2,4])}            
        }
        if (length(index.strong)>1){
          # relevant.vars<-paste0("x", index.strong)
          # cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
          # data1<-as.data.frame(cbind(cy,cdesign))
          # colnames(data1)<-c("y",paste0("x", 1:K))
          # # glm(cfmula,data=data1,family = binomial(link = "probit"))
          # fit<-reg.fit.possible(data=data1,fmula=cfmula)
          # fit.possible<-!(fit$error | fit$warnings)
          # if (fit.possible){
          #   g<-glm(cy~cdesign[,index.strong],family=binomial(link="probit"))
          #   pv.mat[2,index.strong]<-coef(summary(g))[-1,4]
          # }
          # if (!fit.possible){
          for (s in index.strong){
            index.strong.without.s<-setdiff(index.strong,c(s))
            comb<-unique(design[(which(cy==1)),index.strong.without.s])
            if(is.vector(comb))comb.ind<-find.all.rows(comb,cdesign[,index.strong.without.s])$ind
            if(is.matrix(comb)){
              comb.ind<-c()
              for(u in seq(nrow(comb))){
                comb.ind<-sort(c(comb.ind,find.all.rows(comb[u,],cdesign[,index.strong.without.s])$ind))
              }
            }
            if(length(unique(cdesign[comb.ind,s]))==1)pv1<-NA
            if(length(unique(cdesign[comb.ind,s]))==2)pv1<-fisher.test(cy[comb.ind],cdesign[comb.ind,s])$p.value
            pv2<-fisher.test(cy,cdesign[,s])$p.value
            # cfmula <- as.formula(paste("y ~ ",paste0("x", s)))
            # fit<-reg.fit.possible(data=data1,fmula=cfmula)
            # fit.possible<-!(fit$error|fit$warnings)
            # pv3<-ifelse(fit.possible,coef(summary(fit$g))[2,4],NA)
            pv.mat[2,s]<-min(na.omit(c(pv1,pv2)))
            #pv.comp[s,bl,]<-c(pv1,pv2,pv3)
          }
        }
      }
    }
    
    correction.strong[2,which(pv.mat[2,]<correction.threshold)]<-TRUE
    correction.strong[2,which(pv.mat[2,]>correction.threshold)]<-FALSE
    # Thompson.strong[bl,which(pv.mat[2,]<Thompson.threshold)]<-TRUE
    pv.temp[bl,]<-pv.mat[2,]
    pv.mat[1,]<-pv.mat[2,]
    correction.strong[1,]<-correction.strong[2,]
    
    # Check if any factor is strong and update mean and sd
    
    # if (all(!Thompson.strong[bl,])){
      list2<-list(bl=bl,cruns=cruns,SEPARATION=NULL,y=y,
                  design0=design0,cBA=cBA)   
      if(!SPIKESLAB)update<-posterior(list2,samp=FALSE) 
      # if(SPIKESLAB)update<-posterior.spike.slab(list2,samp=F) # BA first
      post.mean.temp[bl+1,]<-update$update.mean
      # post.median.temp[bl+1,]<-update$update.median
      post.sd.temp[bl+1,]<-update$update.sd
      p.post.mean.temp[bl+1,]<-update$update.mean.p
      # p.post.sd.temp[bl+1,]<-update$update.sd.p
      # est.form.temp[bl+1]<-update$update.est
      post.prob.temp[bl+1,]<-update$update.post.prob
      cBA<-update$BA
  }

      
 
  return(list(pv.mat=pv.mat,
              p=p,y=y,
              post.mean.temp=post.mean.temp,post.sd.temp=post.sd.temp,
              post.prob.temp=post.prob.temp,design0=design0,
              p.post.mean.temp=p.post.mean.temp, cBA= cBA,
              pv.temp=pv.temp,correction.strong=correction.strong))
} #end of function



RANDES <- function(l){ # list of only K and F
  k<-l$K
  f<-l$F
  runs<-2^(k-f)
  cruns<-2^(k-f)
  post.mean.temp<-matrix(ncol=K+1,nrow=max.blocks+1)
  post.median.temp<-matrix(ncol=K+1,nrow=max.blocks+1)
  post.prob.temp<-matrix(ncol=K+1,nrow=max.blocks+1)
  post.sd.temp<-matrix(ncol=K+1,nrow=max.blocks+1)
  p.post.mean.temp<-matrix(ncol=2^K,nrow=max.blocks+1)
  p.post.sd.temp<-matrix(ncol=2^K,nrow=max.blocks+1)
  est.form.temp<-rep(NA,max.blocks+1)
  pv.temp<-matrix(ncol=K,nrow=max.blocks)
  spike.weight<-matrix(ncol=K,nrow=max.blocks+1)
  if(SPIKESLAB)p.spike<-spike.prior.probability
  
  full.design0<-matrix(ncol=K+1,nrow=2^K)
  full.design0[,1]<-rep(1,2^K)
  for(i in 1:K){
    xx<-c(rep(1,2^(K-i)),rep(-1,2^(K-i)))
    full.design0[,i+1]<-rep(xx,2^(i-1))
  }
  
  rep<-max.blocks*2*cruns/(2^k)
  
  # form a random design with rep replications
  list<-list(k1=k,f1=f,rep=rep,full.design0=full.design0) 
  design0<-form.random.design(list)
  design<-design0[,-1]
  p<-pnorm(design0%*%b)
  y<-rbinom(rep*2^k,1,p)
  
  
  bl<-1
  block.runs.index<-c(((bl-1)*2*cruns+1):(bl*2*cruns))
  all.data.to.block<-c(1:(bl*2*cruns))
  cdesign<-design[all.data.to.block,]
  colnames(cdesign)<-paste0("x", 1:K)
  relevant.vars<-paste0("x", 1:K)
  cy<-y[all.data.to.block]
  cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
  data1<-as.data.frame(cbind(cy,cdesign))
  colnames(data1)<-c("y",paste0("x", 1:K))
  # glm(cfmula,data=data1,family = binomial(link = "probit"))
  fit<-reg.fit.possible(data=data1,fmula=cfmula)
  SEPARATION<-fit$error | fit$warnings | sum(cy)==0 #for the posterior mean and s.d at the end of this block
  
  # Caculation of p-values
  sep<-rep(NA,K)
  for(j in 1:K){
    relevant.vars<-paste0("x", j)
    cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
    data1<-as.data.frame(cbind(cy,cdesign))
    colnames(data1)<-c("y",paste0("x", 1:K))
    # glm(cfmula,data=data1,family = binomial(link = "probit"))
    fit<-reg.fit.possible(data=data1,fmula=cfmula)
    sep[j]<-fit$error | fit$warnings | sum(cy)==0
  }
  if(sum(cy)==0){
    pv.temp[bl,]<-rep(1,k)
  }
  if(sum(cy)>0){
    for(j in 1:k){
      if(sep[j]){
        ft<-fisher.test(cdesign[,j],cy)
        pv.temp[bl,j]<-ft$p.value
      }
      if(!sep[j]){
        ft<-fisher.test(cdesign[,j],cy)
        g<-glm(cy~cdesign[,j],family=binomial(link="probit"))  
        pv.temp[bl,j]<-min(ft$p.value,coef(summary(g))[2,4])
      }
    }
  }
  
  list2<-list(spike.weight=spike.weight,bl=bl,cruns=cruns,SEPARATION=SEPARATION,y=y,design0=design0)   
  if(!SPIKESLAB)update<-posterior(list2,samp=T) # BA first
  if(SPIKESLAB)update<-posterior.spike.slab(list2,samp=T) # BA first
  post.mean.temp[1:2,]<-update$update.mean
  post.median.temp[1:2,]<-update$update.median
  post.sd.temp[1:2,]<-update$update.sd
  p.post.mean.temp[1:2,]<-update$update.mean.p
  p.post.sd.temp[1:2,]<-update$update.sd.p
  est.form.temp[1:2]<-update$update.est
  post.prob.temp[1:2,]<-update$update.post.prob
  cBA<-update$BA  
  post.sample<-update$post.sample
  if(SPIKESLAB)spike.weight<-update$spike.weight
  
  for (bl in 2:max.blocks){
    
    block.runs.index<-c(((bl-1)*2*cruns+1):(bl*2*cruns))
    all.data.to.block<-c(1:(bl*2*cruns))
    cdesign<-design[all.data.to.block,]
    colnames(cdesign)<-paste0("x", 1:K)
    relevant.vars<-paste0("x", 1:K)
    cy<-y[all.data.to.block]
    cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
    data1<-as.data.frame(cbind(cy,cdesign))
    colnames(data1)<-c("y",paste0("x", 1:K))
    # glm(cfmula,data=data1,family = binomial(link = "probit"))
    fit<-reg.fit.possible(data=data1,fmula=cfmula)
    SEPARATION<-fit$error | fit$warnings | sum(cy)==0 #for the posterior mean and s.d at the end of this block
    
    # Caculation of p-values
    sep<-rep(NA,K)
    for(j in 1:K){
      relevant.vars<-paste0("x", j)
      cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
      data1<-as.data.frame(cbind(cy,cdesign))
      colnames(data1)<-c("y",paste0("x", 1:K))
      # glm(cfmula,data=data1,family = binomial(link = "probit"))
      fit<-reg.fit.possible(data=data1,fmula=cfmula)
      sep[j]<-fit$error | fit$warnings | sum(cy)==0
    }
    if(sum(cy)==0){
      pv.temp[bl,]<-rep(1,k)
    }
    if(sum(cy)>0){
      for(j in 1:k){
        if(sep[j]){
          ft<-fisher.test(cdesign[,j],cy)
          pv.temp[bl,j]<-ft$p.value
        }
        if(!sep[j]){
          ft<-fisher.test(cdesign[,j],cy)
          g<-glm(cy~cdesign[,j],family=binomial(link="probit"))  
          pv.temp[bl,j]<-min(ft$p.value,coef(summary(g))[2,4])
        }
      }
    }
    list2<-list(spike.weight=spike.weight,bl=bl,cruns=cruns,SEPARATION=SEPARATION,y=y,design0=design0,cBA=cBA)   
    if(!SPIKESLAB)update<-posterior(list2,samp=T) # BA first
    if(SPIKESLAB)update<-posterior.spike.slab(list2,samp=T) # BA first
    post.mean.temp[bl+1,]<-update$update.mean
    post.median.temp[bl+1,]<-update$update.median
    post.sd.temp[bl+1,]<-update$update.sd
    p.post.mean.temp[bl+1,]<-update$update.mean.p
    p.post.sd.temp[bl+1,]<-update$update.sd.p
    est.form.temp[bl+1]<-update$update.est
    post.prob.temp[bl+1,]<-update$update.post.prob
    cBA<-update$BA
    post.sample<-update$post.sample
    if(SPIKESLAB)spike.weight<-update$spike.weight
    
  }
  
  return(list(design0=design0,y=y,post.mean.temp=post.mean.temp,
              post.sd.temp=post.sd.temp,est.form.temp=est.form.temp,
              cBA=cBA,runs=runs,post.median.temp=post.median.temp,
              post.sample=post.sample,spike.weight=spike.weight,
              post.prob.temp=post.prob.temp,pv.temp=pv.temp,
              p.post.mean.temp=p.post.mean.temp,
              p.post.sd.temp=p.post.sd.temp))
}

# Fractional factorial all the way - special objects for relation
# between p-value and posterior weight

FFDalltheway<-function(l,start.block){
  pv.mat<-l$pv.mat
  pv.mat2<-l$pv.mat2
  pv.type<-l$pv.type
  pv.type2<-l$pv.type2
  direc.temp<-l$direc.temp
  correction.strong<-l$correction.strong
  Thompson.strong<-l$Thompson.strong
  start.Thompson<-l$start.Thompson
  design<-l$design
  k<-K
  f<-F
  y<-l$y
  ind.strong<-l$ind.strong  
  k1<-0
  f1<-0
  post.mean.temp<-l$post.mean.temp
  post.median.temp<-l$post.median.temp
  post.sd.temp<-l$post.sd.temp
  p.post.mean.temp<-l$p.post.mean.temp
  p.post.sd.temp<-l$p.post.sd.temp
  est.form.temp<-l$est.form.temp
  SEPARATION<-l$SEPARATION
  cBA<-l$cBA
  post.sample<-l$post.sample
  spike.weight<-l$spike.weight 
  post.prob.temp<-l$post.prob.temp
  
  cruns<-2^(k-f)
  cnblocks<-max(2^(f-1),1)
  crep<-ceiling((max.blocks-start.Thompson)/cnblocks)
  cblocks<-array(NA,dim=c(2*cnblocks,2*cruns,k))
  
  if(f>0){
    dup<-1       
    x.def<-relations.def(k,f)
    base.design<-x.def[1:cruns,1:(k-f)] # full 2^(k-f) design matrix
    full.design0<-matrix(ncol=k+1,nrow=2^K) 
    full.design0[,1]<-rep(1,2^k)
    for(i in 1:k){
      xx<-c(rep(1,2^(k-i)),rep(-1,2^(k-i)))
      full.design0[,i+1]<-rep(xx,2^(i-1))
    }
    
    full.design<-full.design0[,-1]   # without intercept
    
    gen.signs<-matrix(nrow=2^f,ncol=f)
    for(i in 1:f){
      xx<-c(rep(1,2^(f-i)),rep(-1,2^(f-i)))
      gen.signs[,i]<-rep(xx,2^(i-1))
    }
    
    for(h in 1:(2*cnblocks)){
      cblocks[h,,]<-generator(gen.signs[h,],k,f,cruns,base.design,x=x.def)
    }
    
    if (!is.foldover(cblocks[1,1:cruns,])){
      #ind<-find.dual.block(blocks,full.design) # it takes a few minutes to run 
      if(k==10 & f==6){ind<-IND.10.6}
      if(k==9 & f==5){ind<-IND.9.5}
      if(k==5 & f==1){ind<-cbind(c(1,1),c(2,2))}
      cblocks<-cblocks[ind[,1],,]
    }
    
    if (is.foldover(cblocks[1,1:cruns,])){
      half.blocks<-array(NA,dim=c(2*cnblocks,cruns,k))
      for(h in 1:(2*cnblocks)){
        half.blocks[h,,]<-generator.without.foldover(gen.signs[h,],k,f,cruns,base.design,x=x.def)
      }
      ind<-sample(2*cnblocks)
      for (h in 1:cnblocks){
        cblocks[h,,]<-rbind(half.blocks[ind[h],,],half.blocks[ind[2*cnblocks-h+1],,])
      }
    }
  }
  if(f<=0){
    full.design0<-matrix(ncol=k+1,nrow=2^k) 
    full.design0[,1]<-rep(1,2^k)
    for(i in 1:k){
      xx<-c(rep(1,2^(k-i)),rep(-1,2^(k-i)))
      full.design0[,i+1]<-rep(xx,2^(i-1))
    }
    full.design<-full.design0[,-1]
    dup<-2*cruns/2^k
    temp.block<-c()
    for(d in 1:dup){
      temp.block<-rbind(temp.block,full.design)
    }
    cblocks[1,,]<-cblocks[2,,]<-temp.block
  }
  
  # Add the design with rep replications:
  temp.list<-c(l,list(f=f,k=k,blocks=cblocks,nblocks=cnblocks,rep=crep,runs=cruns))
  design1<-form.design(temp.list)$design
  design<-rbind(l$design,design1)
  design0<-cbind(rep(1,nrow(design)),design) # with intercept
  
  p<-pnorm(design0%*%b)
  if(start.block==1)add.p<-p[1:nrow(design)]
  if(start.block!=1)add.p<-p[(nrow(l$design)+1):nrow(design)]
  add.y<-rbinom(length(add.p),1,add.p)
  if(start.block==1)y[1:nrow(design)]<-add.y
  if(start.block!=1)y[(nrow(l$design)+1):nrow(design)]<-add.y
  
  
  # After every block, decide if there are strong factors
  # and update posterior mean and s.d

  
  pv.mat<-rbind(l$pv.mat,rep(NA,K)) # blocks,factors
  correction.strong<-rbind(l$correction.strong,rep(FALSE,K))# blocks,factors
  
  # after 1st block:
  if(start.block==1){
    start.loop<-2
    bl<-1
    all.data.to.block<-c(1:(bl*2*cruns))
    cdesign<-design[all.data.to.block,]
    colnames(cdesign)<-paste0("x", 1:K)
    relevant.vars<-paste0("x", 1:K)
    cy<-y[all.data.to.block]
    cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
    data1<-as.data.frame(cbind(cy,cdesign))
    colnames(data1)<-c("y",paste0("x", 1:K))
    # glm(cfmula,data=data1,family = binomial(link = "probit"))
    fit<-reg.fit.possible(data=data1,fmula=cfmula)
    SEPARATION<-fit$error | fit$warnings | sum(cy)==0 #for the posterior mean and s.d at the end of this block
    
    sep<-rep(NA,K)
    for(j in 1:K){
      relevant.vars<-paste0("x", j)
      cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
      data1<-as.data.frame(cbind(cy,cdesign))
      colnames(data1)<-c("y",paste0("x", 1:K))
      # glm(cfmula,data=data1,family = binomial(link = "probit"))
      fit<-reg.fit.possible(data=data1,fmula=cfmula)
      sep[j]<-fit$error | fit$warnings
    }
    
    list2<-list(spike.weight=spike.weight,bl=bl,cruns=cruns,SEPARATION=SEPARATION,y=y,design0=design0)   
    if(!SPIKESLAB)update<-posterior(list2,samp=FALSE) # BA first
    if(SPIKESLAB)update<-posterior.spike.slab(list2,samp=FALSE) # BA first
    
    post.mean.temp[1:2,]<-update$update.mean
    post.median.temp[1:2,]<-update$update.median
    post.sd.temp[1:2,]<-update$update.sd
    p.post.mean.temp[1:2,]<-update$update.mean.p
    p.post.sd.temp[1:2,]<-update$update.sd.p
    est.form.temp[1:2]<-update$update.est
    post.prob.temp[1:2,]<-update$update.post.prob
    cBA<-update$BA
    if(SPIKESLAB) spike.weight<-update$spike.weight
    
    if(sum(y[1:(bl*2*cruns)])==0){
      pv.mat[2,]<-rep(1,k)
      pv.mat2[bl,]<-rep(1,k)
      pv.type[bl,]<-rep("zero",k)
      pv.type2[bl,]<-rep("null",k)
      direc.temp[bl,]<-rep(0,k)
      }
    if(sum(y[1:(bl*2*cruns)])>0){
      for(j in 1:k){
        if(sep[j]){
          ft<-fisher.test(cdesign[,j],cy)
          pv.mat[1,j]<-ft$p.value
          pv.mat2[1,j]<-pv.mat[1,j]
          pv.type[1,j]<-"u"
          pv.type2[1,j]<-"fisher"
          tab<-table(cdesign[,j],cy)
          dif<-tab[2,2]-tab[1,2]
          direc.temp[bl,j]<-sign(dif)
          }
        if(!sep[j]){
          ft<-fisher.test(cdesign[,j],cy)
          g<-glm(cy~cdesign[,j],family=binomial(link="probit"))  
          pv.mat[1,j]<-min(ft$p.value,coef(summary(g))[2,4])
          pv.mat2[1,j]<-pv.mat[1,j]
          pv.type[1,j]<-"u"
          pv.type2[1,j]<-ifelse(ft$p.value<coef(summary(g))[2,4],"fisher","glm")
          if(ft$p.value<=coef(summary(g))[2,4]){
            tab<-table(cdesign[,j],cy)
            dif<-tab[2,2]-tab[1,2]
            direc.temp[bl,j]<-sign(dif)}
          if(ft$p.value>coef(summary(g))[2,4]){
            direc.temp[bl,j]<-as.numeric(sign(coef(g)[2]))}
        }
      }
    }
      correction.strong[1,which(pv.mat[1,]<correction.threshold)]=TRUE
      Thompson.strong[1,which(pv.mat[1,]<Thompson.threshold)]=TRUE
  }
  if(start.block>1) start.loop<-start.block
  
  # next blocks:
  BREAK<-FALSE
  for (bl in start.loop:max.blocks){
    all.data.to.block<-c(1:(bl*2*cruns))
    cdesign<-design[all.data.to.block,]
    colnames(cdesign)<-paste0("x", 1:K)
    relevant.vars<-paste0("x", 1:K)
    cy<-y[all.data.to.block]
    sum(cy)
    cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
    data1<-as.data.frame(cbind(cy,cdesign))
    colnames(data1)<-c("y",paste0("x", 1:K))
    # glm(cfmula,data=data1,family = binomial(link = "probit"))
    fit<-reg.fit.possible(data=data1,fmula=cfmula)
    SEPARATION<-fit$error | fit$warnings | sum(cy)==0 # for the posterior mean and s.d at the end of this block
    
    sep<-rep(NA,K)
    for(j in 1:K){
      relevant.vars<-paste0("x", j)
      cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
      data1<-as.data.frame(cbind(cy,cdesign))
      colnames(data1)<-c("y",paste0("x", 1:K))
      # glm(cfmula,data=data1,family = binomial(link = "probit"))
      fit<-reg.fit.possible(data=data1,fmula=cfmula)
      sep[j]<-fit$error | fit$warnings
    }
    if(sum(cy)==0){
        pv.mat[2,]<-rep(1,k)
        pv.mat2[bl,]<-rep(1,k)
        pv.type[bl,]<-rep("zero",k)
        pv.type2[bl,]<-rep("null",k)
        direc.temp[bl,]<-rep(0,k)
        
      }
    if(sum(cy)>0){
      
      if (!(any(correction.strong[1,]))&!BREAK){
        for(j in 1:k){
          if(sep[j]){
            ft<-fisher.test(cdesign[,j],cy)
            pv.mat[2,j]<-ft$p.value
            pv.mat2[bl,j]<-pv.mat[2,j]
            pv.type[bl,j]<-"u"
            pv.type2[bl,j]<-"fisher"
            tab<-table(cdesign[,j],cy)
            dif<-tab[2,2]-tab[1,2]
            direc.temp[bl,j]<-sign(dif)
            
          }
          if(!sep[j]){
            ft<-fisher.test(cdesign[,j],cy)
            g<-glm(cy~cdesign[,j],family=binomial(link="probit"))  
            pv.mat[2,j]<-min(ft$p.value,coef(summary(g))[2,4])
            pv.mat2[bl,j]<-pv.mat[2,j]
            pv.type[bl,j]<-"u"
            pv.type2[bl,j]<-ifelse(ft$p.value<coef(summary(g))[2,4],"fisher","glm")
            if(ft$p.value<=coef(summary(g))[2,4]){
              tab<-table(cdesign[,j],cy)
              dif<-tab[2,2]-tab[1,2]
              direc.temp[bl,j]<-sign(dif)}
            if(ft$p.value>coef(summary(g))[2,4]){
              direc.temp[bl,j]<-as.numeric(sign(coef(g)[2]))}
          }
        }
      }
      if (any(correction.strong[1,])&!BREAK){   
        index.strong<-which(correction.strong[1,])
        for (s in c(1:K)[-index.strong]){
          relevant.vars<-paste0("x", c(s,index.strong))
          cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
          data1<-as.data.frame(cbind(cy,cdesign))
          colnames(data1)<-c("y",paste0("x", 1:K))
          # glm(cfmula,data=data1,family = binomial(link = "probit"))
          fit<-reg.fit.possible(data=data1,fmula=cfmula)
          
          if(fit$error | fit$warnings){ # if a model *cannot* be fitted
            if(length(index.strong)>1){
              comb<-unique(cdesign[which(cy==1),index.strong])
              if(is.vector(comb))comb.ind<-find.all.rows(comb,cdesign[,index.strong])$ind
              if(is.matrix(comb)){
                comb.ind<-c()
                for(u in seq(nrow(comb))){
                  comb.ind<-sort(c(comb.ind,find.all.rows(comb[u,],cdesign[,index.strong])$ind))
                }
              }
              ft<-fisher.test(cy[comb.ind],cdesign[comb.ind,s])
              pv.mat[2,s]<-ft$p.value
              pv.mat2[bl,s]<-pv.mat[2,s]
              pv.type[bl,s]<-"m"
              pv.type2[bl,s]<-"fisher"
              tab<-table(cdesign[comb.ind,s],cy[comb.ind])
              dif<-tab[2,2]-tab[1,2]
              direc.temp[bl,s]<-sign(dif)
            }
            if(length(index.strong)==1){
              comb<-unique(design[(which(cy==1)),index.strong])
              if(length(comb)==2){
                ft<-fisher.test(cy,cdesign[,s])
                pv.mat[2,s]<-ft$p.value
                pv.mat2[bl,s]<-pv.mat[2,s]
                pv.type[bl,s]<-"m"
                pv.type2[bl,s]<-"fisher"
                tab<-table(cdesign[,s],cy)
                dif<-tab[2,2]-tab[1,2]
                direc.temp[bl,s]<-sign(dif)
              }
              if(length(comb)==1){
                comb.ind<-which(cdesign[,index.strong]==comb)
                ft<-fisher.test(cy[comb.ind],cdesign[comb.ind,s])
                pv.mat[2,s]<-ft$p.value
                pv.mat2[bl,s]<-pv.mat[2,s]
                pv.type[bl,s]<-"m"
                pv.type2[bl,s]<-"fisher"
                tab<-table(cdesign[comb.ind,s],cy[comb.ind])
                dif<-tab[2,2]-tab[1,2]
                direc.temp[bl,s]<-sign(dif)
              }
            }
          }
          if(!(fit$error | fit$warnings)){ # if a model *can* be fitted
            g<-glm(cfmula,data=data1,family=binomial(link="probit"),separation = "test")
            pv.mat[2,s]<-coef(summary(g))[2,4]
            pv.mat2[bl,s]<-pv.mat[2,s]
            pv.type[bl,s]<-"m"
            pv.type2[bl,s]<-"glm"
            direc.temp[bl,s]<-as.numeric(sign(coef(g)[2]))
          }
        } # end of p.v for non-strong factors
        
        if (length(index.strong)==1){
          s<-index.strong
          if(sep[s]){
            ft<-fisher.test(cdesign[,s],cy)
            pv.mat[2,s]<-ft$p.value
            pv.mat2[bl,s]<-pv.mat[2,s]
            pv.type[bl,s]<-"u"
            pv.type2[bl,s]<-"fisher"
            tab<-table(cdesign[,s],cy)
            dif<-tab[2,2]-tab[1,2]
            direc.temp[bl,s]<-sign(dif)
          }
          if(!sep[s]){
            ft<-fisher.test(cdesign[,s],cy)
            g<-glm(cy~cdesign[,s],family=binomial(link="probit"))  
            pv.mat[2,s]<-min(ft$p.value,coef(summary(g))[2,4])
            pv.mat2[bl,s]<-pv.mat[2,s]
            pv.type[bl,s]<-"u"
            pv.type2[bl,s]<-ifelse(ft$p.value<coef(summary(g))[2,4],"fisher","glm")
            if(ft$p.value<=coef(summary(g))[2,4]){
              tab<-table(cdesign[,s],cy)
              dif<-tab[2,2]-tab[1,2]
              direc.temp[bl,s]<-sign(dif)}
            if(ft$p.value>coef(summary(g))[2,4]){
              direc.temp[bl,s]<-as.numeric(sign(coef(g)[2]))}
          }            
        }
        if (length(index.strong)>1){
          relevant.vars<-paste0("x", index.strong)
          cfmula <- as.formula(paste("y ~ ", paste(relevant.vars, collapse= "+")))
          data1<-as.data.frame(cbind(cy,cdesign))
          colnames(data1)<-c("y",paste0("x", 1:K))
          # glm(cfmula,data=data1,family = binomial(link = "probit"))
          fit<-reg.fit.possible(data=data1,fmula=cfmula)
          fit.possible<-!(fit$error | fit$warnings)
          if (fit.possible){
            g<-glm(cy~cdesign[,index.strong],family=binomial(link="probit"))
            pv.mat[2,index.strong]<-coef(summary(g))[-1,4]
            pv.mat2[bl,index.strong]<-pv.mat[2,index.strong]
            pv.type[bl,index.strong]<-rep("m",length(index.strong))
            pv.type2[bl,index.strong]<-rep("glm",length(index.strong))
            direc.temp[bl,index.strong]<-as.numeric(sign(coef(g)[-1]))
          }
          if (!fit.possible){
            for (s in index.strong){
              index.strong.without.s<-setdiff(index.strong,c(s))
              comb<-unique(design[(which(cy==1)),index.strong.without.s])
              if(is.vector(comb))comb.ind<-find.all.rows(comb,cdesign[,index.strong.without.s])$ind
              if(is.matrix(comb)){
                comb.ind<-c()
                for(u in seq(nrow(comb))){
                  comb.ind<-sort(c(comb.ind,find.all.rows(comb[u,],cdesign[,index.strong.without.s])$ind))
                }
              }
              if(length(unique(cdesign[comb.ind,s]))==1)pv1<-NA
              if(length(unique(cdesign[comb.ind,s]))==2)pv1<-fisher.test(cy[comb.ind],cdesign[comb.ind,s])$p.value
              pv2<-fisher.test(cy,cdesign[,s])$p.value
              cfmula <- as.formula(paste("y ~ ",paste0("x", s)))
              fit<-reg.fit.possible(data=data1,fmula=cfmula)
              fit.possible<-!(fit$error|fit$warnings)
              pv3<-ifelse(fit.possible,coef(summary(fit$g))[2,4],NA)
              if(is.na(min(na.omit(c(pv1,pv2,pv3))))){
                edebpv<-new.env()
                deb<-list(cy=cy,cdesign=cdesign,cdesign0=cdesign0,s=s,
                          index.strong=index.strong,comb.ind=comb.ind,
                          index.strong.without.s=index.strong.without.s,
                          pv=c(pv1,pv2,pv3))
                assign("deb",deb,envir=edebpv)
                save(edebpv, file = "edebpv.Rda")
              }
              
              
              pv.mat[2,s]<-min(na.omit(c(pv1,pv2,pv3)))
              pv.mat2[bl,s]<-pv.mat[2,s]
              pv.type[bl,s]<-"m"
              pv.type2[bl,s]<-ifelse(which.min(c(pv1,pv2,pv3))!=3,"fisher","glm")
              if(!is.na(pv1)){
                if(min(na.omit(c(pv1,pv2,pv3)))==pv1){
                  tab<-table(cdesign[comb.ind,s],cy[comb.ind])
                  dif<-tab[2,2]-tab[1,2]
                  direc.temp[bl,s]<-sign(dif)}}
              if(!is.na(pv2)){
              if(min(na.omit(c(pv1,pv2,pv3)))==pv2){
                tab<-table(cdesign[,s],cy)
                dif<-tab[2,2]-tab[1,2]
                direc.temp[bl,s]<-sign(dif)
              }}
              if(!is.na(pv3)){
              if(min(na.omit(c(pv1,pv2,pv3)))==pv3){
                direc.temp[bl,s]<-as.numeric(sign(coef(fit$g)[2]))
                }}
              
            }
          }
        }
      }
    }
    correction.strong[2,which(pv.mat[2,]<correction.threshold)]<-TRUE
    correction.strong[2,which(pv.mat[2,]>correction.threshold)]<-FALSE
    Thompson.strong[bl,which(pv.mat[2,]<Thompson.threshold)]<-TRUE
    
    pv.mat[1,]<-pv.mat[2,]
    correction.strong[1,]<-correction.strong[2,]
    
    # Update mean and sd
    
    list2<-list(spike.weight=spike.weight,bl=bl,cruns=cruns,SEPARATION=SEPARATION,y=y,
                design0=design0,cBA=cBA)   
    if(!SPIKESLAB)update<-posterior(list2,samp=TRUE) # BA first
    if(SPIKESLAB)update<-posterior.spike.slab(list2,samp=TRUE) # BA first
    post.mean.temp[bl+1,]<-update$update.mean
    post.median.temp[bl+1,]<-update$update.median
    post.sd.temp[bl+1,]<-update$update.sd
    p.post.mean.temp[bl+1,]<-update$update.mean.p
    p.post.sd.temp[bl+1,]<-update$update.sd.p
    est.form.temp[bl+1]<-update$update.est
    post.prob.temp[bl+1,]<-update$update.post.prob
    cBA<-update$BA
    post.sample<-update$post.sample
    if(SPIKESLAB)spike.weight<-update$spike.weight
  }
    
    design0<-cbind(rep(1,nrow(design)),design)
    p<-pnorm(design0%*%b)
  
  
  return(list(Thompson.strong=Thompson.strong,
              design=design,RSTOP=RSTOP,p=p,y=y,k1=k1,f1=f1,
              start.Thompson=start.Thompson,
              post.mean.temp=post.mean.temp,post.median.temp=post.median.temp,post.sd.temp=post.sd.temp,
              est.form.temp=est.form.temp,cBA=cBA,spike.weight=spike.weight,
              SEPARATION=SEPARATION,post.sample=post.sample,
              post.prob.temp=post.prob.temp,pv.type2=pv.type2,
              pv.type=pv.type,pv.mat2=pv.mat2,
              p.post.mean.temp=p.post.mean.temp,
              p.post.sd.temp=p.post.sd.temp,direc.temp=direc.temp))
}