# A/B test

K<-1
F<-0
b.mat<-as.matrix(rbind(c(-2.2,0),c(-2.2,0),c(-2.2,0),c(-2.2,0),c(-2.2,0),c(-2.2,0),
                       c(-2.2,0.05),
                       c(-2.2,0.1),
                       c(-2.2,0.2),
                       c(-2.2,0.3)))
correction.threshold<-0.1
Thompson.threshold<-0.05
max.blocks<-128 # for 10 factors sim, otherwise 150

n=10000
var<-5
cov_mtrx<-as.matrix(Diagonal(x=rep(var,K+1)))
mu<-c(qnorm(0.01),rep(0,K))
SPIKESLAB<-FALSE

cutoff<-0.1
max.w<-0.2
c.inc<-0.1
c.dec<-0.02
max.w.tail<-0.07
min.w.tail<-0.07
tail<-0.01*n
tail1<-0.05*n
resample.count<-50
max.tail.shift<-0.3
max.wobble<-0.15
# b.mat<-as.matrix(rbind(c(-1.5,0.05),
#                        c(-1.5,0.1),
#                        c(-1.5,0.2),
#                        c(-1.5,0.3)))


runs<-16
cruns<-16
ca<-10
IT<-100

AB.test <- function(b){ # b = (b_0,b_1)
  post.mean.temp<-matrix(ncol=K+1,nrow=max.blocks+1)
  post.sd.temp<-matrix(ncol=K+1,nrow=max.blocks+1)
  p.post.mean.temp<-matrix(ncol=2^K,nrow=max.blocks+1)
  p.post.sd.temp<-matrix(ncol=2^K,nrow=max.blocks+1)
  # post.sample<-l$post.sample
  # spike.weight<-l$spike.weight 
  post.prob.temp<-matrix(ncol=K+1,nrow=max.blocks+1)

  pv <- rep(NA,max.blocks)
  sum.p <- rep(NA,max.blocks)
  # eqalloc <- sample(c(-1,1),2*runs*max.blocks,replace = T)
  # balanced design:
  eqalloc <- rep(c(1,-1),(max.blocks*2*runs)/2)
  p <- pnorm(b[1] + eqalloc*b[2])
  y <- rbinom(length(p),1,p)
  
  bl <- 1
  current.block.index <- c((2*runs*(bl-1)+1):(2*runs*bl))
  sum.p[bl] <- sum(p[current.block.index])
  all.data.to.block<-c(1:(bl*2*runs))
  cy <- y[all.data.to.block]
  cx <- eqalloc[all.data.to.block]
  data1<-as.data.frame(cbind(cy,cx))
  colnames(data1)<-c("y","x")
  cfmula <- as.formula(paste("y ~ x"))
  fit<-reg.fit.possible(data=data1,fmula=cfmula)
  SEPARATION<-fit$error | fit$warnings | sum(cy)==0 
  if(sum(cy)==0){
    pv[bl]<-1
  }
  if(sum(cy)>0){
    if(SEPARATION){
      ft<-fisher.test(cx,cy)
      pv[bl]<-ft$p.value
    }
    if(!SEPARATION){
      ft<-fisher.test(cx,cy)
      g<-glm(cfmula,data=data1,family = binomial(link = "probit"))  
      pv[bl]<-min(ft$p.value,coef(summary(g))[2,4])
    }
  }
  list2<-list(spike.weight=0,bl=bl,cruns=cruns,SEPARATION=SEPARATION,y=cy,design0=cbind(rep(1,length(cx)),cx))   
  if(!SPIKESLAB)update<-posterior(list2,samp=FALSE) # BA first
  if(SPIKESLAB)update<-posterior.spike.slab(list2,samp=FALSE) # BA first
  
  post.mean.temp[1:2,]<-update$update.mean
  post.sd.temp[1:2,]<-update$update.sd
  p.post.mean.temp[1:2,]<-update$update.mean.p
  p.post.sd.temp[1:2,]<-update$update.sd.p
  post.prob.temp[1:2,]<-update$update.post.prob
  cBA<-update$BA
  if(SPIKESLAB) spike.weight<-update$spike.weight
  
  
  for(bl in 2:max.blocks){
    current.block.index <- c((2*runs*(bl-1)+1):(2*runs*bl))
    sum.p[bl] <- sum(p[current.block.index])
    all.data.to.block<-c(1:(bl*2*runs))
    cy <- y[all.data.to.block]
    cx <- eqalloc[all.data.to.block]
    data1<-as.data.frame(cbind(cy,cx))
    colnames(data1)<-c("y","x")
    cfmula <- as.formula(paste("y ~ x"))
    fit<-reg.fit.possible(data=data1,fmula=cfmula)
    SEPARATION<-fit$error | fit$warnings | sum(cy)==0 
    if(sum(cy)==0){
      pv[bl]<-1
    }
    if(sum(cy)>0){
      if(SEPARATION){
        ft<-fisher.test(cx,cy)
        pv[bl]<-ft$p.value
      }
      if(!SEPARATION){
        ft<-fisher.test(cx,cy)
        g<-glm(cfmula,data=data1,family = binomial(link = "probit"))  
        pv[bl]<-min(ft$p.value,coef(summary(g))[2,4])
      }
    }
    list2<-list(spike.weight=0,bl=bl,cruns=cruns,cBA=cBA, SEPARATION=SEPARATION,y=cy,design0=cbind(rep(1,length(cx)),cx))   
    if(!SPIKESLAB)update<-posterior(list2,samp=FALSE) # BA first
    if(SPIKESLAB)update<-posterior.spike.slab(list2,samp=FALSE) # BA first
    
    post.mean.temp[bl+1,]<-update$update.mean
    post.sd.temp[bl+1,]<-update$update.sd
    p.post.mean.temp[bl+1,]<-update$update.mean.p
    p.post.sd.temp[bl+1,]<-update$update.sd.p
    post.prob.temp[bl+1,]<-update$update.post.prob
    cBA<-update$BA
    if(SPIKESLAB) spike.weight<-update$spike.weight
    
    #if (post.prob.temp[bl+1,2] > 0.975) break
    
  }
  
  return(list(p=p, y=y, pv.temp=pv,
             post.mean.temp=post.mean.temp,post.sd.temp=post.sd.temp,
              cBA=cBA,spike.weight=spike.weight,
              post.prob.temp=post.prob.temp,
              p.post.mean.temp=p.post.mean.temp,
              p.post.sd.temp=p.post.sd.temp))
  
}


pv.AB.ar<-array(dim=c(IT,max.blocks,K,ca))
n.suc.AB<-matrix(ncol=ca,nrow=IT)
sum.p.AB<-array(NA,dim=c(max.blocks,IT,ca))

mean.sum.p.AB<-matrix(nrow=max.blocks,ncol=ca)
sd.sum.p.AB<-matrix(nrow=max.blocks,ncol=ca)
post.mean.AB.ar<-array(NA,dim=c(IT,max.blocks+1,K+1,ca))
post.sd.AB.ar<-array(NA,dim=c(IT,max.blocks+1,K+1,ca))
p.post.mean.AB.ar<-array(NA,dim=c(IT,max.blocks+1,2^K,ca))
p.post.sd.AB.ar<-array(NA,dim=c(IT,max.blocks+1,2^K,ca))
post.prob.AB.ar<-array(NA,dim=c(IT,max.blocks+1,K+1,ca))
spike.weight <- 0

for (B in 1:ca){ 
  print(B)
  b <- b.mat[B,]
  for (it in 1:IT){
    print(it)
    l <- AB.test(b=b)

    post.mean.AB.ar[it,,,B]<-l$post.mean.temp
    post.sd.AB.ar[it,,,B]<-l$post.sd.temp
    p.post.mean.AB.ar[it,,,B]<-l$p.post.mean.temp
    p.post.sd.AB.ar[it,,,B]<-l$p.post.sd.temp
    pv.AB.ar[it,,,B]<-l$pv.temp
    post.prob.AB.ar[it,,,B]<-l$post.prob.temp
    n.suc.AB[it,B]<-sum(l$y)
    
  }
  #mean.sum.p.AB[,B]<-apply(sum.p.AB[,,B],2,mean) #= constant
  #sd.sum.p.AB[,B]<-apply(sum.p.AB[,,B],2,sd)  # = zero
  
}

