library(MASS)
library(Matrix) 
library(mvtnorm)
library(safeBinaryRegression)
# library(matrixStats)
library(Hmisc)


# Parameters
################

# choose K, F, b

K<-5
F<-1
correction.threshold<-0.1
Thompson.threshold<-0.05
pw.threshold <- 0.975
max.blocks<-150

n=10000
var<-5
cov_mtrx<-as.matrix(Diagonal(x=rep(var,K+1)))
mu<-c(qnorm(0.01),rep(0,K))
SPIKESLAB<-FALSE

cutoff<-0.1
max.w<-0.2
c.inc<-0.1
c.dec<-0.02
max.w.tail<-0.07
min.w.tail<-0.07
tail<-0.01*n
tail1<-0.05*n
resample.count<-50
max.tail.shift<-0.3
max.wobble<-0.15
max.wobble.pw<-0.90

IND.10.6<-cbind(seq(from=1,to=63,by=2),seq(from=2,to=64,by=2))
IND.9.5<-cbind(seq(from=1,to=31,by=2),seq(from=2,to=32,by=2))

#######################################################
# Iterations of FFD + Thompson
#######################################################

runs<-2^(K-F)
ca<-4
IT<-100
b.mat<-as.matrix(rbind(c(-2.2,0.05,0,0,0,0),
                       c(-2.2,0.1,0,0,0,0),
                       c(-2.2,0.2,0,0,0,0),
                       c(-2.2,0.3,0,0,0,0)))


# FFD + Thompson
#################
sum.p.FFD<-array(NA,dim=c(max.blocks,IT,ca))
prop.1.FFD<-array(NA,dim=c(IT,max.blocks,K,ca))
cum.prop.1.FFD<-array(NA,dim=c(IT,max.blocks,K,ca))
prop.Thompson.FFD<-array(NA,dim=c(IT,max.blocks,K,ca))
best.sum.p<-matrix(ncol=ca,nrow=max.blocks)
mean.sum.p.FFD<-matrix(nrow=max.blocks,ncol=ca)
sd.sum.p.FFD<-matrix(nrow=max.blocks,ncol=ca)
post.mean.FFD.ar<-array(NA,dim=c(IT,max.blocks+1,K+1,ca))
post.median.FFD.ar<-array(NA,dim=c(IT,max.blocks+1,K+1,ca))
post.sd.FFD.ar<-array(NA,dim=c(IT,max.blocks+1,K+1,ca))
p.post.mean.FFD.ar<-array(NA,dim=c(IT,max.blocks+1,2^K,ca))
p.post.mean2.FFD.ar<-array(NA,dim=c(IT,max.blocks+1,2^K,ca))
p.post.sd.FFD.ar<-array(NA,dim=c(IT,max.blocks+1,2^K,ca))
est.form.FFD<-array(NA,dim=c(IT,max.blocks+1,ca))
post.prob.FFD.ar<-array(NA,dim=c(IT,max.blocks+1,K+1,ca))
Thompson.first<-array(NA,dim=c(IT,K,ca))
Thompson.FFD.ar<-array(dim=c(IT,max.blocks,ca)) # only for b1
pv.FFD.ar<-array(dim=c(IT,max.blocks,K,ca))
n.suc.FFD<-matrix(ncol=ca,nrow=IT)

full.design0<-matrix(ncol=K+1,nrow=2^K) 
full.design0[,1]<-rep(1,2^K)
for(i in 1:K){
  xx<-c(rep(1,2^(K-i)),rep(-1,2^(K-i)))
  full.design0[,i+1]<-rep(xx,2^(i-1))
}
p.mat<-matrix(nrow=2^K,ncol=ca)
for(B in 1:ca){
  for(j in 1:(2^K)){
    p.mat[j,B]<-pnorm(full.design0[j,]%*%b.mat[B,])
  }
}

for(B in 1:ca){
  b<-b.mat[B,]
  for(it in 1:IT){
    print(it)
    LIK.0<-FALSE
    RESAMPLE<-FALSE
    pv.mat<-rep(NA,K)
    correction.strong<-rep(FALSE,K)
    Thompson.strong<-matrix(FALSE,nrow=max.blocks,ncol=K)
    design<-c()
    play.variables<-c()
    y<-c()
    ind.strong<-c()
    start.Thompson<-c()
    RSTOP<-c(NA,NA,"NA")
    SEPARATION<-TRUE
    b.samples.temp<-matrix(nrow=n,ncol=max.blocks+1)
    post.mean.temp<-matrix(ncol=K+1,nrow=max.blocks+1)
    post.median.temp<-matrix(ncol=K+1,nrow=max.blocks+1)
    post.sd.temp<-matrix(ncol=K+1,nrow=max.blocks+1)
    p.post.mean.temp<-matrix(ncol=2^K,nrow=max.blocks+1)
    p.post.sd.temp<-matrix(ncol=2^K,nrow=max.blocks+1)
    est.form.temp<-rep(NA,max.blocks+1)
    post.prob.temp<-matrix(ncol=K+1,nrow=max.blocks+1)
    pv.temp<-matrix(ncol=K,nrow=max.blocks)
    spike.weight<-matrix(ncol=K,nrow=max.blocks+1)
    start.block<-1
    start.Thompson<-0
    l<-list(pv.mat=pv.mat,correction.strong=correction.strong,Thompson.strong=Thompson.strong,
            design=design,start.block=start.block,k=K,f=F,y=y,ind.strong=ind.strong,
            RSTOP=RSTOP,start.Thompson=start.Thompson,SEPARATION=SEPARATION,
            post.mean.temp=post.mean.temp,post.median.temp=post.median.temp,post.sd.temp=post.sd.temp,
            est.form.temp=est.form.temp,post.prob.temp=post.prob.temp,
            spike.weight=spike.weight,b.samples.temp=b.samples.temp,
            p.post.mean.temp=p.post.mean.temp,p.post.sd.temp=p.post.sd.temp,
            pv.temp=pv.temp)
    for(u in 1:max.blocks){
      if(length(l$ind.strong)==0){
        l<-FFD.pw(l,start.block)
        (play.variables<-cbind(play.variables,l$RSTOP))
        (number.of.strong<-length(l$ind.strong))
        (l$k1<-K-number.of.strong)
        (l$f1<-F-number.of.strong)
        (start.block<-l$start.Thompson+1)
      }
      if(length(l$ind.strong)!=0){
        l<-FFD.T.pw(l,start.block)
        (play.variables<-cbind(play.variables,l$RSTOP))
        (number.of.strong<-length(l$ind.strong))
        (l$k1<-K-number.of.strong)
        (l$f1<-F-number.of.strong)
        (start.block<-l$start.Thompson+1)
      }
      if(start.block!=max.blocks+1)u<-u+1
      if(start.block==max.blocks+1)break
    }
    for(bl in 1:max.blocks){
      block.ind<-c(((bl-1)*2*runs+1):(bl*2*runs))
      sum.p.FFD[bl,it,B]<-sum(pnorm(cbind(rep(1,dim(l$design[block.ind,])[1]),l$design[block.ind,])%*%b))
      if(bl==1)prop.Thompson.FFD[it,bl,,B]<-as.numeric(l$Thompson.strong[1,])
      if(bl>1)prop.Thompson.FFD[it,bl,,B]<-apply(l$Thompson.strong[1:bl,],2,mean)
      
      for(j in 1:K){
        prop.1.FFD[it,bl,j,B]<-prop1(l$design[block.ind,j])
        cum.prop.1.FFD[it,bl,j,B]<-prop1(l$design[1:(bl*2*runs),j])}
      
      # counts<-apply(full.design0[,-1],1,count.comb.suc,x=l$design[1:(bl*2*runs),],y=l$y[1:(bl*2*runs)])
      # for(comb in 1:(2^K)){
      #   n.arm[it,bl,comb,B]<-counts[[comb]]$n.comb
      #   s.arm[it,bl,comb,B]<-counts[[comb]]$n.suc
      #   }
    }
    # for(bl in 1:(max.blocks+1)){
      # for (comb in 1:(2^K)){
      #   p.post.mean2.FFD.ar[it,bl,comb,B]<-pnorm(full.design0[comb,]%*%l$post.mean.temp[bl,])
      # }
    # }
    post.mean.FFD.ar[it,,,B]<-l$post.mean.temp
    post.median.FFD.ar[it,,,B]<-l$post.median.temp
    post.sd.FFD.ar[it,,,B]<-l$post.sd.temp
    p.post.mean.FFD.ar[it,,,B]<-l$p.post.mean.temp
    p.post.sd.FFD.ar[it,,,B]<-l$p.post.sd.temp
    est.form.FFD[it,,B]<-l$est.form.temp
    pv.FFD.ar[it,,,B]<-l$pv.temp
    post.prob.FFD.ar[it,,,B]<-l$post.prob.temp
    Thompson.first[it,,B]<-compute.Thompson.first(l$Thompson.strong)
    Thompson.FFD.ar[it,,B]<-l$Thompson.strong[,1]
    n.suc.FFD[it,B]<-sum(l$y)
    
  } # end of loop iterations
  
  # Averaging over all iterations for one case
  
  full.design0<-matrix(ncol=K+1,nrow=2^K) 
  full.design0[,1]<-rep(1,2^K)
  for(i in 1:K){
    xx<-c(rep(1,2^(K-i)),rep(-1,2^(K-i)))
    full.design0[,i+1]<-rep(xx,2^(i-1))
  }
  p.mat[,B]<-pnorm(full.design0%*%b.mat[B,])
  best.sum.p[,B]<-rep(max(unique(p.mat[,B]))*2*runs,max.blocks)
  mean.sum.p.FFD[,B]<-apply(sum.p.FFD[,,B],1,mean)
  sd.sum.p.FFD[,B]<-apply(sum.p.FFD[,,B],1,sd)
  
} # end of loop cases


# Only Thompson
#################
sum.p.T<-array(NA,dim=c(max.blocks,IT,ca))
prop.1.T<-array(NA,dim=c(IT,max.blocks,K,ca))
cum.prop.1.T<-array(NA,dim=c(IT,max.blocks,K,ca))
mean.sum.p.T<-matrix(ncol=ca,nrow=max.blocks)
sd.sum.p.T<-matrix(ncol=ca,nrow=max.blocks)
post.mean.T.ar<-array(NA,dim=c(IT,max.blocks+1,K+1,ca))
post.median.T.ar<-array(NA,dim=c(IT,max.blocks+1,K+1,ca))
post.sd.T.ar<-array(NA,dim=c(IT,max.blocks+1,K+1,ca))
p.post.mean.T.ar<-array(NA,dim=c(IT,max.blocks+1,2^K,ca))
p.post.mean2.T.ar<-array(NA,dim=c(IT,max.blocks+1,2^K,ca))
p.post.sd.T.ar<-array(NA,dim=c(IT,max.blocks+1,2^K,ca))
est.form.T<-array(NA,dim=c(IT,max.blocks+1,ca))
post.prob.T.ar<-array(NA,dim=c(IT,max.blocks+1,K+1,ca))
pv.T.ar<-array(dim=c(IT,max.blocks,K,ca))
n.suc.T<-matrix(ncol=ca,nrow=IT)



for(B in 1:ca){
  b<-b.mat[B,]
  for(it in 1:IT){
    print(it)
    LIK.0<-FALSE
    RESAMPLE<-FALSE
    SEPARATION<-TRUE
    
    l<-list(K=K,F=F)
    sim<-Only.Thompson(l)
    for(bl in 1:max.blocks){
      block.ind<-c(((bl-1)*2*runs+1):(bl*2*runs))
      sum.p.T[bl,it,B]<-sum(pnorm(sim$design0[block.ind,]%*%b))
      for(j in 1:K){
        prop.1.T[it,bl,j,B]<-prop1(sim$design0[block.ind,j+1])
        cum.prop.1.T[it,bl,j,B]<-prop1(sim$design0[1:(bl*2*runs),j+1])}
    }
    for(bl in 1:(max.blocks+1)){
      for (comb in 1:(2^K)){
        p.post.mean2.T.ar[it,bl,comb,B]<-pnorm(full.design0[comb,]%*%sim$post.mean.temp[bl,])
      }
    }
    
    post.mean.T.ar[it,,,B]<-sim$post.mean.temp
    post.median.T.ar[it,,,B]<-sim$post.median.temp
    post.sd.T.ar[it,,,B]<-sim$post.sd.temp
    p.post.mean.T.ar[it,,,B]<-sim$p.post.mean.temp
    p.post.sd.T.ar[it,,,B]<-sim$p.post.sd.temp
    est.form.T[it,,B]<-sim$est.form.temp
    pv.T.ar[it,,,B]<-sim$pv.temp
    post.prob.T.ar[it,,,B]<-sim$post.prob.temp
    n.suc.T[it,B]<-sum(sim$y)
    
  } # end of loop iterations
  
  # Averaging over all iterations for one case
  
  mean.sum.p.T[,B]<-apply(sum.p.T[,,B],1,mean)
  sd.sum.p.T[,B]<-apply(sum.p.T[,,B],1,sd)
  
} # end of loop cases

#####
# MVT
#####
sum.p.RAN<-array(NA,dim=c(max.blocks,IT,ca))
prop.1.RAN<-array(NA,dim=c(IT,max.blocks,K,ca))
cum.prop.1.RAN<-array(NA,dim=c(IT,max.blocks,K,ca))
mean.sum.p.RAN<-matrix(ncol=ca,nrow=max.blocks)
sd.sum.p.RAN<-matrix(ncol=ca,nrow=max.blocks)
post.mean.RAN.ar<-array(NA,dim=c(IT,max.blocks+1,K+1,ca))
post.median.RAN.ar<-array(NA,dim=c(IT,max.blocks+1,K+1,ca))
post.sd.RAN.ar<-array(NA,dim=c(IT,max.blocks+1,K+1,ca))
p.post.mean.RAN.ar<-array(NA,dim=c(IT,max.blocks+1,2^K,ca))
p.post.mean2.RAN.ar<-array(NA,dim=c(IT,max.blocks+1,2^K,ca))
p.post.sd.RAN.ar<-array(NA,dim=c(IT,max.blocks+1,2^K,ca))
est.form.RAN<-array(NA,dim=c(IT,max.blocks+1,ca))
post.prob.RAN.ar<-array(NA,dim=c(IT,max.blocks+1,K+1,ca))
pv.RAN.ar<-array(dim=c(IT,max.blocks,K,ca))
n.suc.RAN<-matrix(ncol=ca,nrow=IT)

for(B in 1:ca){
  b<-b.mat[B,]
  for(it in 1:IT){
    print(it)
    LIK.0<-FALSE
    RESAMPLE<-FALSE
    SEPARATION<-TRUE
    
    l<-list(K=K,F=F)
    sim<-RANDES(l)
    for(bl in 1:max.blocks){
      block.ind<-c(((bl-1)*2*runs+1):(bl*2*runs))
      sum.p.RAN[bl,it,B]<-sum(pnorm(sim$design0[block.ind,]%*%b))
      for(j in 1:K){
        prop.1.RAN[it,bl,j,B]<-prop1(sim$design0[block.ind,j+1])
        cum.prop.1.RAN[it,bl,j,B]<-prop1(sim$design0[1:(bl*2*runs),j+1])}
    }
    for(bl in 1:(max.blocks+1)){
      for (comb in 1:(2^K)){
        p.post.mean2.RAN.ar[it,bl,comb,B]<-pnorm(full.design0[comb,]%*%sim$post.mean.temp[bl,])
      }
    }
    
    post.mean.RAN.ar[it,,,B]<-sim$post.mean.temp
    post.median.RAN.ar[it,,,B]<-sim$post.median.temp
    post.sd.RAN.ar[it,,,B]<-sim$post.sd.temp
    p.post.mean.RAN.ar[it,,,B]<-sim$p.post.mean.temp
    p.post.sd.RAN.ar[it,,,B]<-sim$p.post.sd.temp
    est.form.RAN[it,,B]<-sim$est.form.temp
    pv.RAN.ar[it,,,B]<-sim$pv.temp
    post.prob.RAN.ar[it,,,B]<-sim$post.prob.temp
    n.suc.RAN[it,B]<-sum(sim$y)
    
  } # end of loop iterations
  
  # Averaging over all iterations for one case
  
  mean.sum.p.RAN[,B]<-apply(sum.p.RAN[,,B],1,mean)
  sd.sum.p.RAN[,B]<-apply(sum.p.RAN[,,B],1,sd)
  
} # end of loop cases

mean.sum.p.AB<-matrix(ncol=ca,nrow=max.blocks)
for (B in 1:ca){
  mean.sum.p.AB[,B] <- apply(sum.p.AB[,,B],2,mean)
}
#################################################
# Regret

R.FFD <- array(NA,dim=c(max.blocks,IT,ca))
R.T <- array(NA,dim=c(max.blocks,IT,ca))
R.AB <- array(NA,dim=c(max.blocks,IT,ca))
R.MVT <- array(NA,dim=c(max.blocks,IT,ca))

mean.R.FFD <- matrix(NA,ncol=ca,nrow=max.blocks)
mean.R.T <- matrix(NA,ncol=ca,nrow=max.blocks)
mean.R.AB <- matrix(NA,ncol=ca,nrow=max.blocks)
mean.R.MVT <- matrix(NA,ncol=ca,nrow=max.blocks)

cum.R.FFD <- matrix(NA,ncol=ca,nrow=max.blocks)
cum.R.T <- matrix(NA,ncol=ca,nrow=max.blocks)
cum.R.AB <- matrix(NA,ncol=ca,nrow=max.blocks)
cum.R.MVT <- matrix(NA,ncol=ca,nrow=max.blocks)


for (B in 1:ca){
  for(it in 1:IT){
    R.FFD[,it,B] <- best.sum.p[,B] - sum.p.FFD[,it,B]
    R.T[,it,B] <- best.sum.p[,B] - sum.p.T[,it,B]
    R.AB[,it,B] <- best.sum.p[,B] - sum.p.AB[it,,B]
    R.MVT[,it,B] <- best.sum.p[,B] - sum.p.RAN[,it,B]
    
  }
  mean.R.FFD[,B] <- apply(R.FFD[,,B],1,mean)
  mean.R.T[,B] <- apply(R.T[,,B],1,mean)
  mean.R.AB[,B] <- apply(R.AB[,,B],1,mean)
  mean.R.MVT[,B] <- apply(R.MVT[,,B],1,mean)
  cum.R.FFD[,B] <- cumsum(mean.R.FFD[,B])
  cum.R.T[,B] <- cumsum(mean.R.T[,B])
  cum.R.AB[,B] <- cumsum(mean.R.AB[,B])
  cum.R.MVT[,B] <- cumsum(mean.R.MVT[,B])
  
}



#################################################
# Plots & Diagnostics

{
  pdf("plot1a - Regret comparison (+FFD1).pdf", width=7, height=7)
  par(mfcol=c(2,2))
  per <- c(1,3,2,4)
  for(B in per){
    maxy<-max(mean.R.FFD[,B],mean.R.T[,B],mean.R.AB[,B])
    plot(mean.R.FFD[,B]~seq(max.blocks),type="l",lty=1,lwd=2,
         ylim=c(0,maxy),xlab="Blocks",ylab="Expected Loss",
         main=paste("Effect Size =",b.mat[B,2]),
         cex.axis=1,cex.lab=1,cex.main=1)
    abline(h=unique(mean.R.MVT[,B]),lty=1,lwd=2,col="grey")
    lines(mean.R.T[,B]~seq(max.blocks),lty=2,lwd=2)
    lines(mean.R.AB[,B]~seq(max.blocks),lty=3,lwd=2.5)
    lines(mean.R.FFD1[,B]~seq(max.blocks),lty=1,lwd=2,col="blue")
    
    # if(B==1 | B==2)legend("bottomleft", ncol=1,
    #                       c("FFD + TS","TS","OFAT","MVT"),
    #                       lty=c(1,2,3,1),cex=0.8,lwd=c(1.5,1.5,2,1.5),col=c(rep("black",3),"grey"))
    # if(B==3 | B==4)legend(90,maxy*0.8, ncol=1,
    #                       c("FFD + TS","TS","OFAT","MVT"),
    #                       lty=c(1,2,3,1),cex=0.8,lwd=c(1.5,1.5,2,1.5),col=c(rep("black",3),"grey"))
    if(B==1 | B==2)legend("bottomleft", ncol=1,
                          c("FFD1 + TS","FFD + TS","TS","OFAT","MVT"),
                          lty=c(1,1,2,3,1),cex=0.8,lwd=c(1.5,1.5,1.5,2,1.5),col=c("blue",rep("black",3),"grey"))
    if(B==3 | B==4)legend(90,maxy*0.8, ncol=1,
                          c("FFD1 + TS","FFD + TS","TS","OFAT","MVT"),
                          lty=c(1,1,2,3,1),cex=0.8,lwd=c(1.5,1.5,1.5,2,1.5),col=c("blue",rep("black",3),"grey"))
    
  }
  
  dev.off()
}

{
  pdf("plot1b - cumulative Regret comparison (+FFD1).pdf", width=7, height=7)
  par(mfcol=c(2,2))
  per <- c(1,3,2,4)
  for(B in per){
    maxy<-max(cum.R.FFD[max.blocks,B],cum.R.FFD1[max.blocks,B],cum.R.T[max.blocks,B],cum.R.AB[max.blocks,B])
    plot(cum.R.FFD[,B]~seq(max.blocks),type="l",lty=1,lwd=2,
         ylim=c(0,maxy),xlab="Blocks",ylab="Cumulative expected regret",
         main=paste("Effect Size =",b.mat[B,2]),
         cex.axis=1,cex.lab=1,cex.main=1)
    lines(cum.R.FFD1[,B]~seq(max.blocks),lty=1,lwd=2,col="blue")
    lines(cum.R.MVT[,B]~seq(max.blocks),lty=1,lwd=2,col="grey")
    lines(cum.R.T[,B]~seq(max.blocks),lty=2,lwd=2)
    lines(cum.R.AB[,B]~seq(max.blocks),lty=3,lwd=2.5)
    
    legend("topleft", ncol=1,
                          c("FFD1 + TS","FFD + TS","TS","OFAT","MVT"),
                          lty=c(1,1,2,3,1),cex=0.8,lwd=c(1.5,1.5,1.5,2,1.5),col=c("blue",rep("black",3),"grey"))
  } 
  dev.off()
}


# Number of realized conversions comparison

apply(n.suc.FFD,2,mean)
apply(n.suc.T,2,mean)
apply(n.suc.AB,2,mean)
apply(n.suc.RAN,2,mean)

# Number of expected conversions comparison
expconv <- matrix(NA,ncol=4,nrow=4)
expconv <- as.data.frame(expconv)
rownames(expconv) <- as.character(b.mat[,2])
colnames(expconv) <- c("FFD","T","MVT","AB")

for(B in 1:ca){
  expconv$FFD[B] <- cumsum(mean.sum.p.FFD[,B])[150]
  expconv$T[B] <-cumsum(mean.sum.p.T[,B])[150]
  expconv$MVT[B] <-cumsum(mean.sum.p.RAN[,B])[150]
  expconv$AB[B] <-cumsum(mean.sum.p.AB[,B])[150]
}
expconv

# Time until identification of effect
#####################################

# Option a - median pv
{
median.pv.b1.FFD <-matrix(NA,nrow = max.blocks,ncol = ca)
median.pv.b1.T <-matrix(NA,nrow = max.blocks,ncol = ca)
median.pv.b1.AB <-matrix(NA,nrow = max.blocks,ncol = ca)

for (B in 1:ca){
  median.pv.b1.FFD[,B] <- apply(pv.FFD.ar[,,1,B],2,median)
  median.pv.b1.T[,B] <- apply(pv.T.ar[,,1,B],2,median)
  median.pv.b1.AB[,B] <- apply(pv.AB.ar[,,1,B],2,median)
}

pdf("plot2a - time.pdf", width=5, height=5)
par(mfcol=c(2,2))
for(B in c(1,3,2,4)){
  # miny<-min(median.pv.b1.FFD[,B],median.pv.b1.T[,B],median.pv.b1.AB[,B])
  plot(median.pv.b1.FFD[,B] ~ seq(max.blocks),type="l",lty=1,
       xlab="Blocks",ylab="P-value",ylim=c(0.01,1),
       main=paste("Effect Size =",b.mat[B,2]),
       cex.axis=0.8,cex.lab=0.8,cex.main=0.8,log="y")
  lines(median.pv.b1.T[,B] ~ seq(max.blocks),lty=2)
  lines(median.pv.b1.AB[,B] ~ seq(max.blocks),lty=3)
  abline(h=0.05)
  # legend(110,0.6*maxy, ncol=1,box.col="white",
  #      c("FFD + TS","TS","Random"),
  #      lty=c(1,2,3),cex=0.7)
}

dev.off()
}


times.FFD <- matrix(NA,ncol=ca,nrow=IT)
times.FFD1 <- matrix(NA,ncol=ca,nrow=IT)
times.T <- matrix(NA,ncol=ca,nrow=IT)
times.AB <- matrix(NA,ncol=ca,nrow=IT)
times.MVT <- matrix(NA,ncol=ca,nrow=IT)

direc.FFD <- matrix(NA,ncol=ca,nrow=IT)
direc.T <- matrix(NA,ncol=ca,nrow=IT)
direc.AB <- matrix(NA,ncol=ca,nrow=IT)
direc.MVT <- matrix(NA,ncol=ca,nrow=IT)


for(B in 1:ca){
  times.FFD[,B] <- compute.Thompson.first(t(pv.FFD.ar[,,1,B]<0.05))
  times.T[,B] <- compute.Thompson.first(t(pv.T.ar[,,1,B]<0.05))
  times.AB[,B] <- compute.Thompson.first(t(pv.AB.ar[,,1,B]<0.05))
  times.MVT[,B] <- compute.Thompson.first(t(pv.RAN.ar[,,1,B]<0.05))
  # times.T[,B] <- apply(post.prob.T.ar[,,2,B],1,high.post.w,direc="pos")
  # times.FFD[,B] <- apply(post.prob.FFD.ar[,,2,B],1,high.post.w,direc="pos")
  # times.AB[,B] <- apply(post.prob.AB.ar[,,2,B],1,high.post.w,direc="pos")
  # times.MVT[,B] <- apply(post.prob.RAN.ar[,,2,B],1,high.post.w,direc="pos")
  # times.FFD1[,B] <- apply(post.prob.FFD1.ar[,,2,B],1,high.post.w,direc="pos")
  
  
  times.FFD[,B][times.FFD[,B]==-1] <- max.blocks + 1
  times.T[,B][times.T[,B]==-1] <- max.blocks + 1
  times.AB[,B][times.AB[,B]==-1] <- max.blocks + 1
  times.MVT[,B][times.MVT[,B]==-1] <- max.blocks + 1
  
  # Is the direction right?
  for (it in 1:IT){
    direc.FFD[it,B] <- ifelse(times.FFD[it,B]!=(max.blocks + 1),post.prob.FFD.ar[it,times.FFD[it,B],2,B] > 0.5,NA)
    direc.T[it,B] <- ifelse(times.T[it,B]!=(max.blocks + 1),post.prob.T.ar[it,times.T[it,B],2,B] > 0.5,NA)
    direc.AB[it,B] <- ifelse(times.AB[it,B]!=(max.blocks + 1),post.prob.AB.ar[it,times.AB[it,B],2,B] > 0.5,NA)
    direc.MVT[it,B] <- ifelse(times.MVT[it,B]!=(max.blocks + 1),post.prob.RAN.ar[it,times.MVT[it,B],2,B] > 0.5,NA)
    
  }

  times.FFD[,B][direc.FFD[,B]==0] <- max.blocks + 1
  times.T[,B][direc.T[,B]==0] <- max.blocks + 1
  times.AB[,B][direc.AB[,B]==0] <- max.blocks + 1
  times.MVT[,B][direc.MVT[,B]==0] <- max.blocks + 1
  

# option e - log normal qqplot

{
palBW <- c("black","ivory4","ivory3","white")
pal <-   c("mediumorchid4","lightseagreen","lightsalmon","olivedrab3","goldenrod2")
pdf("plot2e - time to identification.pdf", width=7, height=7)
par(mfcol=c(2,2))
for(B in c(1,3,2,4)){

  FFDpts <- qqnorm(times.FFD[,B], plot.it=FALSE)
  # FFD1pts <- qqnorm(times.FFD1[,B], plot.it=FALSE)
  Tpts <- qqnorm(times.T[,B], plot.it=FALSE)
  ABpts <- qqnorm(times.AB[,B], plot.it=FALSE)
  MVTpts <- qqnorm(times.MVT[,B], plot.it=FALSE)
  
  ind1 <- which(times.T[,B]!=151)
  ind2 <- which(times.FFD[,B]!=151)
  ind3 <- which(times.MVT[,B]!=151)
  ind4 <- which(times.AB[,B]!=151)
  # ind5 <- which(times.FFD1[,B]!=151)
  
  plot(Tpts$y[ind1] ~ Tpts$x[ind1],log="y",
       xlim=c(-2.8,2.8),ylim=c(1,150),
       col="black",pch=21,bg=pal[1],cex=0.9,
       # pch=16,col=pal[1],cex=0.5,
       # main = paste("Effect size = ",b.mat[B,2]),
       main = bquote(atop(beta[1]==.(b.mat[B,2]))),
       cex.main=1,cex.lab=0.9,cex.axis=0.9,
       ylab = "Time to identification (p-value < 0.05)",
       xlab = "Normal quantiles")
  points(MVTpts$y[ind3] ~ MVTpts$x[ind3],col="black",pch=21,bg=pal[3],cex=0.9)
  points(FFDpts$y[ind2] ~ FFDpts$x[ind2],col="black",pch=21,bg=pal[2],cex=0.9)
  points(ABpts$y[ind4] ~ ABpts$x[ind4],col="black",pch=21,bg=pal[4],cex=0.9)

  legend("bottomright",c("TS","FFD+TS","MVT","OFAT"),cex=0.9,
         pch=rep(21,4),col=rep("black",4),pt.bg=pal)
 # 
  # points(MVTpts$y[ind3] ~ MVTpts$x[ind3],pch=16,col=pal[3],cex=0.5)
  # points(ABpts$y[ind4] ~ ABpts$x[ind4],pch=16,col=pal[4],cex=0.5)
  # points(FFDpts$y[ind2] ~ FFDpts$x[ind2],pch=16,col=pal[5],cex=0.5)
  # points(Tpts$y[ind1] ~ Tpts$x[ind1],pch=16,col=pal[1],cex=0.5)
  # points(FFD1pts$y[ind5] ~ FFD1pts$x[ind5],pch=16,col=pal[2],cex=0.5)
  
  # legend("bottomright",c("TS","FFD1+TS","MVT","OFAT","FFD+TS"),cex=0.9,
  #        pch=rep(16,4),col=pal)
   
}
dev.off()
}


# time to false identification
################################
{
times.FFD4 <- matrix(NA,ncol=ca,nrow=IT)
times.T4 <- matrix(NA,ncol=ca,nrow=IT)
times.MVT4<- matrix(NA,ncol=ca,nrow=IT)
times.FFD5 <- matrix(NA,ncol=ca,nrow=IT)
times.T5 <- matrix(NA,ncol=ca,nrow=IT)
times.MVT5<- matrix(NA,ncol=ca,nrow=IT)
# times.AB <- matrix(NA,ncol=ca,nrow=IT) # AB doesn't have inert factors

for(B in 1:ca){
  times.FFD4[,B] <- apply(post.prob.FFD.ar[,,5,B],1,high.post.w)
  times.T4[,B] <- apply(post.prob.T.ar[,,5,B],1,high.post.w)
  times.MVT4[,B] <- apply(post.prob.RAN.ar[,,5,B],1,high.post.w)
  # times.FFD4[,B] <- compute.Thompson.first(t(pv.FFD.ar[,,4,B]<0.05))
  # times.T4[,B] <- compute.Thompson.first(t(pv.T.ar[,,4,B]<0.05))
  # times.MVT4[,B] <- compute.Thompson.first(t(pv.RAN.ar[,,4,B]<0.05))
  times.FFD5[,B] <- apply(post.prob.FFD.ar[,,6,B],1,high.post.w)
  times.T5[,B] <- apply(post.prob.T.ar[,,6,B],1,high.post.w)
  times.MVT5[,B] <- apply(post.prob.RAN.ar[,,6,B],1,high.post.w)
  # times.FFD5[,B] <- compute.Thompson.first(t(pv.FFD.ar[,,5,B]<0.05))
  # times.T5[,B] <- compute.Thompson.first(t(pv.T.ar[,,5,B]<0.05))
  # times.MVT5[,B] <- compute.Thompson.first(t(pv.RAN.ar[,,5,B]<0.05))
  
  # times.FFD4[,B][times.FFD4[,B]==-1] <- 150
  # # times.T4[,B][times.T4[,B]==-1] <- 150
  # times.MVT4[,B][times.MVT4[,B]==-1] <- 150
  # times.FFD5[,B][times.FFD5[,B]==-1] <- 150
  # # times.T5[,B][times.T5[,B]==-1] <- 150
  # times.MVT5[,B][times.MVT5[,B]==-1] <- 150
}

{
pal <- c("black","ivory3","white")
pdf("Time to false identification - all.pdf", width=7, height=7)
par(mfcol=c(2,2))
cex1 <- 0.7
for(B in c(1,3,2,4)){
  FFDpts4 <- qqnorm(times.FFD4[,B], plot.it=FALSE)
  Tpts4 <- qqnorm(times.T4[,B], plot.it=FALSE)
  MVTpts4 <- qqnorm(times.MVT4[,B], plot.it=FALSE)
  
  ind1 <- which(times.T4[,B]!=150)
  ind2 <- which(times.FFD4[,B]!=150)
  ind3 <- which(times.MVT4[,B]!=150)
  
  plot(Tpts4$y[ind1] ~ Tpts4$x[ind1],log="y",
       xlim=c(-2.8,2.8),ylim=c(1,150),
       col="black",pch=21,bg=pal[1],cex=cex1,
       main = bquote(atop("Inert factor x4",beta[1]==.(b.mat[B,2]))),
       cex.main=1.2,cex.lab=1,cex.axis=1,
       ylab = "Time to (false) identification",
       xlab = "Normal quantiles")
  points(FFDpts4$y[ind2] ~ FFDpts4$x[ind2],col="black",pch=21,bg=pal[2],cex=cex1)
  points(MVTpts4$y[ind3] ~ MVTpts4$x[ind3],col="black",pch=21,bg=pal[3],cex=cex1)
  
  legend("bottomright",c("TS","FFD+TS","MVT"),cex=1.1,
         col=c("black","black","black","black"),pch=c(21,21,21,21),pt.bg=pal)
}
  par(mfcol=c(2,2))
  for(B in c(1,3,2,4)){
  
  FFDpts5 <- qqnorm(times.FFD5[,B], plot.it=FALSE)
  Tpts5 <- qqnorm(times.T5[,B], plot.it=FALSE)
  MVTpts5 <- qqnorm(times.MVT5[,B], plot.it=FALSE)

  ind1 <- which(times.T5[,B]!=150)
  ind2 <- which(times.FFD5[,B]!=150)
  ind3 <- which(times.MVT5[,B]!=150)

  plot(Tpts5$y[ind1] ~ Tpts5$x[ind1],log="y",
     xlim=c(-2.8,2.8),ylim=c(1,150),
     col="black",pch=21,bg=pal[1],cex=cex1,
     main = bquote(atop("Inert factor x5",beta[1]==.(b.mat[B,2]))),
     cex.main=1.2,cex.lab=1,cex.axis=1,
     ylab = "Time to false identification (post w)",
     xlab = "Normal quantiles")
  points(FFDpts5$y[ind2] ~ FFDpts5$x[ind2],col="black",pch=21,bg=pal[2],cex=cex1)
  points(MVTpts5$y[ind3] ~ MVTpts5$x[ind3],col="black",pch=21,bg=pal[3],cex=cex1)

  legend("bottomright",c("TS","FFD+TS","MVT"),cex=1.1,
         col=c("black","black","black","black"),pch=c(21,21,21,21),pt.bg=pal)
  
}
dev.off()
}


# how long the experiment continued to use TS with most weight on the weaker choice --
# David's comment from July 2018 (Results dms)

}
  # False Identification Rate
  FIR <- function(x){
    x <- x[!is.na(x)]
    return(1-sum(x)/length(x))
  }
  
  # False Identification Count
  FIC <- function(x){
    return(sum(1 - x, na.rm = T))
  }
  
  apply(direc.FFD,2,FUN = FIR)
  apply(direc.T,2,FUN = FIR)
  apply(direc.AB,2,FUN = FIR)
  apply(direc.MVT,2,FUN = FIR)
  
  apply(direc.FFD,2,FUN = FIC)
  apply(direc.T,2,FUN = FIC)
  apply(direc.AB,2,FUN = FIC)
  apply(direc.MVT,2,FUN = FIC)
  
  
  
  times_false.FFD <- matrix(NA,ncol=ca,nrow=IT)
  times_false.T <- matrix(NA,ncol=ca,nrow=IT)
  times_false.AB <- matrix(NA,ncol=ca,nrow=IT)
  times_false.MVT <- matrix(NA,ncol=ca,nrow=IT)
  
  for(B in 1:ca){
    for(it in 1:IT){
      if(isTRUE(!direc.FFD[it,B])) times_false.FFD[it,B] <- sum(pv.FFD.ar[it,,1,B] < 0.05)
      if(isTRUE(!direc.AB[it,B])) times_false.AB[it,B] <- sum(pv.AB.ar[it,,1,B] < 0.05)
      if(isTRUE(!direc.T[it,B])) times_false.T[it,B] <- sum(pv.T.ar[it,,1,B] < 0.05)
      if(isTRUE(!direc.MVT[it,B])) times_false.MVT[it,B] <- sum(pv.RAN.ar[it,,1,B] < 0.05)
    }
  }
  
  apply(times_false.FFD,2,FUN = mean, na.rm = T)
  apply(times_false.T,2,FUN = mean, na.rm = T)
  apply(times_false.AB,2,FUN = mean, na.rm = T)
  apply(times_false.MVT,2,FUN = mean, na.rm = T)

  {
    pdf("Time to identification in the wrong direction - all.pdf", width=7, height=7)
    ltype <- c(1:4)
    cex1 <- 0.7
    FFDpts <- apply(times_false.FFD,2,FUN = mean, na.rm = T)
    Tpts <-   apply(times_false.T,2,FUN = mean, na.rm = T)
    MVTpts <-   apply(times_false.MVT,2,FUN = mean, na.rm = T)
    ABpts <-   apply(times_false.AB,2,FUN = mean, na.rm = T)
    
    
    plot(FFDpts ~ b.mat[,2],col=1,cex=cex1,xlim = c(0.05,0.3),ylim = c(0,50))
    
    pch=21,bg=pal[1],
           main = bquote(atop("Inert factor x4",beta[1]==.(b.mat[B,2]))),
           cex.main=1.2,cex.lab=1,cex.axis=1,
           ylab = "Time to (false) identification",
           xlab = "Normal quantiles")
    points(Tpts ~ b.mat[,2],cex=cex1, col =2)
    points(MVTpts ~ b.mat[,2],cex=cex1,col=3)
    points(ABpts ~ b.mat[,2],cex=cex1,col = 4)
    
      legend("bottomright",c("TS","FFD+TS","MVT"),cex=1.1,
             col=c("black","black","black","black"),pch=c(21,21,21,21),pt.bg=pal)
    }
    par(mfcol=c(2,2))
    for(B in c(1,3,2,4)){
      
      FFDpts5 <- qqnorm(times.FFD5[,B], plot.it=FALSE)
      Tpts5 <- qqnorm(times.T5[,B], plot.it=FALSE)
      MVTpts5 <- qqnorm(times.MVT5[,B], plot.it=FALSE)
      
      ind1 <- which(times.T5[,B]!=150)
      ind2 <- which(times.FFD5[,B]!=150)
      ind3 <- which(times.MVT5[,B]!=150)
      
      plot(Tpts5$y[ind1] ~ Tpts5$x[ind1],log="y",
           xlim=c(-2.8,2.8),ylim=c(1,150),
           col="black",pch=21,bg=pal[1],cex=cex1,
           main = bquote(atop("Inert factor x5",beta[1]==.(b.mat[B,2]))),
           cex.main=1.2,cex.lab=1,cex.axis=1,
           ylab = "Time to false identification (post w)",
           xlab = "Normal quantiles")
      points(FFDpts5$y[ind2] ~ FFDpts5$x[ind2],col="black",pch=21,bg=pal[2],cex=cex1)
      points(MVTpts5$y[ind3] ~ MVTpts5$x[ind3],col="black",pch=21,bg=pal[3],cex=cex1)
      
      legend("bottomright",c("TS","FFD+TS","MVT"),cex=1.1,
             col=c("black","black","black","black"),pch=c(21,21,21,21),pt.bg=pal)
      
    }
    dev.off()
  }


##################################################

}


########################################################
mean.p.post.mean.FFD <-array(NA,dim = c(max.blocks+1,2^K,ca)) 
mean.p.post.mean.T <-array(NA,dim = c(max.blocks+1,2^K,ca)) 
mean.p.post.mean.RAN <-array(NA,dim = c(max.blocks+1,2^K,ca)) 
mean.p.post.mean.AB <-array(NA,dim = c(max.blocks+1,2^K,ca)) 


for(B in 1:ca){
  for(comb in 1:(2^K)){
    mean.p.post.mean.FFD[,comb,B] <- apply(p.post.mean.FFD.ar[,,comb,B],2,mean) 
    mean.p.post.mean.T[,comb,B] <- apply(p.post.mean.T.ar[,,comb,B],2,mean) 
    mean.p.post.mean.RAN[,comb,B] <- apply(p.post.mean.RAN.ar[,,comb,B],2,mean) 
  }
  mean.p.post.mean.AB[,1,B] <- apply(p.post.mean.AB.ar[,,1,B],2,mean)
  mean.p.post.mean.AB[,2,B] <- apply(p.post.mean.AB.ar[,,2,B],2,mean) 
  
}

{ 
pdf("plot 4 - Analysis of probabilities' mean.pdf", width=12, height=5)
#pdf("plot 4 - Analysis of probabilities' mean - examples.pdf", width=10, height=5)
pal <- c("black","ivory4","ivory3","white")
# par(mfrow=c(4,2))
par(mfrow=c(1,2))
mar.default <- c(5,4,4,2) + 0.1
par(mar = mar.default + c(0, 4, 0, 0)) 
even <- seq(2,151,2)
# for(B in 1:ca){ 
B <- 4
for(comb in c(1,17)){
  maxy <- max(mean.p.post.mean.FFD[2:151,comb,B],
              mean.p.post.mean.T[2:151,comb,B],
              mean.p.post.mean.RAN[2:151,comb,B],
              mean.p.post.mean.AB[2:151,ifelse(comb==1,1,2),B]
              )
  plot(mean.p.post.mean.T[even,comb,B]~even,
       ylim=c(0,maxy),
       ylab=expression(hat(p)),xlab="Block",
       cex=0.9,col="black",pch=21,bg=pal[1],
       sub = paste("p=",round(p.mat[comb,B],3)))
  # sub=paste("X=(",paste(full.design0[comb,],collapse=" "),")"),
  points(mean.p.post.mean.FFD[even,comb,B]~even,
         cex=0.9,col="black",pch=21,bg=pal[2])
  points(mean.p.post.mean.RAN[even,comb,B]~even,
         cex=0.9,col="black",pch=21,bg=pal[3])
  points(mean.p.post.mean.AB[even,ifelse(comb==1,1,2),B]~even,
         cex=0.9,col="black",pch=21,bg=pal[4])
#  text(x=120,y=maxy,pos = 1,labels=paste("p=",round(p.mat[comb,B],3)))
  abline(h=p.mat[comb,B])
  legend("topright",c("TS","FFD+TS","MVT","OFAT"),cex=0.9,
          col=rep("black",4),pch=rep(21,4),pt.bg=pal)
# }
}
dev.off()
}

library(ggplot2)

multiplot <- function(..., plotlist=NULL, cols) {
  require(grid)
  
  # Make a list from the ... arguments and plotlist
  plots <- c(list(...), plotlist)
  
  numPlots = length(plots)
  
  # Make the panel
  plotCols = cols                          # Number of columns of plots
  plotRows = ceiling(numPlots/plotCols) # Number of rows needed, calculated from # of cols
  
  # Set up the page
  grid.newpage()
  pushViewport(viewport(layout = grid.layout(plotRows, plotCols)))
  vplayout <- function(x, y)
    viewport(layout.pos.row = x, layout.pos.col = y)
  
  # Make each plot, in the correct location
  for (i in 1:numPlots) {
    curRow = ceiling(i/plotCols)
    curCol = (i-1) %% plotCols + 1
    print(plots[[i]], vp = vplayout(curRow, curCol ))
  }
  
}

{  
  pal2 <- c("white","grey","dimgrey")
  pdf("plot 5 - s.d dist for some probabilities.pdf", width=10, height=5)
  breaks<-c(25,125)
  type<-c("MVT","FFD+TS","TS")
  
    bl <- breaks[1]
    B <- 3
    ind.plus <- 1
    ind.minus <- 17
    sdss<-c()
      temp1<-temp2<-temp3<-matrix(ncol=3,nrow=IT)
      temp4<-temp5<-temp6<-matrix(ncol=3,nrow=IT)
      
      temp1<-cbind(rep(round(p.mat[ind.plus,B],3),IT),p.post.sd.RAN.ar[,bl+1,ind.plus,B],rep(type[1],IT))
      temp2<-cbind(rep(round(p.mat[ind.plus,B],3),IT),p.post.sd.FFD.ar[,bl+1,ind.plus,B],rep(type[2],IT))
      temp3<-cbind(rep(round(p.mat[ind.plus,B],3),IT),p.post.sd.T.ar[,bl+1,ind.plus,B],rep(type[3],IT))
      temp4<-cbind(rep(round(p.mat[ind.minus,B],3),IT),p.post.sd.RAN.ar[,bl+1,ind.minus,B],rep(type[1],IT))
      temp5<-cbind(rep(round(p.mat[ind.minus,B],3),IT),p.post.sd.FFD.ar[,bl+1,ind.minus,B],rep(type[2],IT))
      temp6<-cbind(rep(round(p.mat[ind.minus,B],3),IT),p.post.sd.T.ar[,bl+1,ind.minus,B],rep(type[3],IT))
      sdss<-rbind(temp1,temp2,temp3,temp4,temp5,temp6)
    
    
    sds<-data.frame(prob=sdss[,1],sd=as.numeric(sdss[,2]),Type=sdss[,3])
    plot.title<-NA  #paste("SDs distribution for effect size",b.mat[B,2])
    plot.subtitle<-paste("After",bl*32,"users")
    bp <- ggplot(sds,aes(x = prob, y = sd, fill = factor(Type, levels = type))) + geom_boxplot()  
    plot1 <- bp + scale_fill_manual(values=pal2) +
      xlab("True P") + ylab("SD")+labs(fill = "Design") + 
      ggtitle(bquote(atop(.(plot.title), atop(italic(.(plot.subtitle)), "")))) + theme_classic() + theme(plot.title = element_text(hjust = 0.5))
    
    bl <- breaks[2]
    B <- 3
    ind.plus <- 1
    ind.minus <- 17
    sdss<-c()
    temp1<-temp2<-temp3<-matrix(ncol=3,nrow=IT)
    temp4<-temp5<-temp6<-matrix(ncol=3,nrow=IT)
    
    temp1<-cbind(rep(round(p.mat[ind.plus,B],3),IT),p.post.sd.RAN.ar[,bl+1,ind.plus,B],rep(type[1],IT))
    temp2<-cbind(rep(round(p.mat[ind.plus,B],3),IT),p.post.sd.FFD.ar[,bl+1,ind.plus,B],rep(type[2],IT))
    temp3<-cbind(rep(round(p.mat[ind.plus,B],3),IT),p.post.sd.T.ar[,bl+1,ind.plus,B],rep(type[3],IT))
    temp4<-cbind(rep(round(p.mat[ind.minus,B],3),IT),p.post.sd.RAN.ar[,bl+1,ind.minus,B],rep(type[1],IT))
    temp5<-cbind(rep(round(p.mat[ind.minus,B],3),IT),p.post.sd.FFD.ar[,bl+1,ind.minus,B],rep(type[2],IT))
    temp6<-cbind(rep(round(p.mat[ind.minus,B],3),IT),p.post.sd.T.ar[,bl+1,ind.minus,B],rep(type[3],IT))
    sdss<-rbind(temp1,temp2,temp3,temp4,temp5,temp6)
    
    
    sds<-data.frame(prob=sdss[,1],sd=as.numeric(sdss[,2]),Type=sdss[,3])
    plot.title<-NA  #paste("SDs distribution for effect size",b.mat[B,2])
    plot.subtitle<-paste("After",bl*32,"users")
    bp <- ggplot(sds,aes(x = prob, y = sd, fill = factor(Type, levels = type))) + geom_boxplot()  
    plot2 <- bp + scale_fill_manual(values=pal2) +
      xlab("True P") + ylab("SD")+labs(fill = "Design") + 
      ggtitle(bquote(atop(.(plot.title), atop(italic(.(plot.subtitle)), "")))) + theme_classic() + theme(plot.title = element_text(hjust = 0.5))
    
    # bl <- breaks[1]
    # B <- 4
    # ind.plus <- 5
    # ind.minus <- 30
    # sdss<-c()
    # temp1<-temp2<-temp3<-matrix(ncol=3,nrow=IT)
    # temp4<-temp5<-temp6<-matrix(ncol=3,nrow=IT)
    # 
    # temp1<-cbind(rep(round(p.mat[ind.plus,B],3),IT),p.post.sd.RAN.ar[,bl+1,ind.plus,B],rep(type[1],IT))
    # temp2<-cbind(rep(round(p.mat[ind.plus,B],3),IT),p.post.sd.FFD.ar[,bl+1,ind.plus,B],rep(type[2],IT))
    # temp3<-cbind(rep(round(p.mat[ind.plus,B],3),IT),p.post.sd.T.ar[,bl+1,ind.plus,B],rep(type[3],IT))
    # temp4<-cbind(rep(round(p.mat[ind.minus,B],3),IT),p.post.sd.RAN.ar[,bl+1,ind.minus,B],rep(type[1],IT))
    # temp5<-cbind(rep(round(p.mat[ind.minus,B],3),IT),p.post.sd.FFD.ar[,bl+1,ind.minus,B],rep(type[2],IT))
    # temp6<-cbind(rep(round(p.mat[ind.minus,B],3),IT),p.post.sd.T.ar[,bl+1,ind.minus,B],rep(type[3],IT))
    # sdss<-rbind(temp1,temp2,temp3,temp4,temp5,temp6)
    # 
    # 
    # sds<-data.frame(prob=sdss[,1],sd=as.numeric(sdss[,2]),Type=sdss[,3])
    # plot.title<-paste("S.ds distribution for effect size",b.mat[B,2])
    # plot.subtitle<-paste("After",bl*32,"users")
    # bp <- ggplot(sds,aes(x = prob, y = sd, fill = factor(Type, levels = type))) + geom_boxplot()  
    # plot3 <- bp + scale_fill_manual(values=pal2) +
    #   xlab("Probabilities") + ylab("S.d")+labs(fill = "Design") + 
    #   ggtitle(bquote(atop(.(plot.title), atop(italic(.(plot.subtitle)), "")))) + theme_classic() + theme(plot.title = element_text(hjust = 0.5))
    # 
    # bl <- breaks[2]
    # B <- 4
    # ind.plus <- 5
    # ind.minus <- 30
    # sdss<-c()
    # temp1<-temp2<-temp3<-matrix(ncol=3,nrow=IT)
    # temp4<-temp5<-temp6<-matrix(ncol=3,nrow=IT)
    # 
    # temp1<-cbind(rep(round(p.mat[ind.plus,B],3),IT),p.post.sd.RAN.ar[,bl+1,ind.plus,B],rep(type[1],IT))
    # temp2<-cbind(rep(round(p.mat[ind.plus,B],3),IT),p.post.sd.FFD.ar[,bl+1,ind.plus,B],rep(type[2],IT))
    # temp3<-cbind(rep(round(p.mat[ind.plus,B],3),IT),p.post.sd.T.ar[,bl+1,ind.plus,B],rep(type[3],IT))
    # temp4<-cbind(rep(round(p.mat[ind.minus,B],3),IT),p.post.sd.RAN.ar[,bl+1,ind.minus,B],rep(type[1],IT))
    # temp5<-cbind(rep(round(p.mat[ind.minus,B],3),IT),p.post.sd.FFD.ar[,bl+1,ind.minus,B],rep(type[2],IT))
    # temp6<-cbind(rep(round(p.mat[ind.minus,B],3),IT),p.post.sd.T.ar[,bl+1,ind.minus,B],rep(type[3],IT))
    # sdss<-rbind(temp1,temp2,temp3,temp4,temp5,temp6)
    # 
    # 
    # sds<-data.frame(prob=sdss[,1],sd=as.numeric(sdss[,2]),Type=sdss[,3])
    # plot.title<-paste("S.ds distribution for effect size",b.mat[B,2])
    # plot.subtitle<-paste("After",bl*32,"users")
    # bp <- ggplot(sds,aes(x = prob, y = sd, fill = factor(Type, levels = type))) + geom_boxplot()  
    # plot4 <- bp + scale_fill_manual(values=pal2) +
    #   xlab("Probabilities") + ylab("S.d")+labs(fill = "Design") + 
    #   ggtitle(bquote(atop(.(plot.title), atop(italic(.(plot.subtitle)), "")))) + theme_classic() + theme(plot.title = element_text(hjust = 0.5))
    
  multiplot(plot1,plot2,cols = 2)
  dev.off()
  
}

{
pdf("plot 6 - s.d dist for b1.pdf", width=10, height=5)
breaks<-c(25,100)
j<-1
type<-c("MVT","FFD+TS","TS")

bl <- breaks[1]
sdss<-c()
for(B in 1:ca){
  temp1<-temp2<-temp3<-matrix(ncol=3,nrow=IT)
  temp1<-cbind(rep(b.mat[B,2],IT),post.sd.RAN.ar[,bl+1,j+1,B],rep(type[1],IT))
  temp2<-cbind(rep(b.mat[B,2],IT),post.sd.FFD.ar[,bl+1,j+1,B],rep(type[2],IT))
  temp3<-cbind(rep(b.mat[B,2],IT),post.sd.T.ar[,bl+1,j+1,B],rep(type[3],IT))
  temp<-rbind(temp1,temp2,temp3)
  sdss<-rbind(sdss,temp)
}

sds<-data.frame(effect=sdss[,1],sd=as.numeric(sdss[,2]),Type=sdss[,3])
plot.title<-"S.ds distribution"
plot.subtitle<-paste("After",bl*32,"users")
bp <- ggplot(sds,aes(x = effect, y = sd, fill = factor(Type, levels = type))) + geom_boxplot()  
plot1 <- bp + scale_fill_manual(values=pal2) +
  xlab("Effect size") + ylab("S.d")+labs(fill = "Design") + 
  ggtitle(bquote(atop(.(plot.title), atop(italic(.(plot.subtitle)), "")))) + theme_classic() + theme(plot.title = element_text(hjust = 0.5))

bl <- breaks[2]
sdss<-c()
for(B in 1:ca){
  temp1<-temp2<-temp3<-matrix(ncol=3,nrow=IT)
  temp1<-cbind(rep(b.mat[B,2],IT),post.sd.RAN.ar[,bl+1,j+1,B],rep(type[1],IT))
  temp2<-cbind(rep(b.mat[B,2],IT),post.sd.FFD.ar[,bl+1,j+1,B],rep(type[2],IT))
  temp3<-cbind(rep(b.mat[B,2],IT),post.sd.T.ar[,bl+1,j+1,B],rep(type[3],IT))
  temp<-rbind(temp1,temp2,temp3)
  sdss<-rbind(sdss,temp)
}

sds<-data.frame(effect=sdss[,1],sd=as.numeric(sdss[,2]),Type=sdss[,3])
plot.title<-"S.ds distribution"
plot.subtitle<-paste("After",bl*32,"users")
bp <- ggplot(sds,aes(x = effect, y = sd, fill = factor(Type, levels = type))) + geom_boxplot()  
plot2 <- bp + scale_fill_manual(values=pal2) +
  xlab("Effect size") + ylab("S.d")+labs(fill = "Design") + 
  ggtitle(bquote(atop(.(plot.title), atop(italic(.(plot.subtitle)), "")))) + theme_classic() + theme(plot.title = element_text(hjust = 0.5))

multiplot(plot1,plot2,cols = 2)
dev.off()
}

#############################################################3
# Comparing switching by p-value/ posterior weight methods

# Regret
{
R.FFD <- array(NA,dim=c(max.blocks,IT,ca))
R.FFD1 <- array(NA,dim=c(max.blocks,IT,ca))

mean.R.FFD <- matrix(NA,ncol=ca,nrow=max.blocks)
mean.R.FFD1 <- matrix(NA,ncol=ca,nrow=max.blocks)

cum.R.FFD <- matrix(NA,ncol=ca,nrow=max.blocks)
cum.R.FFD1 <- matrix(NA,ncol=ca,nrow=max.blocks)


for (B in 1:ca){
  for(it in 1:IT){
    R.FFD[,it,B] <- best.sum.p[,B] - sum.p.FFD[,it,B]
    R.FFD1[,it,B] <- best.sum.p[,B] - sum.p.FFD1[,it,B]

  }
  mean.R.FFD[,B] <- apply(R.FFD[,,B],1,mean)
  mean.R.FFD1[,B] <- apply(R.FFD1[,,B],1,mean)

  cum.R.FFD[,B] <- cumsum(mean.R.FFD[,B])
  cum.R.FFD1[,B] <- cumsum(mean.R.FFD1[,B])
  
}
}

#################################################

# Regret comparison
pal2 <- c("goldenrod2","lightseagreen")
{
  pdf("plot1a - Regret comparison (pv-pw).pdf", width=7, height=7)
  par(mfcol=c(2,2))
  per <- c(1,3,2,4)
  for(B in per){
    maxy<-max(mean.R.FFD[,B],mean.R.FFD1[,B])
    plot(mean.R.FFD[,B]~seq(max.blocks),type="l",lty=1,lwd=2,
         ylim=c(0,maxy),xlab="Blocks",ylab="Expected Loss",
         main=paste("Effect Size =",b.mat[B,2]),
         cex.axis=1,cex.lab=1,cex.main=1,col=pal2[1])
    lines(mean.R.FFD1[,B]~seq(max.blocks),lty=2,lwd=2,col=pal2[2])

    legend("topright", ncol=1,
                          c("FFD + TS (pv)","FFD1 + TS (pw)"),
                          lty=c(1,1),cex=0.8,lwd=c(1.5,1.5),col=pal2)
  }
  
  dev.off()
}

# cumulative Regret comparison

{
  pdf("plot1b - cumulative Regret comparison (pv-pw).pdf", width=7, height=7)
  par(mfcol=c(2,2))
  per <- c(1,3,2,4)
  for(B in per){
    maxy<-max(cum.R.FFD[,B],cum.R.FFD1[,B])
    plot(cum.R.FFD[,B]~seq(max.blocks),type="l",lty=1,lwd=2,
         ylim=c(0,maxy),xlab="Blocks",ylab="Cumulative expected Loss",
         main=paste("Effect Size =",b.mat[B,2]),
         cex.axis=1,cex.lab=1,cex.main=1,col=pal2[1])
    lines(cum.R.FFD1[,B]~seq(max.blocks),lty=1,lwd=2,col=pal2[2])
    
    if (B==3 | B==4) legend("bottomright", ncol=1,
           c("FFD + TS (pv)","FFD1 + TS (pw)"),
           lty=c(1,1),cex=0.8,lwd=c(1.5,1.5),col=pal2)
    if (B==1 | B==2)legend("topleft", ncol=1,
           c("FFD + TS (pv)","FFD1 + TS (pw)"),
           lty=c(1,1),cex=0.8,lwd=c(1.5,1.5),col=pal2)
    
  }
  
  dev.off()
}

# Number of realized conversions comparison
{
  apply(n.suc.FFD,2,mean)
  apply(n.suc.FFD1,2,mean)
  
  # Number of expected conversions comparison
  expconv <- matrix(NA,ncol=2,nrow=4)
  expconv <- as.data.frame(expconv)
  rownames(expconv) <- as.character(b.mat[,2])
  colnames(expconv) <- c("FFD","FFD1")
  
  for(B in 1:ca){
    expconv$FFD[B] <- cumsum(mean.sum.p.FFD[,B])[150]
    expconv$FFD1[B] <- cumsum(mean.sum.p.FFD1[,B])[150]
  }
  expconv
}

# Time until identification of effect
#####################################

# Option a - median pw
{
  median.pw.b1.FFD1 <-matrix(NA,nrow = max.blocks,ncol = ca)
  median.pw.b1.FFD <-matrix(NA,nrow = max.blocks,ncol = ca)
  median.pw.b1.T <-matrix(NA,nrow = max.blocks,ncol = ca)
  median.pw.b1.AB <-matrix(NA,nrow = max.blocks,ncol = ca)
  median.pw.b1.MVT <-matrix(NA,nrow = max.blocks,ncol = ca)
  average.pw.b1.FFD1 <-matrix(NA,nrow = max.blocks,ncol = ca)
  average.pw.b1.FFD <-matrix(NA,nrow = max.blocks,ncol = ca)
  average.pw.b1.T <-matrix(NA,nrow = max.blocks,ncol = ca)
  average.pw.b1.AB <-matrix(NA,nrow = max.blocks,ncol = ca)
  average.pw.b1.MVT <-matrix(NA,nrow = max.blocks,ncol = ca)
  
  
  for (B in 1:ca){
    median.pw.b1.FFD[,B] <- apply(post.prob.FFD.ar[,-1,2,B],2,median)
    median.pw.b1.FFD1[,B] <- apply(post.prob.FFD1.ar[,-1,2,B],2,median)
    median.pw.b1.T[,B] <- apply(post.prob.T.ar[,-1,2,B],2,median)
    median.pw.b1.AB[,B] <- apply(post.prob.AB.ar[,-1,2,B],2,median)
    median.pw.b1.MVT[,B] <- apply(post.prob.RAN.ar[,-1,2,B],2,median)
    average.pw.b1.FFD[,B] <- apply(post.prob.FFD.ar[,-1,2,B],2,mean)
    average.pw.b1.FFD1[,B] <- apply(post.prob.FFD1.ar[,-1,2,B],2,mean)
    average.pw.b1.T[,B] <- apply(post.prob.T.ar[,-1,2,B],2,mean)
    average.pw.b1.AB[,B] <- apply(post.prob.AB.ar[,-1,2,B],2,mean)
    average.pw.b1.MVT[,B] <- apply(post.prob.RAN.ar[,-1,2,B],2,mean)
    
  }
  # pal <- c("black","green","red","purple","blue")
  pal <-   c("mediumorchid4","lightseagreen","lightsalmon","olivedrab3","goldenrod2")
  {
  pdf("plot3a - median pw.pdf", width=5, height=5)
  par(mfcol=c(2,2))
  for(B in c(1,3,2,4)){
    # miny<-min(median.pv.b1.FFD[,B],median.pv.b1.T[,B],median.pv.b1.AB[,B])
    plot(median.pw.b1.FFD[,B] ~ seq(max.blocks),type="l",lty=1,
         xlab="Blocks",ylab="Median posterior weight on +",ylim=c(0.5,1),
         main=paste("Effect Size =",b.mat[B,2]),col=pal[5],
         cex.axis=0.8,cex.lab=0.8,cex.main=0.8)
    lines(median.pw.b1.FFD1[,B] ~ seq(max.blocks),lty=1,col=pal[2])
    lines(median.pw.b1.T[,B] ~ seq(max.blocks),lty=1,col=pal[1])
    lines(median.pw.b1.AB[,B] ~ seq(max.blocks),lty=1,col=pal[4])
    lines(median.pw.b1.MVT[,B] ~ seq(max.blocks),lty=1,col=pal[3])
    
    abline(h=0.95)
    legend("bottomright", ncol=1,bty="n",
         c("FFD + TS","FFD1 + TS","TS","MVT","OFAT"),
         lty=rep(1,5),cex=0.4,col=pal[c(5,2,1,3,4)])
  }
  
  dev.off()
  }
  
  {
    pdf("plot3b - average pw.pdf", width=5, height=5)
    par(mfcol=c(2,2))
    for(B in c(1,3,2,4)){
      # miny<-min(median.pv.b1.FFD[,B],median.pv.b1.T[,B],median.pv.b1.AB[,B])
      plot(average.pw.b1.FFD[,B] ~ seq(max.blocks),type="l",lty=1,
           xlab="Blocks",ylab="Average posterior weight on +",ylim=c(0.5,1),
           main=paste("Effect Size =",b.mat[B,2]),col=pal[5],
           cex.axis=0.8,cex.lab=0.8,cex.main=0.8)
      lines(average.pw.b1.FFD1[,B] ~ seq(max.blocks),lty=1,col=pal[2])
      lines(average.pw.b1.T[,B] ~ seq(max.blocks),lty=1,col=pal[1])
      lines(average.pw.b1.AB[,B] ~ seq(max.blocks),lty=1,col=pal[4])
      lines(average.pw.b1.MVT[,B] ~ seq(max.blocks),lty=1,col=pal[3])
      
      abline(h=0.95)
      legend("bottomright", ncol=1,bty="n",
             c("FFD + TS","FFD1 + TS","TS","MVT","OFAT"),
             lty=rep(1,5),cex=0.4,col=pal[c(5,2,1,3,4)])
    }
    
    dev.off()
  }
}

# option e - log normal qqplot

# times.FFD <- matrix(NA,ncol=ca,nrow=IT)
times.FFD1 <- matrix(NA,ncol=ca,nrow=IT)
times.T <- matrix(NA,ncol=ca,nrow=IT)
times.AB <- matrix(NA,ncol=ca,nrow=IT)
times.MVT <- matrix(NA,ncol=ca,nrow=IT)

for(B in 1:ca){
  times.T[,B] <- apply(post.prob.T.ar[,,2,B],1,high.post.w,direc="pos")
  # times.FFD[,B] <- apply(post.prob.FFD.ar[,,2,B],1,high.post.w,direc="pos")
  times.FFD1[,B] <- apply(post.prob.FFD1.ar[,,2,B],1,high.post.w,direc="pos")
  times.AB[,B] <- apply(post.prob.AB.ar[,,2,B],1,high.post.w,direc="pos")
  times.MVT[,B] <- apply(post.prob.RAN.ar[,,2,B],1,high.post.w,direc="pos")
  
}

{
pal <-   c("mediumorchid4","lightseagreen","lightsalmon","olivedrab3","goldenrod2")
pdf("plot2e - time (one factor), all(FFD1 instead of FFD).pdf", width=7, height=7)
par(mfcol=c(2,2))
for(B in c(1,3,2,4)){
  
  # FFDpts <- qqnorm(times.FFD[,B], plot.it=FALSE)
  Tpts <- qqnorm(times.T[,B], plot.it=FALSE)
  ABpts <- qqnorm(times.AB[,B], plot.it=FALSE)
  MVTpts <- qqnorm(times.MVT[,B], plot.it=FALSE)
  FFD1pts <- qqnorm(times.FFD1[,B], plot.it=FALSE)
  
  ind1 <- which(times.T[,B]!=151)
  # ind2 <- which(times.FFD[,B]!=150)
  ind3 <- which(times.MVT[,B]!=151)
  ind4 <- which(times.AB[,B]!=151)
  ind5 <- which(times.FFD1[,B]!=151)
  
  plot(Tpts$y[ind1] ~ Tpts$x[ind1],log="y",
       xlim=c(-2.8,2.8),ylim=c(1,150),
       # col="black",pch=21,bg=pal[1],cex=0.9,
       pch=16,col=pal[1],cex=0.5,
       # main = paste("Effect size = ",b.mat[B,2]),
       main = bquote(atop(beta[1]==.(b.mat[B,2]))),
       cex.main=1,cex.lab=0.9,cex.axis=0.9,
       ylab = "Time to identification",
       xlab = "Normal quantiles")
  # points(MVTpts$y[ind3] ~ MVTpts$x[ind3],col="black",pch=21,bg=pal[3],cex=0.9)
  # points(FFDpts$y[ind2] ~ FFDpts$x[ind2],col="black",pch=21,bg=pal[2],cex=0.9)
  # points(ABpts$y[ind4] ~ ABpts$x[ind4],col="black",pch=21,bg=pal[4],cex=0.9)
  # 
  # legend("bottomright",c("TS","FFD+TS","MVT","OFAT"),cex=0.9,
  #        col=c("black","black","black","black"),pch=c(21,21,21,21),pt.bg=pal)
  # 
  points(MVTpts$y[ind3] ~ MVTpts$x[ind3],pch=16,col=pal[3],cex=0.5)
  points(ABpts$y[ind4] ~ ABpts$x[ind4],pch=16,col=pal[4],cex=0.5)
  # points(FFDpts$y[ind2] ~ FFDpts$x[ind2],pch=16,col=pal[5],cex=0.5)
  points(Tpts$y[ind1] ~ Tpts$x[ind1],pch=16,col=pal[1],cex=0.5)
  points(FFD1pts$y[ind5] ~ FFD1pts$x[ind5],pch=16,col=pal[2],cex=0.5)
  
  legend("bottomright",c("TS","FFD1+TS","MVT","OFAT"),cex=0.9,
         pch=rep(16,4),col=pal[-5])
}  

dev.off()
}

# Comparison FFD1(time defined by pw) -FFD (time defined by pv)
{
  times.FFD <- matrix(NA,ncol=ca,nrow=IT)
  times.FFD1 <- matrix(NA,ncol=ca,nrow=IT)

  for(B in 1:ca){
    times.FFD1[,B] <- apply(post.prob.FFD1.ar[,,2,B],1,high.post.w,direc="pos")
    times.FFD[,B] <- compute.Thompson.first(t(pv.FFD.ar[,,1,B]<0.05))
    times.FFD[which(times.FFD[,B]==-1),B] <- max.blocks + 1
    }
}
{
  pal <-   c("mediumorchid4","lightseagreen","lightsalmon","olivedrab3","goldenrod2")
  pdf("plot2e - times FFD (pv) vs FFD1(pw).pdf", width=7, height=7)
  par(mfcol=c(2,2))
  for(B in c(1,3,2,4)){
    
    FFDpts <- qqnorm(times.FFD[,B], plot.it=FALSE)
    FFD1pts <- qqnorm(times.FFD1[,B], plot.it=FALSE)
    
    ind2 <- which(times.FFD[,B]!=151)
    ind5 <- which(times.FFD1[,B]!=151)
    
    plot(FFDpts$y[ind2] ~ FFDpts$x[ind2],log="y",
         xlim=c(-2.8,2.8),ylim=c(1,150),
         # col="black",pch=21,bg=pal[1],cex=0.9,
         pch=16,col=pal[5],cex=0.5,
         # main = paste("Effect size = ",b.mat[B,2]),
         main = bquote(atop(beta[1]==.(b.mat[B,2]))),
         cex.main=1,cex.lab=0.9,cex.axis=0.9,
         ylab = "Time to identification",
         xlab = "Normal quantiles")
    points(FFD1pts$y[ind5] ~ FFD1pts$x[ind5],pch=16,col=pal[2],cex=0.5)
    
    legend("bottomright",c("FFD1+TS","FFD+TS"),cex=0.9,
           pch=rep(16,4),col=pal[c(2,5)])
  }  
  
  dev.off()
}

# time to false identification
################################
{
  times.FFD4 <- matrix(NA,ncol=ca,nrow=IT)
  times.T4 <- matrix(NA,ncol=ca,nrow=IT)
  times.MVT4<- matrix(NA,ncol=ca,nrow=IT)
  times.FFD14 <- matrix(NA,ncol=ca,nrow=IT)
  times.FFD5 <- matrix(NA,ncol=ca,nrow=IT)
  times.T5 <- matrix(NA,ncol=ca,nrow=IT)
  times.MVT5<- matrix(NA,ncol=ca,nrow=IT)
  times.FFD15 <- matrix(NA,ncol=ca,nrow=IT)
  
  # times.AB <- matrix(NA,ncol=ca,nrow=IT) # AB doesn't have inert factors
  
  for(B in 1:ca){
    times.FFD4[,B] <- apply(post.prob.FFD.ar[,,5,B],1,high.post.w)
    times.FFD14[,B] <- apply(post.prob.FFD1.ar[,,5,B],1,high.post.w)
    times.T4[,B] <- apply(post.prob.T.ar[,,5,B],1,high.post.w)
    times.MVT4[,B] <- apply(post.prob.RAN.ar[,,5,B],1,high.post.w)
    # times.FFD4[,B] <- compute.Thompson.first(t(pv.FFD.ar[,,4,B]<0.05))
    # times.T4[,B] <- compute.Thompson.first(t(pv.T.ar[,,4,B]<0.05))
    # times.MVT4[,B] <- compute.Thompson.first(t(pv.RAN.ar[,,4,B]<0.05))
    times.FFD5[,B] <- apply(post.prob.FFD.ar[,,6,B],1,high.post.w)
    times.FFD15[,B] <- apply(post.prob.FFD1.ar[,,6,B],1,high.post.w)
    times.T5[,B] <- apply(post.prob.T.ar[,,6,B],1,high.post.w)
    times.MVT5[,B] <- apply(post.prob.RAN.ar[,,6,B],1,high.post.w)
    # times.FFD5[,B] <- compute.Thompson.first(t(pv.FFD.ar[,,5,B]<0.05))
    # times.T5[,B] <- compute.Thompson.first(t(pv.T.ar[,,5,B]<0.05))
    # times.MVT5[,B] <- compute.Thompson.first(t(pv.RAN.ar[,,5,B]<0.05))
    
    # times.FFD4[,B][times.FFD4[,B]==-1] <- 150
    # # times.T4[,B][times.T4[,B]==-1] <- 150
    # times.MVT4[,B][times.MVT4[,B]==-1] <- 150
    # times.FFD5[,B][times.FFD5[,B]==-1] <- 150
    # # times.T5[,B][times.T5[,B]==-1] <- 150
    # times.MVT5[,B][times.MVT5[,B]==-1] <- 150
  }
  
  {
    # pal <- c("black","ivory3","white")
    pal <- c("mediumorchid4","lightseagreen","lightsalmon","olivedrab3","goldenrod2")

    pdf("Time to false identification - all.pdf", width=7, height=7)
    # for X4
    par(mfcol=c(2,2))
    cex1 <- 0.5
    for(B in c(1,3,2,4)){
      # FFDpts4 <- qqnorm(times.FFD4[,B], plot.it=FALSE)
      FFD1pts4 <- qqnorm(times.FFD14[,B], plot.it=FALSE)
      Tpts4 <- qqnorm(times.T4[,B], plot.it=FALSE)
      MVTpts4 <- qqnorm(times.MVT4[,B], plot.it=FALSE)
      
      ind1 <- which(times.T4[,B]!=151)
      # ind2 <- which(times.FFD4[,B]!=151)
      ind3 <- which(times.MVT4[,B]!=151)
      ind4 <- which(times.FFD14[,B]!=151)
      
      plot(Tpts4$y[ind1] ~ Tpts4$x[ind1],log="y",
           xlim=c(-2.8,2.8),ylim=c(1,150),
           # col="black",pch=21,bg=pal[1],cex=cex1,
           pch=16,col=pal[1],cex=cex1,
           main = bquote(atop("Inert factor x4",beta[1]==.(b.mat[B,2]))),
           cex.main=1.2,cex.lab=1,cex.axis=1,
           ylab = "Time to (false) identification",
           xlab = "Normal quantiles")
      # points(FFDpts4$y[ind2] ~ FFDpts4$x[ind2],col="black",pch=21,bg=pal[2],cex=cex1)
      # points(MVTpts4$y[ind3] ~ MVTpts4$x[ind3],col="black",pch=21,bg=pal[3],cex=cex1)
      # legend("bottomright",c("TS","FFD+TS","MVT"),cex=1.1,
      #        col=c("black","black","black","black"),pch=c(21,21,21,21),pt.bg=pal)
      
      # points(FFDpts4$y[ind2] ~ FFDpts4$x[ind2],pch=16,col=pal[5],cex=cex1)
      points(MVTpts4$y[ind3] ~ MVTpts4$x[ind3],pch=16,col=pal[3],cex=cex1)
      points(FFD1pts4$y[ind4] ~ FFD1pts4$x[ind4],pch=16,col=pal[2],cex=cex1)
      
      legend("bottomright",c("TS","FFD1+TS","MVT"),cex=1.1,
             col=pal[-c(4,5)],pch=rep(16,3))
      # legend("bottomright",c("TS","FFD1+TS","MVT","FFD+TS"),cex=1.1,
      #        col=pal[-4],pch=rep(16,4))
      
    }
    # for X5
    par(mfcol=c(2,2))
    cex1 <- 0.5
    for(B in c(1,3,2,4)){
      FFDpts5 <- qqnorm(times.FFD5[,B], plot.it=FALSE)
      FFD1pts5 <- qqnorm(times.FFD15[,B], plot.it=FALSE)
      Tpts5 <- qqnorm(times.T5[,B], plot.it=FALSE)
      MVTpts5 <- qqnorm(times.MVT5[,B], plot.it=FALSE)
      
      ind1 <- which(times.T5[,B]!=151)
      ind2 <- which(times.FFD5[,B]!=151)
      ind3 <- which(times.MVT5[,B]!=151)
      ind4 <- which(times.FFD15[,B]!=151)
      
      plot(Tpts5$y[ind1] ~ Tpts5$x[ind1],log="y",
           xlim=c(-2.8,2.8),ylim=c(1,150),
           # col="black",pch=21,bg=pal[1],cex=cex1,
           pch=16,col=pal[1],cex=cex1,
           main = bquote(atop("Inert factor x5",beta[1]==.(b.mat[B,2]))),
           cex.main=1.2,cex.lab=1,cex.axis=1,
           ylab = "Time to (false) identification",
           xlab = "Normal quantiles")
      # points(FFDpts4$y[ind2] ~ FFDpts4$x[ind2],col="black",pch=21,bg=pal[2],cex=cex1)
      # points(MVTpts4$y[ind3] ~ MVTpts4$x[ind3],col="black",pch=21,bg=pal[3],cex=cex1)
      # legend("bottomright",c("TS","FFD+TS","MVT"),cex=1.1,
      #        col=c("black","black","black","black"),pch=c(21,21,21,21),pt.bg=pal)
      
      points(FFDpts5$y[ind2] ~ FFDpts5$x[ind2],pch=16,col=pal[5],cex=cex1)
      points(MVTpts5$y[ind3] ~ MVTpts5$x[ind3],pch=16,col=pal[3],cex=cex1)
      points(FFD1pts5$y[ind4] ~ FFD1pts5$x[ind4],pch=16,col=pal[2],cex=cex1)
      
      legend("bottomright",c("TS","FFD1+TS","MVT","FFD+TS"),cex=1.1,
             col=pal[-4],pch=rep(16,4))
    }
    dev.off()
  }
}

# Analysis of probabilities' mean
########################################################

mean.p.post.mean.FFD <-array(NA,dim = c(max.blocks+1,2^K,ca))
mean.p.post.mean.FFD1 <-array(NA,dim = c(max.blocks+1,2^K,ca)) 
mean.p.post.mean.T <-array(NA,dim = c(max.blocks+1,2^K,ca)) 
mean.p.post.mean.RAN <-array(NA,dim = c(max.blocks+1,2^K,ca)) 

for(B in 1:ca){
  for(comb in 1:(2^K)){
    mean.p.post.mean.FFD[,comb,B] <- apply(p.post.mean.FFD.ar[,,comb,B],2,mean)
    mean.p.post.mean.FFD1[,comb,B] <- apply(p.post.mean.FFD1.ar[,,comb,B],2,mean)
    mean.p.post.mean.T[,comb,B] <- apply(p.post.mean.T.ar[,,comb,B],2,mean) 
    mean.p.post.mean.RAN[,comb,B] <- apply(p.post.mean.RAN.ar[,,comb,B],2,mean) 
  }
}

{ 
  pdf("plot 4 - Analysis of probabilities' mean (+FFD1) .pdf", width=5, height=10)
  # pdf("plot 4 - Analysis of probabilities' mean - b1=0.05(+FFD1).pdf", width=10, height=5)
  pal <- c("mediumorchid4","lightseagreen","lightsalmon","olivedrab3","goldenrod2")
  # pal <- c("grey","black","white")
  par(mfrow=c(4,2))
  # par(mfrow=c(1,2))
  even <- seq(2,151,2)
  for(B in 1:ca){ 
  # B <- 1
  for(comb in c(1,17)){
    maxy <- max(mean.p.post.mean.FFD[2:151,comb,B],
                mean.p.post.mean.FFD1[2:151,comb,B],
                mean.p.post.mean.RAN[2:151,comb,B],
                mean.p.post.mean.T[2:151,comb,B])
    maintitle <- ifelse(comb==1,paste("p(+), Effect size = ",b.mat[B,2]),paste("p(-), Effect size = ",b.mat[B,2]))
    plot(mean.p.post.mean.T[even,comb,B]~even,
         ylim=c(0,maxy),
         ylab=expression(hat(p)),xlab="Block",
         cex=0.5,pch=16,col=pal[1],
         main = maintitle, cex.main = 0.85)
        # cex=0.9,col="black",pch=21,bg=pal[1])
        
    # sub=paste("X=(",paste(full.design0[comb,],collapse=" "),")"),
    points(mean.p.post.mean.FFD1[even,comb,B]~even,
           cex=0.5,pch=16,col=pal[2])
          # cex=0.9,col=pal[2],pch=21,bg=pal[2])
    points(mean.p.post.mean.RAN[even,comb,B]~even,
           cex=0.5,pch=16,col=pal[3])
           # cex=0.9,col="black",pch=21,bg=pal[3])
    points(mean.p.post.mean.FFD[even,comb,B]~even,
           cex=0.5,pch=16,col=pal[5])
    # cex=0.9,col="black",pch=21,bg=pal[3])
    
    text(x=120,y=maxy,pos = 1,labels=paste("p=",round(p.mat[comb,B],3)))
    abline(h=p.mat[comb,B])
    # legend("topright",rev(c("FFD+TS","TS","MVT")),cex=0.9,
    #        col=c("black","black","black"),pch=c(21,21,21),pt.bg=rev(pal))
    legend(x=30,y=maxy,c("TS","FFD1+TS","MVT","FFD"),cex=0.9,
           col=pal[-4],pch=rep(16,4),bty="n")
    
     }
  }
  dev.off()
}


# regression pv-pw
# Based on a script from 2.2.17 folder, "Analysis of successes and failures, b1=0.3, FFD N 2.2.17"
# on the disc-on-key

# MVT

for (B in 1:ca){
direction.df<-as.data.frame(matrix(NA,nrow=IT,ncol=8))
colnames(direction.df)<-c("iteration",
                          "block_pv","pv","pw_block_pv", # in which block pv<0.05 and what was the pw then
                          "pw_block_pv_adjusted",
                          "how_much_time",
                          "direction", "ES")
direction.df$ES <- rep(b.mat[B,2],IT)
for (it in 1:IT){
  direction.df$iteration[it]<-it
  Tf <- times.MVT[it,B]
  if(Tf != max.blocks+1){
    direction.df$pv[it] <- pv.RAN.ar[it,Tf,1,B]
    direction.df$block_pv[it]<-Tf
    direction.df$pw_block_pv[it]<-post.prob.RAN.ar[it,Tf+1,2,B]
    direction.df$pw_block_pv_adjusted[it] <- direction.df$pw_block_pv[it]
    direction.df$direction[it] <- TRUE
    direction.df$how_much_time[it] <- sum(post.prob.RAN.ar[it,1:Tf,2,B] > 0.975)
    if (direction.df$pw_block_pv[it] < 0.1){
      direction.df$pw_block_pv_adjusted[it] <- 1 - direction.df$pw_block_pv[it]
      direction.df$direction[it] <- FALSE
    }
  }                                    
}
nam <- paste("direction.dfB", B, sep = "")
assign(nam, direction.df)
}

direction.df2 <- rbind(direction.dfB1,direction.dfB2,direction.dfB3,direction.dfB4)

# FFD

for (B in 1:ca){
  direction.df<-as.data.frame(matrix(NA,nrow=IT,ncol=8))
  colnames(direction.df)<-c("iteration",
                            "block_pv","pv","pw_block_pv", # in which block pv<0.05 and what was the pw then
                            "pw_block_pv_adjusted",
                            "how_much_time",
                            "direction", "ES")
  direction.df$ES <- rep(b.mat[B,2],IT)
  for (it in 1:IT){
    direction.df$iteration[it]<-it
    Tf <- Thompson.first[it,1,B]
    if(Tf != -1){
      direction.df$pv[it] <- pv.FFD.ar[it,Tf,1,B]
      direction.df$block_pv[it]<-Tf
      direction.df$pw_block_pv[it]<-post.prob.FFD.ar[it,Tf+1,2,B]
      direction.df$pw_block_pv_adjusted[it] <- direction.df$pw_block_pv[it]
      direction.df$direction[it] <- TRUE
      direction.df$how_much_time[it] <- sum(post.prob.FFD.ar[it,1:Tf,2,B] > 0.975)
      if (direction.df$pw_block_pv[it] < 0.1){
        direction.df$pw_block_pv_adjusted[it] <- 1 - direction.df$pw_block_pv[it]
        direction.df$direction[it] <- FALSE
      }
    }                                    
  }
  nam <- paste("direction.dfB", B, sep = "")
  assign(nam, direction.df)
}

direction.df1 <- rbind(direction.dfB1,direction.dfB2,direction.dfB3,direction.dfB4)



lm1 <- lm(pw_block_pv_adjusted ~ pv, data = direction.df1) # FFD
lm2 <- lm(pw_block_pv_adjusted ~ pv, data = direction.df2) # MVT

# lm.sqrt <- lm(sqrt(pw_block_pv_adjusted) ~ pv, data = direction.df1)
# plot(sqrt(pw_block_pv_adjusted) ~ pv,data = direction.df1.pv)
# summary(lm)
# loglog.lm <- lm(log(1-pw_block_pv_adjusted) ~ log(pv) + block_pv, data = direction.df1.pv) 
# summary(loglog.lm)
# 
# plot(loglog.lm)
# plot(loglog.lm$residuals~loglog.lm$fitted.values)
# plot(log(1-direction.df1.pv$pw_block_pv_adjusted) ~ log(direction.df1.pv$pv))

{
pdf("analysis pv-pw FFD.pdf", width=7, height=7)
par (mfcol= c(2,2))
for(B in c(1,3,2,4)){
ll <- (B-1)*IT + 1
ul <- B*IT
plot(direction.df1$pv[ll:ul],direction.df1$pw_block_pv_adjusted[ll:ul],
          pch=16, cex = 0.8, xlim = c(0.01,0.05), # ylim = c(0.001,0.05),
     main = bquote(atop(beta[1]==.(b.mat[B,2]))),
     xlab = "p-value at the switch", ylab = "posterior weight")
lm <- lm(pw_block_pv_adjusted ~ pv, data = direction.df1[ll:ul,])
# lm1 <- lm(log(1-pw_block_pv_adjusted) ~ log(pv) + block_pv, data = direction.df1[ll:ul,])
# abline(exp(coef(lm1)[c(1,2)]))
cf <- round(coef(lm), 4) 

# sign check to avoid having plus followed by minus for negative coefficients
 eq <- paste0("pw = ", cf[1],
              ifelse(sign(cf[2])==1, " + ", " - "), abs(cf[2]), " pv")

# printing of the equation
text(labels = eq, x=0.025,
     y= min(direction.df1$pw_block_pv_adjusted[ll:ul],na.rm = T),
     pos = 3, cex = 0.9)
abline(a=1,b=-0.5,col=grey(0.5))
}
dev.off()
}

{
  pdf("analysis pv-pw MVT.pdf", width=7, height=7)
  par (mfcol= c(2,2))
  for(B in c(1,3,2,4)){
    ll <- (B-1)*IT + 1
    ul <- B*IT
    plot(direction.df2$pv[ll:ul],direction.df2$pw_block_pv_adjusted[ll:ul],
         pch=16, cex = 0.8, xlim = c(0.01,0.05), # ylim = c(0.001,0.05),
         main = bquote(atop(beta[1]==.(b.mat[B,2]))),
         xlab = "p-value at the switch", ylab = "posterior weight")
    lm <- lm(pw_block_pv_adjusted ~ pv, data = direction.df2[ll:ul,])
    # lm1 <- lm(log(1-pw_block_pv_adjusted) ~ log(pv) + block_pv, data = direction.df1[ll:ul,])
    # abline(exp(coef(lm1)[c(1,2)]))
    cf <- round(coef(lm), 4) 
    
    # sign check to avoid having plus followed by minus for negative coefficients
    eq <- paste0("pw = ", cf[1],
                 ifelse(sign(cf[2])==1, " + ", " - "), abs(cf[2]), " pv")
    
    # printing of the equation
    text(labels = eq, x=0.025,
         y= min(direction.df2$pw_block_pv_adjusted[ll:ul],na.rm = T),
         pos = 3, cex = 0.9)
  
  abline(a=1,b=-0.5,col=grey(0.5))
}
  dev.off()
}

# {
#   pdf("analysis log log model.pdf", width=10, height=5)
#   par (mfcol= c(1,2))
#   plot(loglog.lm$residuals~loglog.lm$fitted.values, xlab = 'Fitted values', ylab = 'Residuals')
#   plot((1-direction.df1.pv$pw_block_pv_adjusted) ~ direction.df1.pv$pv, 
#        log = "xy", xlab = "p-value at the switch", ylab = "1 - posterior weight")
#   
#   dev.off()
# }
# 

