library(MASS)
library(Matrix) 
library(mvtnorm)
library(safeBinaryRegression)
# library(matrixStats)
library(Hmisc)

# Parameters
################

# choose K, F, b

K<-5
F<-1
correction.threshold<-0.1
Thompson.threshold<-0.05
pw.threshold <- 0.975
max.blocks<-150

n=10000
var<-5
cov_mtrx<-as.matrix(Diagonal(x=rep(var,K+1)))
mu<-c(qnorm(0.01),rep(0,K))
SPIKESLAB<-FALSE
CalcPv <- TRUE

cutoff<-0.1
max.w<-0.2
c.inc<-0.1
c.dec<-0.02
max.w.tail<-0.07
min.w.tail<-0.07
tail<-0.01*n
tail1<-0.05*n
resample.count<-50
max.tail.shift<-0.3
max.wobble<-0.15
max.wobble.pw<-0.90

IND.10.6<-cbind(seq(from=1,to=63,by=2),seq(from=2,to=64,by=2))
IND.9.5<-cbind(seq(from=1,to=31,by=2),seq(from=2,to=32,by=2))

#######################################################
# Iterations of FFD + Thompson
#######################################################

runs<-2^(K-F)
ca<-1
IT<-100
b.mat<-as.matrix(rbind(c(-2.2,0.3,0.2,0.1,0,0),
                       c(-2.2,0.3,0.2,0.1,0,0)))



# FFD + Thompson
#################
sum.p.FFD<-array(NA,dim=c(max.blocks,IT,ca))
prop.1.FFD<-array(NA,dim=c(IT,max.blocks,K,ca))
cum.prop.1.FFD<-array(NA,dim=c(IT,max.blocks,K,ca))
prop.Thompson.FFD<-array(NA,dim=c(IT,max.blocks,K,ca))
best.sum.p<-matrix(ncol=ca,nrow=max.blocks)
mean.sum.p.FFD<-matrix(nrow=max.blocks,ncol=ca)
sd.sum.p.FFD<-matrix(nrow=max.blocks,ncol=ca)
post.mean.FFD.ar<-array(NA,dim=c(IT,max.blocks+1,K+1,ca))
post.median.FFD.ar<-array(NA,dim=c(IT,max.blocks+1,K+1,ca))
post.sd.FFD.ar<-array(NA,dim=c(IT,max.blocks+1,K+1,ca))
p.post.mean.FFD.ar<-array(NA,dim=c(IT,max.blocks+1,2^K,ca))
p.post.mean2.FFD.ar<-array(NA,dim=c(IT,max.blocks+1,2^K,ca))
p.post.sd.FFD.ar<-array(NA,dim=c(IT,max.blocks+1,2^K,ca))
est.form.FFD<-array(NA,dim=c(IT,max.blocks+1,ca))
post.prob.FFD.ar<-array(NA,dim=c(IT,max.blocks+1,K+1,ca))
Thompson.first<-array(NA,dim=c(IT,K,ca))
Thompson.FFD.ar<-array(dim=c(IT,max.blocks,ca)) # only for b1
pv.FFD.ar<-array(dim=c(IT,max.blocks,K,ca))
n.suc.FFD<-matrix(ncol=ca,nrow=IT)

full.design0<-matrix(ncol=K+1,nrow=2^K) 
full.design0[,1]<-rep(1,2^K)
for(i in 1:K){
  xx<-c(rep(1,2^(K-i)),rep(-1,2^(K-i)))
  full.design0[,i+1]<-rep(xx,2^(i-1))
}
p.mat<-matrix(nrow=2^K,ncol=ca)
for(B in 1:ca){
  for(j in 1:(2^K)){
    p.mat[j,B]<-pnorm(full.design0[j,]%*%b.mat[B,])
  }
}

  b<-b.mat[1,]
  for(it in 1:IT){
    print(it)
    LIK.0<-FALSE
    RESAMPLE<-FALSE
    pv.mat<-rep(NA,K)
    correction.strong<-rep(FALSE,K)
    Thompson.strong<-matrix(FALSE,nrow=max.blocks,ncol=K)
    design<-c()
    play.variables<-c()
    y<-c()
    ind.strong<-c()
    start.Thompson<-c()
    RSTOP<-c(NA,NA,"NA")
    SEPARATION<-TRUE
    b.samples.temp<-matrix(nrow=n,ncol=max.blocks+1)
    post.mean.temp<-matrix(ncol=K+1,nrow=max.blocks+1)
    post.median.temp<-matrix(ncol=K+1,nrow=max.blocks+1)
    post.sd.temp<-matrix(ncol=K+1,nrow=max.blocks+1)
    p.post.mean.temp<-matrix(ncol=2^K,nrow=max.blocks+1)
    p.post.sd.temp<-matrix(ncol=2^K,nrow=max.blocks+1)
    est.form.temp<-rep(NA,max.blocks+1)
    post.prob.temp<-matrix(ncol=K+1,nrow=max.blocks+1)
    pv.temp<-matrix(ncol=K,nrow=max.blocks)
    spike.weight<-matrix(ncol=K,nrow=max.blocks+1)
    start.block<-1
    start.Thompson<-0
    l<-list(pv.mat=pv.mat,correction.strong=correction.strong,Thompson.strong=Thompson.strong,
            design=design,start.block=start.block,k=K,f=F,y=y,ind.strong=ind.strong,
            RSTOP=RSTOP,start.Thompson=start.Thompson,SEPARATION=SEPARATION,
            post.mean.temp=post.mean.temp,post.median.temp=post.median.temp,post.sd.temp=post.sd.temp,
            est.form.temp=est.form.temp,post.prob.temp=post.prob.temp,
            spike.weight=spike.weight,b.samples.temp=b.samples.temp,
            p.post.mean.temp=p.post.mean.temp,p.post.sd.temp=p.post.sd.temp,
            pv.temp=pv.temp)
    for(u in 1:max.blocks){
      if(length(l$ind.strong)==0){
        l<-FFD(l,start.block)
        (play.variables<-cbind(play.variables,l$RSTOP))
        (number.of.strong<-length(l$ind.strong))
        (l$k1<-K-number.of.strong)
        (l$f1<-F-number.of.strong)
        (start.block<-l$start.Thompson+1)
      }
      if(length(l$ind.strong)!=0){
        l<-FFD.T(l,start.block)
        (play.variables<-cbind(play.variables,l$RSTOP))
        (number.of.strong<-length(l$ind.strong))
        (l$k1<-K-number.of.strong)
        (l$f1<-F-number.of.strong)
        (start.block<-l$start.Thompson+1)
      }
      if(start.block!=max.blocks+1)u<-u+1
      if(start.block==max.blocks+1)break
    }
  for(bl in 1:max.blocks){
      block.ind<-c(((bl-1)*2*runs+1):(bl*2*runs))
      sum.p.FFD[bl,it,B]<-sum(pnorm(cbind(rep(1,dim(l$design[block.ind,])[1]),l$design[block.ind,])%*%b))
      if(bl==1)prop.Thompson.FFD[it,bl,,B]<-as.numeric(l$Thompson.strong[1,])
      if(bl>1)prop.Thompson.FFD[it,bl,,B]<-apply(l$Thompson.strong[1:bl,],2,mean)
      
      for(j in 1:K){
        prop.1.FFD[it,bl,j,B]<-prop1(l$design[block.ind,j])
        cum.prop.1.FFD[it,bl,j,B]<-prop1(l$design[1:(bl*2*runs),j])}
      
      # counts<-apply(full.design0[,-1],1,count.comb.suc,x=l$design[1:(bl*2*runs),],y=l$y[1:(bl*2*runs)])
      # for(comb in 1:(2^K)){
      #   n.arm[it,bl,comb,B]<-counts[[comb]]$n.comb
      #   s.arm[it,bl,comb,B]<-counts[[comb]]$n.suc
      #   }
  }
    for(bl in 1:(max.blocks+1)){
        for (comb in 1:(2^K)){
          p.post.mean2.FFD.ar[it,bl,comb,B]<-pnorm(full.design0[comb,]%*%l$post.mean.temp[bl,])
        }
      }
    post.mean.FFD.ar[it,,,B]<-l$post.mean.temp
    post.median.FFD.ar[it,,,B]<-l$post.median.temp
    post.sd.FFD.ar[it,,,B]<-l$post.sd.temp
    p.post.mean.FFD.ar[it,,,B]<-l$p.post.mean.temp
    p.post.sd.FFD.ar[it,,,B]<-l$p.post.sd.temp
    est.form.FFD[it,,B]<-l$est.form.temp
    pv.FFD.ar[it,,,B]<-l$pv.temp
    post.prob.FFD.ar[it,,,B]<-l$post.prob.temp
    Thompson.first[it,,B]<-compute.Thompson.first(l$Thompson.strong)
    Thompson.FFD.ar[it,,B]<-l$Thompson.strong[,1]
    n.suc.FFD[it,B]<-sum(l$y)
    
  } # end of loop iterations
  
  # Averaging over all iterations for one case
   
    full.design0<-matrix(ncol=K+1,nrow=2^K) 
    full.design0[,1]<-rep(1,2^K)
    for(i in 1:K){
      xx<-c(rep(1,2^(K-i)),rep(-1,2^(K-i)))
      full.design0[,i+1]<-rep(xx,2^(i-1))
    }
    p.mat[,B]<-pnorm(full.design0%*%b.mat[B,])
    best.sum.p[,B]<-rep(max(unique(p.mat[,B]))*2*runs,max.blocks)
    mean.sum.p.FFD[,B]<-apply(sum.p.FFD[,,B],1,mean)
    sd.sum.p.FFD[,B]<-apply(sum.p.FFD[,,B],1,sd)
    

# Only Thompson
#################
sum.p.T<-array(NA,dim=c(max.blocks,IT,ca))
prop.1.T<-array(NA,dim=c(IT,max.blocks,K,ca))
cum.prop.1.T<-array(NA,dim=c(IT,max.blocks,K,ca))
mean.sum.p.T<-matrix(ncol=ca,nrow=max.blocks)
sd.sum.p.T<-matrix(ncol=ca,nrow=max.blocks)
post.mean.T.ar<-array(NA,dim=c(IT,max.blocks+1,K+1,ca))
post.median.T.ar<-array(NA,dim=c(IT,max.blocks+1,K+1,ca))
post.sd.T.ar<-array(NA,dim=c(IT,max.blocks+1,K+1,ca))
p.post.mean.T.ar<-array(NA,dim=c(IT,max.blocks+1,2^K,ca))
p.post.mean2.T.ar<-array(NA,dim=c(IT,max.blocks+1,2^K,ca))
p.post.sd.T.ar<-array(NA,dim=c(IT,max.blocks+1,2^K,ca))
est.form.T<-array(NA,dim=c(IT,max.blocks+1,ca))
post.prob.T.ar<-array(NA,dim=c(IT,max.blocks+1,K+1,ca))
pv.T.ar<-array(dim=c(IT,max.blocks,K,ca))
n.suc.T<-matrix(ncol=ca,nrow=IT)


for(B in 1:ca){
  b<-b.mat[B,]
  for(it in 1:IT){
    print(it)
    LIK.0<-FALSE
    RESAMPLE<-FALSE
    SEPARATION<-TRUE

    l<-list(K=K,F=F)
    sim<-Only.Thompson(l)
    for(bl in 1:max.blocks){
      block.ind<-c(((bl-1)*2*runs+1):(bl*2*runs))
      sum.p.T[bl,it,B]<-sum(pnorm(sim$design0[block.ind,]%*%b))
      for(j in 1:K){
        prop.1.T[it,bl,j,B]<-prop1(sim$design0[block.ind,j+1])
        cum.prop.1.T[it,bl,j,B]<-prop1(sim$design0[1:(bl*2*runs),j+1])}
    }
    for(bl in 1:(max.blocks+1)){
      for (comb in 1:(2^K)){
        p.post.mean2.T.ar[it,bl,comb,B]<-pnorm(full.design0[comb,]%*%sim$post.mean.temp[bl,])
      }
    }
    
    post.mean.T.ar[it,,,B]<-sim$post.mean.temp
    post.median.T.ar[it,,,B]<-sim$post.median.temp
    post.sd.T.ar[it,,,B]<-sim$post.sd.temp
    p.post.mean.T.ar[it,,,B]<-sim$p.post.mean.temp
    p.post.sd.T.ar[it,,,B]<-sim$p.post.sd.temp
    est.form.T[it,,B]<-sim$est.form.temp
    pv.T.ar[it,,,B]<-sim$pv.temp
    post.prob.T.ar[it,,,B]<-sim$post.prob.temp
    n.suc.T[it,B]<-sum(sim$y)
    
  }
  # end of loop iterations
  # g<-glm(sim$y ~ sim$design[,-1],family=binomial(link="probit"))
  # print(cbind(b,sim$post.mean.temp[251,],coef(summary(g))[,1]))
  # 
  # Averaging over all iterations for one case
  
  mean.sum.p.T[,B]<-apply(sum.p.T[,,B],1,mean)
  sd.sum.p.T[,B]<-apply(sum.p.T[,,B],1,sd)
}  

#####
# MVT
#####
sum.p.RAN<-array(NA,dim=c(max.blocks,IT,ca))
prop.1.RAN<-array(NA,dim=c(IT,max.blocks,K,ca))
cum.prop.1.RAN<-array(NA,dim=c(IT,max.blocks,K,ca))
mean.sum.p.RAN<-matrix(ncol=ca,nrow=max.blocks)
sd.sum.p.RAN<-matrix(ncol=ca,nrow=max.blocks)
post.mean.RAN.ar<-array(NA,dim=c(IT,max.blocks+1,K+1,ca))
post.median.RAN.ar<-array(NA,dim=c(IT,max.blocks+1,K+1,ca))
post.sd.RAN.ar<-array(NA,dim=c(IT,max.blocks+1,K+1,ca))
p.post.mean.RAN.ar<-array(NA,dim=c(IT,max.blocks+1,2^K,ca))
p.post.mean2.RAN.ar<-array(NA,dim=c(IT,max.blocks+1,2^K,ca))
p.post.sd.RAN.ar<-array(NA,dim=c(IT,max.blocks+1,2^K,ca))
est.form.RAN<-array(NA,dim=c(IT,max.blocks+1,ca))
post.prob.RAN.ar<-array(NA,dim=c(IT,max.blocks+1,K+1,ca))
pv.RAN.ar<-array(dim=c(IT,max.blocks,K,ca))
n.suc.RAN<-matrix(ncol=ca,nrow=IT)

B <- 1
  b<-b.mat[B,]
  for(it in 1:IT){
    print(it)
    LIK.0<-FALSE
    RESAMPLE<-FALSE
    SEPARATION<-TRUE
    
    l<-list(K=K,F=F)
    sim<-RANDES(l)
    for(bl in 1:max.blocks){
      block.ind<-c(((bl-1)*2*runs+1):(bl*2*runs))
      sum.p.RAN[bl,it,B]<-sum(pnorm(sim$design0[block.ind,]%*%b))
      for(j in 1:K){
        prop.1.RAN[it,bl,j,B]<-prop1(sim$design0[block.ind,j+1])
        cum.prop.1.RAN[it,bl,j,B]<-prop1(sim$design0[1:(bl*2*runs),j+1])}
    }
    for(bl in 1:(max.blocks+1)){
      for (comb in 1:(2^K)){
        p.post.mean2.RAN.ar[it,bl,comb,B]<-pnorm(full.design0[comb,]%*%sim$post.mean.temp[bl,])
      }
    }
    
    post.mean.RAN.ar[it,,,B]<-sim$post.mean.temp
    post.median.RAN.ar[it,,,B]<-sim$post.median.temp
    post.sd.RAN.ar[it,,,B]<-sim$post.sd.temp
    p.post.mean.RAN.ar[it,,,B]<-sim$p.post.mean.temp
    p.post.sd.RAN.ar[it,,,B]<-sim$p.post.sd.temp
    est.form.RAN[it,,B]<-sim$est.form.temp
    pv.RAN.ar[it,,,B]<-sim$pv.temp
    post.prob.RAN.ar[it,,,B]<-sim$post.prob.temp
    n.suc.RAN[it,B]<-sum(sim$y)
    
  } # end of loop iterations
  
  # Averaging over all iterations for one case
  
  mean.sum.p.RAN[,B]<-apply(sum.p.RAN[,,B],1,mean)
  sd.sum.p.RAN[,B]<-apply(sum.p.RAN[,,B],1,sd)   # 0!! due to full balance
  
} # end of loop cases


  #############################################
  # Plots & Diagnostics
  #############################################
  
  # Time until identification of effect
  #####################################
B<-1
  
# Option a - median pv
  
median.pv.FFD <-matrix(NA,nrow = max.blocks,ncol = 4)
median.pv.AB <-matrix(NA,nrow = max.blocks,ncol = 4)
# median.pv.AB1 <-matrix(NA,nrow = max.blocks,ncol = 4)
median.pv.T <-matrix(NA,nrow = max.blocks,ncol = 4)
median.pv.MVT <-matrix(NA,nrow = max.blocks,ncol = 4)

for (j in 1:4){
  median.pv.FFD[,j] <- apply(pv.FFD.ar[,,j,B],2,median)
  median.pv.T[,j] <- apply(pv.T.ar[,,j,B],2,median)
  median.pv.MVT[,j] <- apply(pv.RAN.ar[,,j,B],2,median)
  median.pv.AB[,j] <- apply(ABtest.pv.ar[,,4-j+1],2,median)
  # median.pv.AB1[,j] <- apply(ABtest.pv.ar1[,,4-j+1],2,median)
}
{
pdf("plot2a - time (3 active).pdf", width=7, height=7)
  par(mfcol=c(2,2))
  breaksFFD<-c(min(which(median.pv.FFD[,1]<0.05)),min(which(median.pv.FFD[,2]<0.05)),min(which(median.pv.FFD[,3]<0.05)))
  breaksAB<-c(min(which(median.pv.AB[,1]<0.05)),min(which(median.pv.AB[,2]<0.05)),min(which(median.pv.AB[,3]<0.05)))
  breaksT<-c(min(which(median.pv.T[,1]<0.05)),min(which(median.pv.T[,2]<0.05)),min(which(median.pv.T[,3]<0.05)))
  breaksMVT<-c(min(which(median.pv.MVT[,1]<0.05)),min(which(median.pv.MVT[,2]<0.05)),min(which(median.pv.MVT[,3]<0.05)))
  
  plot(median.pv.FFD[,1] ~ seq(max.blocks),type="l",lty=1,lwd = 2,xaxt='n',
       xlim=c(0,max.blocks),xlab="Blocks",ylab="P-value",
       cex.axis=1,cex.lab=1,cex.main=1,log="y",main="FFD+TS")
  
  abline(h=0.05)
  abline(v=breaksFFD[1],col="grey",lwd = 1.5)
  abline(v=breaksFFD[2],col="grey",lwd = 1.5)
  abline(v=breaksFFD[3],col="grey",lwd = 1.5)
  
  lines(median.pv.FFD[,1] ~ seq(max.blocks),lty=1,lwd = 2)
  lines(median.pv.FFD[,2] ~ seq(max.blocks),lty=2,lwd = 2)
  lines(median.pv.FFD[,3] ~ seq(max.blocks),lty=3,lwd = 3)
  
  axis(1,at=sort(c(90,120,150,breaksFFD)),cex.axis=0.7)
  
  legend("topright", ncol=1,
         c(as.expression(bquote(atop(beta[1]==.(b.mat[B,2])))),
         as.expression(bquote(atop(beta[2]==.(b.mat[B,3])))),
         as.expression(bquote(atop(beta[3]==.(b.mat[B,4]))))),
         lty=c(1,2,3),lwd = c(1.5,1.5,2),cex=0.8)
  
  plot(median.pv.AB[,1] ~ seq(max.blocks),type="l",lty=1,lwd=2,xaxt='n',yaxt='n',
       xlim=c(0,max.blocks),xlab="Blocks",ylab="P-value",ylim=c(0.017,1),
       cex.axis=1,cex.lab=1,cex.main=1,log="y",main="OFAT")
  
  abline(h=0.05)
  abline(v=breaksAB[1],col="grey",lwd = 1.5)
  abline(v=breaksAB[2],col="grey",lwd = 1.5)
  abline(v=breaksAB[3],col="grey",lwd = 1.5)
  
  lines(median.pv.AB[,1] ~ seq(max.blocks),lty=1,lwd=2)
  lines(median.pv.AB[,2] ~ seq(max.blocks),lty=2,lwd=2)
  lines(median.pv.AB[,3] ~ seq(max.blocks),lty=3,lwd=3)
  
  axis(1,at=sort(c(60,90,150,breaksAB)),cex.axis=0.7)
  axis(2,at=c(0.02,0.05,0.1,0.2,0.5,1),cex.axis=0.8)
  
  
  legend("topright", ncol=1,
         c(as.expression(bquote(atop(beta[1]==.(b.mat[B,2])))),
           as.expression(bquote(atop(beta[2]==.(b.mat[B,3])))),
           as.expression(bquote(atop(beta[3]==.(b.mat[B,4]))))),
         lty=c(1,2,3),lwd = c(1.5,1.5,2),cex=0.8)
  
  plot(median.pv.MVT[,1] ~ seq(max.blocks),type="l",lty=1,lwd = 2,xaxt='n',
       xlim=c(0,max.blocks),xlab="Blocks",ylab="P-value",ylim=c(0.01,1),
       cex.axis=1,cex.lab=1,cex.main=1,log="y",main="MVT")
  
  abline(h=0.05)
  abline(v=breaksMVT[1],col="grey",lwd = 1.5)
  abline(v=breaksMVT[2],col="grey",lwd = 1.5)
  abline(v=breaksMVT[3],col="grey",lwd = 1.5)
  
  lines(median.pv.MVT[,1] ~ seq(max.blocks),lty=1,lwd = 2)
  lines(median.pv.MVT[,2] ~ seq(max.blocks),lty=2,lwd = 2)
  lines(median.pv.MVT[,3] ~ seq(max.blocks),lty=3,lwd = 3)
  
  axis(1,at=sort(c(80,120,150,breaksMVT)),cex.axis=0.7)
  
  legend("topright", ncol=1,
         c(as.expression(bquote(atop(beta[1]==.(b.mat[B,2])))),
           as.expression(bquote(atop(beta[2]==.(b.mat[B,3])))),
           as.expression(bquote(atop(beta[3]==.(b.mat[B,4]))))),
         lty=c(1,2,3),lwd = c(1.5,1.5,2),cex=0.8)
  
  plot(median.pv.T[,1] ~ seq(max.blocks),type="l",lty=1,lwd = 2,xaxt='n',
       xlim=c(0,max.blocks),xlab="Blocks",ylab="P-value",ylim=c(0.01,1),
       cex.axis=1,cex.lab=1,cex.main=1,log="y",main="TS")
  
  abline(h=0.05)
  abline(v=breaksT[1],col="grey",lwd = 1.5)
  abline(v=breaksT[2],col="grey",lwd = 1.5)
  abline(v=breaksT[3],col="grey",lwd = 1.5)
  
  lines(median.pv.T[,1] ~ seq(max.blocks),lty=1,lwd = 2)
  lines(median.pv.T[,2] ~ seq(max.blocks),lty=2,lwd = 2)
  lines(median.pv.T[,3] ~ seq(max.blocks),lty=3,lwd = 3)
  
  axis(1,at=sort(c(90,120,150,breaksT)),cex.axis=0.7)
  
  legend("topright", ncol=1,
         c(as.expression(bquote(atop(beta[1]==.(b.mat[B,2])))),
           as.expression(bquote(atop(beta[2]==.(b.mat[B,3])))),
           as.expression(bquote(atop(beta[3]==.(b.mat[B,4]))))),
         lty=c(1,2,3),lwd = c(1.5,1.5,2),cex=0.8)
  dev.off()
}

{
  pdf("plot2a1 - time (3 active) - comparison to larger beta_0.pdf", width=10, height=5)
  par(mfcol=c(1,3))
  breaksFFD<-c(min(which(median.pv.FFD[,1]<0.05)),min(which(median.pv.FFD[,2]<0.05)),min(which(median.pv.FFD[,3]<0.05)))
  breaksAB<-c(min(which(median.pv.AB[,1]<0.05)),min(which(median.pv.AB[,2]<0.05)),min(which(median.pv.AB[,3]<0.05)))
  breaksAB1<-c(min(which(median.pv.AB1[,1]<0.05)),min(which(median.pv.AB1[,2]<0.05)),min(which(median.pv.AB1[,3]<0.05)))
  
  plot(median.pv.FFD[,1] ~ seq(max.blocks),type="l",lty=1,lwd = 2,xaxt='n',
       xlim=c(0,max.blocks),xlab="Blocks",ylab="P-value",
       cex.axis=0.8,cex.lab=0.9,cex.main=0.9,log="y",main="FFD+TS")
  
  abline(h=0.05)
  abline(v=breaksFFD[1],col="grey",lwd = 1.5)
  abline(v=breaksFFD[2],col="grey",lwd = 1.5)
  abline(v=breaksFFD[3],col="grey",lwd = 1.5)
  
  lines(median.pv.FFD[,1] ~ seq(max.blocks),lty=1,lwd = 2)
  lines(median.pv.FFD[,2] ~ seq(max.blocks),lty=2,lwd = 2)
  lines(median.pv.FFD[,3] ~ seq(max.blocks),lty=3,lwd = 3)
  
  axis(1,at=sort(c(90,120,150,breaksFFD)),cex.axis=0.7)
  
  legend("topright", ncol=1,
         c("0.3","0.2","0.1"),
         lty=c(1,2,3),lwd = c(1.5,1.5,2),cex=0.85)
  
  plot(median.pv.AB[,1] ~ seq(max.blocks),type="l",lty=1,lwd=2,xaxt='n',yaxt='n',
       xlim=c(0,max.blocks),xlab="Blocks",ylab="P-value",ylim=c(0.017,1),
       cex.axis=0.9,cex.lab=0.9,cex.main=0.9,log="y",main="OFAT")
  
  abline(h=0.05)
  abline(v=breaksAB[1],col="grey",lwd = 1.5)
  abline(v=breaksAB[2],col="grey",lwd = 1.5)
  abline(v=breaksAB[3],col="grey",lwd = 1.5)
  
  lines(median.pv.AB[,1] ~ seq(max.blocks),lty=1,lwd=2)
  lines(median.pv.AB[,2] ~ seq(max.blocks),lty=2,lwd=2)
  lines(median.pv.AB[,3] ~ seq(max.blocks),lty=3,lwd=3)
  
  axis(1,at=sort(c(60,90,150,breaksAB)),cex.axis=0.7)
  axis(2,at=c(0.02,0.05,0.1,0.2,0.5,1),cex.axis=0.8)
  
  
  legend("topright", ncol=1,
         c("0.3","0.2","0.1"),
         lty=c(1,2,3),lwd = c(1.5,1.5,2),cex=0.85)
  
  plot(median.pv.AB1[,1] ~ seq(max.blocks),type="l",lty=1,lwd=2,xaxt='n',yaxt='n',
       xlim=c(0,max.blocks),xlab="Blocks",ylab="P-value",ylim=c(0.01,1),
       cex.axis=0.9,cex.lab=0.9,cex.main=0.9,log="y",main="OFAT - larger beta_0")
  
  abline(h=0.05)
  abline(v=breaksAB1[1],col="grey",lwd = 1.5)
  abline(v=breaksAB1[2],col="grey",lwd = 1.5)
  abline(v=breaksAB1[3],col="grey",lwd = 1.5)
  
  lines(median.pv.AB1[,1] ~ seq(max.blocks),lty=1,lwd=2)
  lines(median.pv.AB1[,2] ~ seq(max.blocks),lty=2,lwd=2)
  lines(median.pv.AB1[,3] ~ seq(max.blocks),lty=3,lwd=3)
  
  axis(1,at=sort(c(60,90,150,breaksAB1)),cex.axis=0.7)
  axis(2,at=c(0.02,0.05,0.1,0.2,0.5,1),cex.axis=0.8)
  
  
  legend("topright", ncol=1,
         c("0.3","0.2","0.1"),
         lty=c(1,2,3),lwd = c(1.5,1.5,2),cex=0.85)
  
  dev.off()
}


# Option c
B<-1
times.FFD <- matrix(NA,ncol=3,nrow=IT)
times.AB <- matrix(NA,ncol=3,nrow=IT)

pdf("plot2c - time (3 active).pdf", width=10, height=5)
par(mfcol=c(1,3))
for(j in 1:3){
  times.FFD[,j] <- compute.Thompson.first(t(pv.FFD.ar[,,j,1]<0.05))
  times.AB[,j] <- compute.Thompson.first(t(ABtest.pv.ar[,,4-j+1]<0.05))
  
  times.FFD[,j][times.FFD[,j]==-1] <- NA
  times.AB[,j][times.AB[,j]==-1] <- NA
  
  # sum(is.na(times.FFD[,j]))
  # sum(is.na(times.AB[,j]))
  
  boxplot(times.FFD[,B],times.AB[,B],
          names = c("FFD+TS","OFAT"),
          ylab = "Time until P-value < 0.05",
          main = paste("Effect size = ",b.mat[1,j+1]),
          cex.main=0.8,cex.lab=0.8,cex.axis=0.8)
}
dev.off()

# False identification summaries
################################
count4 <- 0
count5 <- 0
rec4 <- c()
rec5 <- c()
track4 <- c()
track5 <- c()
for(it in 1:IT){
  if(any(pv.FFD.ar[it,,4,1] < 0.05)) {
    track4 <- c(track4 , it)
    count4 <- count4 + 1
    rec4 <- c(rec4,pv.FFD.ar[it,150,4,1] >= 0.05)
  }
  if(any(pv.FFD.ar[it,,5,1] < 0.05)) {
    track5 <- c(track5 , it)
    count5 <- count5 + 1
    rec5 <- c(rec5,pv.FFD.ar[it,150,5,1] >= 0.05)
    
  }
}
count4/IT # percent of false identifications
count5/IT # percent of false identifications

length(union(track4,track5))

sum(!rec4)/length(rec4) # percent of "recovered" experiments
sum(!rec5)/length(rec5)


interind <- intersect(track4,track5)
recinter <- cbind(rec4[track4 %in% interind],rec5[track5 %in% interind])
cbind(interind,recinter,apply(recinter,1,sum))
sum(apply(recinter,1,sum)>1)
ind4 <- which(!(track4 %in% interind))
ind5 <- which(!(track5 %in% interind))
cbind(track4[ind4],rec4[ind4])
sum(rec4[ind4])
cbind(track5[ind5],rec5[ind5])
sum(rec5[ind5])
(2+13+7)/47

# How long it took for false identification
tfi4 <- rep(NA,IT)
tfi5 <- rep(NA,IT)
for(it in track4){
  tfi4[it] <- min(which(pv.FFD.ar[it,,4,1] < 0.05))
}
for(it in track5){
  tfi5[it] <- min(which(pv.FFD.ar[it,,5,1] < 0.05))
}
mean(c(tfi4,tfi5),na.rm = T)
sd(c(tfi4,tfi5),na.rm = T)
median(c(tfi4,tfi5),na.rm = T)
plot(c(tfi4,tfi5)~seq(200))
x <- c(tfi4,tfi5)
x <- x[!is.na(x)]
plot(density(x))

times.FFD4 <- matrix(NA,ncol=ca,nrow=IT)
times.T4 <- matrix(NA,ncol=ca,nrow=IT)
# times.AB <- matrix(NA,ncol=ca,nrow=IT) # AB doesn't have inert factors
times.MVT4<- matrix(NA,ncol=ca,nrow=IT)
times.FFD5 <- matrix(NA,ncol=ca,nrow=IT)
times.T5 <- matrix(NA,ncol=ca,nrow=IT)
times.MVT5<- matrix(NA,ncol=ca,nrow=IT)

B <- 1
times.FFD4[,B] <- compute.Thompson.first(t(pv.FFD.ar[,,4,B]<0.05))
times.T4[,B] <- compute.Thompson.first(t(pv.T.ar[,,4,B]<0.05))
times.MVT4[,B] <- compute.Thompson.first(t(pv.RAN.ar[,,4,B]<0.05))
times.FFD5[,B] <- compute.Thompson.first(t(pv.FFD.ar[,,5,B]<0.05))
times.T5[,B] <- compute.Thompson.first(t(pv.T.ar[,,5,B]<0.05))
times.MVT5[,B] <- compute.Thompson.first(t(pv.RAN.ar[,,5,B]<0.05))

times.FFD4[,B][times.FFD4[,B]==-1] <- 150
times.T4[,B][times.T4[,B]==-1] <- 150
times.MVT4[,B][times.MVT4[,B]==-1] <- 150
times.FFD5[,B][times.FFD5[,B]==-1] <- 150
times.T5[,B][times.T5[,B]==-1] <- 150
times.MVT5[,B][times.MVT5[,B]==-1] <- 150

  pal <- c("black","ivory3","white")
  pdf("Time to false identification setting (b).pdf", width=10, height=5)
  par(mfcol=c(1,2))
    FFDpts4 <- qqnorm(times.FFD4[,B], plot.it=FALSE)
    Tpts4 <- qqnorm(times.T4[,B], plot.it=FALSE)
    MVTpts4 <- qqnorm(times.MVT4[,B], plot.it=FALSE)
    
    ind1 <- which(times.T4[,B]!=150)
    ind2 <- which(times.FFD4[,B]!=150)
    ind3 <- which(times.MVT4[,B]!=150)

    plot(Tpts4$y[ind1] ~ Tpts4$x[ind1],log="y",
         xlim=c(-2.8,2.8),ylim=c(1,150),
         col="black",pch=21,bg=pal[1],cex=0.9,
         main = paste("Inert factor x4, setting (b)") ,
         cex.main=1,cex.lab=0.9,cex.axis=0.9,
         ylab = "Time to false identification",
         xlab = "Normal quantiles")
    points(FFDpts4$y[ind2] ~ FFDpts4$x[ind2],col="black",pch=21,bg=pal[2],cex=0.9)
    points(MVTpts4$y[ind3] ~ MVTpts4$x[ind3],col="black",pch=21,bg=pal[3],cex=0.9)

    legend("bottomright",c("TS","FFD+TS","MVT"),cex=0.9,
           col=c("black","black","black","black"),pch=c(21,21,21,21),pt.bg=pal)
 
    FFDpts5 <- qqnorm(times.FFD5[,B], plot.it=FALSE)
    Tpts5 <- qqnorm(times.T5[,B], plot.it=FALSE)
    MVTpts5 <- qqnorm(times.MVT5[,B], plot.it=FALSE)
    
    ind1 <- which(times.T5[,B]!=150)
    ind2 <- which(times.FFD5[,B]!=150)
    ind3 <- which(times.MVT5[,B]!=150)
    
    plot(Tpts5$y[ind1] ~ Tpts5$x[ind1],log="y",
         xlim=c(-2.8,2.8),ylim=c(1,150),
         col="black",pch=21,bg=pal[1],cex=0.9,
         main = paste("Inert factor x5, setting (b)"),
         cex.main=1,cex.lab=0.9,cex.axis=0.9,
         ylab = "Time to false identification",
         xlab = "Normal quantiles")
    points(FFDpts5$y[ind2] ~ FFDpts5$x[ind2],col="black",pch=21,bg=pal[2],cex=0.9)
    points(MVTpts5$y[ind3] ~ MVTpts5$x[ind3],col="black",pch=21,bg=pal[3],cex=0.9)
    
    legend("bottomright",c("TS","FFD+TS","MVT"),cex=0.9,
           col=c("black","black","black"),pch=c(21,21,21),pt.bg=pal)
    
  
  dev.off()


##########################################

# Cumulative regret (OFAT is not comparable)
R.FFD <- array(NA,dim=c(max.blocks,IT,ca))
R.T <- array(NA,dim=c(max.blocks,IT,ca))
R.AB <- array(NA,dim=c(max.blocks,IT,ca))
R.MVT <- array(NA,dim=c(max.blocks,IT,ca))

mean.R.FFD <- matrix(NA,ncol=ca,nrow=max.blocks)
mean.R.T <- matrix(NA,ncol=ca,nrow=max.blocks)
mean.R.AB <- matrix(NA,ncol=ca,nrow=max.blocks)
mean.R.MVT <- matrix(NA,ncol=ca,nrow=max.blocks)

cum.R.FFD <- matrix(NA,ncol=ca,nrow=max.blocks)
cum.R.T <- matrix(NA,ncol=ca,nrow=max.blocks)
cum.R.AB <- matrix(NA,ncol=ca,nrow=max.blocks)
cum.R.MVT <- matrix(NA,ncol=ca,nrow=max.blocks)


for (B in 1:ca){
  for(it in 1:IT){
    R.FFD[,it,B] <- best.sum.p[,B] - sum.p.FFD[,it,B]
    R.T[,it,B] <- best.sum.p[,B] - sum.p.T[,it,B]
    R.AB[,it,B] <- best.sum.p[,B] - sum.p.AB[it,,B]
    R.MVT[,it,B] <- best.sum.p[,B] - sum.p.RAN[,it,B]
    
  }
  mean.R.FFD[,B] <- apply(R.FFD[,,B],1,mean)
  mean.R.T[,B] <- apply(R.T[,,B],1,mean)
  mean.R.AB[,B] <- apply(R.AB[,,B],1,mean)
  mean.R.MVT[,B] <- apply(R.MVT[,,B],1,mean)
  cum.R.FFD[,B] <- cumsum(mean.R.FFD[,B])
  cum.R.T[,B] <- cumsum(mean.R.T[,B])
  cum.R.AB[,B] <- cumsum(mean.R.AB[,B])
  cum.R.MVT[,B] <- cumsum(mean.R.MVT[,B])
  
}
{
  pdf("plot1b - cumulative Regret comparison (3 active).pdf", width=5, height=5)
  B <-1
    maxy<-max(cum.R.FFD[max.blocks,B],cum.R.T[max.blocks,B],cum.R.AB[max.blocks,B])
    plot(cum.R.FFD[,B]~seq(max.blocks),type="l",lty=1,lwd=2,
         ylim=c(0,maxy),xlab="Blocks",ylab="Cumulative expected regret",
         main="3 active effects",
         cex.axis=1,cex.lab=1,cex.main=1)
    lines(cum.R.MVT[,B]~seq(max.blocks),lty=1,lwd=2,col="grey")
    lines(cum.R.T[,B]~seq(max.blocks),lty=2,lwd=2)
    # lines(cum.R.AB[,B]~seq(max.blocks),lty=3,lwd=2.5)
    
    legend("topleft", ncol=1,c("FFD + TS","TS","MVT"),
           lty=c(1,2,1),cex=0.8,lwd=c(1.5,1.5,1.5),col=c(rep("black",2),"grey"))
  
  dev.off()
}
